//****************************************************************************
//
//
//    The Minus4 project - Copyright (c) Mike Dailly 1996,97,98,99,2000
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//	Minus4 Written by:
// ------------------
//
// MD - Mike Dailly, Main framework and basic emulator.
//
// 
//
//****************************************************************************
#include <md.h>								// DMA headers
#include <windows.h>

#include	<cvideo.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <direct.h>
#include "dos.h"
#include <conio.h>
#include "debug.h"

//#include "headers\md.h"
//#include "headers\all.h"
//#include "headers\disasm.h"
#include "headers\machine.h"
#include "headers\myprocess.h"
#include "headers\6502.h"
#include "headers\6502.h"
#include "debug.h"
#include "headers\csound.h"


	char	sName[]="Minus4Event";
    WAVEFORMATEX	wfx;


//****************************************************************************
// Enumerate sound devices.
//****************************************************************************
/*BOOL CALLBACK DSEnumProc(LPGUID lpGUID, 
                         LPCTSTR lpszDesc,
                         LPCTSTR lpszDrvName, 
                         LPVOID lpContext )
{
    HWND   hCombo = *(HWND *)lpContext;
    LPGUID lpTemp = NULL;
 
    if ( lpGUID != NULL )
    {
        if (( lpTemp = malloc( sizeof(GUID))) == NULL )
        return( TRUE );
 
        memcpy( lpTemp, lpGUID, sizeof(GUID));
    }
 
    ComboBox_AddString( hCombo, lpszDesc );
    ComboBox_SetItemData( hCombo,
                ComboBox_FindString( hCombo, 0, lpszDesc ),
                lpTemp );
    return( TRUE );
}*/
 

//****************************************************************************
//
// Create and Init Direct Sound system
//
//****************************************************************************
CSound::CSound( HWND hwnd )
{
    DSCAPS			dscaps;
    WAVEFORMATEX	wfx;


	HRESULT res = DirectSoundCreate( NULL, &lpds,    NULL );
    ZeroMemory( &dscaps, sizeof(dscaps));
    dscaps.dwSize = sizeof(dscaps);

    res = lpds->GetCaps( &dscaps );
	if(res!=DS_OK) 
	{
		return;
	}

    res = lpds->SetCooperativeLevel( hwnd, DSSCL_PRIORITY  );		//DSSCL_WRITEPRIMARY );
    if( res != DS_OK )
	{
		switch( res )
		{
			case	DSERR_ALLOCATED    : res = 0; break;
			case	DSERR_INVALIDPARAM    :res = 1; break;
			case	DSERR_UNINITIALIZED  :res = 2; break;
			case	DSERR_UNSUPPORTED  :res = 3; break;
		}

		return;
	}
	
    // Obtain primary buffer
    ZeroMemory(&dsbdesc, sizeof(DSBUFFERDESC));
    dsbdesc.dwSize = sizeof(DSBUFFERDESC);
    dsbdesc.dwFlags = DSBCAPS_PRIMARYBUFFER;
    if FAILED(lpds->CreateSoundBuffer(&dsbdesc, &lpdsbPrimary, NULL))
        return;	// FALSE;
 

    // Set primary buffer format
    memset(&wfx, 0, sizeof(WAVEFORMATEX)); 
    wfx.wFormatTag = WAVE_FORMAT_PCM; 
    wfx.nChannels = 1;							// NO stereo
    wfx.nSamplesPerSec = 31200;					// This is 312 Scan lines *2 ticks per line * 50 Frames per second.
    wfx.wBitsPerSample = 16;			
    wfx.nBlockAlign = (wfx.wBitsPerSample * wfx.nChannels) / 8 ;
    wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign;
    res = lpdsbPrimary->SetFormat(&wfx); 
 
	switch( res )
	{
		case	DSERR_BADFORMAT			: res=1; break;
		case	DSERR_INVALIDCALL		: res=2; break;
		case	DSERR_INVALIDPARAM		: res=3; break;
		case	DSERR_OUTOFMEMORY		: res=4; break;
		case	DSERR_PRIOLEVELNEEDED	: res=5; break;
		case	DSERR_UNSUPPORTED		: res=6; break;
	}

}

//****************************************************************************
// Kill sound system.
//****************************************************************************
CSound::~CSound( void )
{
    if (lpdsNotify) lpdsNotify->Release();
    if (lpds) lpds->Release(); 
}

//****************************************************************************
//
// Create an 8bitMONO Secondary sound buffer
//
//****************************************************************************
LPDIRECTSOUNDBUFFER	CSound::CreateSecondaryBuffer( void )
{
	HRESULT						res;
	LPDIRECTSOUNDBUFFER         lpdsb;
 	uint16						*m_pBuffer1;
	uint32						m_BufferSize1;
	uint16						*m_pBuffer2;
	uint32						m_BufferSize2;
	DSBUFFERDESC				Struct;

    // Set primary buffer format
    memset(&wfx, 0, sizeof(WAVEFORMATEX)); 
    wfx.wFormatTag = WAVE_FORMAT_PCM;
    wfx.nChannels = 1;							// MONO
    wfx.nSamplesPerSec = 31200;					// This is 312 Scan lines *2 ticks per line * 50 Frames per second.
    wfx.wBitsPerSample = 16;
    wfx.nBlockAlign = (wfx.wBitsPerSample * wfx.nChannels) / 8 ;
    wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign;
	wfx.cbSize = 0;

//    res = lpdsbPrimary->SetFormat(&wfx); 
    memset(&dsbdesc, 0, sizeof(DSBUFFERDESC)); 
    dsbdesc.dwSize = sizeof(DSBUFFERDESC); 
    dsbdesc.dwFlags = DSBCAPS_GETCURRENTPOSITION2		// Always a good idea
					| DSBCAPS_GLOBALFOCUS				// Allows background playing
					| DSBCAPS_CTRLPOSITIONNOTIFY;		// Needed for notification
 

    // The size of the buffer is arbitrary, but should be at least
    // two seconds, to keep data writes well ahead of the play
    // position.
 
    dsbdesc.dwBufferBytes = BUFFERSIZE*BUFFERS;		//31200;			//BUFFERSIZE*BUFFERS;
    dsbdesc.lpwfxFormat = &wfx; 
 
    res = lpds->CreateSoundBuffer( &dsbdesc, &lpdsb, NULL);
    if(res != DS_OK) 
	{
        return NULL; 
    }


	res = lpdsb->Lock(	0,	BUFFERSIZE*BUFFERS, (void**) &m_pBuffer1, (DWORD*) &m_BufferSize1, (void**)&m_pBuffer2, (DWORD*) &m_BufferSize2, DSBLOCK_ENTIREBUFFER );
	//memset(m_pBuffer1,0,BUFFERSIZE*BUFFERS);
	for(int i=0;i<(m_BufferSize1/2);i++){
		m_pBuffer1[i]=0x8000;
	}
	res = lpdsb->Unlock( (void*) m_pBuffer1, m_BufferSize1, (void*) m_pBuffer2, (DWORD) m_BufferSize2 );


/*	Struct.dwSize		 = sizeof(DSBUFFERDESC);
	Struct.dwBufferBytes = BUFFERSIZE*BUFFERS;
	Struct.dwFlags		 =  DSBCAPS_GETCURRENTPOSITION2		// Always a good idea
							| DSBCAPS_GLOBALFOCUS				// Allows background playing
							| DSBCAPS_CTRLPOSITIONNOTIFY;
	Struct.lpwfxFormat	 = NULL;
	lpdsb->Initialize(lpds,&Struct);*/
    return lpdsb;
} 
 
//****************************************************************************
// Kill sound system.
//****************************************************************************
BOOL CSound::Play( LPDIRECTSOUNDBUFFER pSoundBuffer )
{
	HRESULT	res;
	LPDIRECTSOUNDBUFFER         lpdsb;
 	uint16						*m_pBuffer1;
	uint32						m_BufferSize1;
	uint16						*m_pBuffer2;
	uint32						m_BufferSize2;

	res = pSoundBuffer->Lock(	0,	BUFFERSIZE*BUFFERS, (void**) &m_pBuffer1, (DWORD*) &m_BufferSize1, (void**)&m_pBuffer2, (DWORD*) &m_BufferSize2, DSBLOCK_ENTIREBUFFER );
	for(int i=0;i<(m_BufferSize1/2);i++){
		m_pBuffer1[i]=0x8000;
	}
	res = pSoundBuffer->Unlock( (void*) m_pBuffer1, m_BufferSize1, (void*) m_pBuffer2, (DWORD) m_BufferSize2 );


	pSoundBuffer->SetVolume(DSBVOLUME_MIN);		// make quiet first
    res = pSoundBuffer->Play( 0, 0, DSBPLAY_LOOPING);
//	pSoundBuffer->SetVolume(DSBVOLUME_MAX);		// make quiet first
	return TRUE;
}


//****************************************************************************
// Kill sound system.
//****************************************************************************
BOOL CSound::Stop( LPDIRECTSOUNDBUFFER pSoundBuffer )
{
	HRESULT	res;

	pSoundBuffer->SetVolume(DSBVOLUME_MIN);		// make quiet first
    res = pSoundBuffer->Stop();
	return TRUE;
}




//****************************************************************************
// Lock: Lock sound buffer
//****************************************************************************
BOOL CSoundBuffer::Lock( uint32 index,  uint32 size)
{
	HRESULT	res;
	
	m_LockedSize = size;
	m_Index = index;
	res = m_pDSBuffer->Lock(	index,	size, (void**) &m_pBuffer1, (DWORD*) &m_BufferSize1, (void**)&m_pBuffer2, (DWORD*) &m_BufferSize2, 0);		//DSBLOCK_ENTIREBUFFER );
//	res = m_pDSBuffer->Lock(	index,	size, (void**) &m_pBuffer1, (DWORD*) &m_BufferSize1, (void**)&m_pBuffer2, (DWORD*) &m_BufferSize2, DSBLOCK_ENTIREBUFFER );
	return TRUE;
}

//****************************************************************************
// Kill sound system.
//****************************************************************************
BOOL CSoundBuffer::Unlock( void )
{
	HRESULT	res;

	m_LockedSize = 0;
	m_Index = 0;
	res = m_pDSBuffer->Unlock( (void*) m_pBuffer1, m_BufferSize1, (void*) m_pBuffer2, (DWORD) m_BufferSize2 );
	return TRUE;
}
 


//****************************************************************************
// Free the object
//****************************************************************************
void CSoundBuffer::Release( void )
{
	m_pDSBuffer->Release();
}
