//****************************************************************************
//
//
//    The Minus4 project - Copyright (c) Mike Dailly 1996,97,98,99,2000
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//	Minus4 Written by:
// ------------------
//
// MD - Mike Dailly, Main framework and basic emulator.
//
// 
//
//****************************************************************************
#include <md.h>								// DMA headers
#include <windows.h>

#define DIRECTINPUT_VERSION 0x0700			//[ 0x0300 | 0x0500 | 0x0700 ]

#include <dinput.h>
//#include <stdio.h>
//#include <stdlib.h>
//#include <io.h>
//#include <direct.h>
//#include "dos.h"
//#include <conio.h>
//#include "debug.h"

#include "headers\wintest.h"
#include "headers\machine.h"
#include "headers\myprocess.h"
#include "headers\6502.h"
#include "headers\6502.h"
#include "debug.h"
#include "headers\CDirectInput.h"

	DIPROPRANGE				diprg; 
	LPDIRECTINPUTDEVICE		pdev; 
	LPDIRECTINPUTDEVICE2	ppdev2;
	//IDirectInputDevice2		*pdev;
	int						active;

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
BOOL FAR PASCAL InitJoystickInput(LPCDIDEVICEINSTANCE pdinst, LPVOID pvRef) 
{ 
	HRESULT				hres; 
	LPDIRECTINPUT		pdi = (LPDIRECTINPUT) pvRef; 
 
   // create the DirectInput joystick device 
	if (pdi->CreateDevice( pdinst->guidInstance, &pdev, NULL ) != DI_OK) 
	{ 
		OutputDebugString("IDirectInput::CreateDevice FAILED\n"); 
		return DIENUM_CONTINUE; 
	} 


    hres = pdev->QueryInterface( IID_IDirectInputDevice2, (void **) &ppdev2); 
	IDirectInputDevice_Release( pdev ); 

	if( ppdev2->SetDataFormat( &c_dfDIJoystick) != DI_OK ) 
	{ 
		OutputDebugString("IDirectInputDevice::SetDataFormat FAILED\n"); 
		ppdev2->Release(); 
		return DIENUM_CONTINUE; 
	} 

	if( ppdev2->SetCooperativeLevel( MainWindow, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND) != DI_OK) 
	{ 
		OutputDebugString("IDirectInputDevice::SetCooperativeLevel FAILED\n"); 
		ppdev2->Release(); 
		return DIENUM_CONTINUE; 
	} 

	active = 1;
	return DIENUM_STOP;			// found one!
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
BOOL CDirectInput::ReacquireInput(void) 
{ 
    HRESULT hRes; 
 
	if( active == 0 ) return FALSE; 

    // if we have a current device 
    if( ppdev2 ) 
    { 
        // acquire the device 
        hRes = ppdev2->Acquire( ); 
        // The call above is a macro that expands to: 
        // g_pdevCurrent->lpVtbl->Acquire(g_pdevCurrent); 
 
        if (SUCCEEDED(hRes)) 
        { 
            // acquisition successful 
            return TRUE; 
        } 
        else 
        { 
            // acquisition failed 
            return FALSE; 
        } 
    } 
    else 
    { 
        // we don't have a current device 
        return FALSE; 
    } 
} 


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
BOOL
CDirectInput::InitJoystick( void )
{
	if( active == 0 ) return FALSE; 

	diprg.diph.dwSize       = sizeof(diprg); 
	diprg.diph.dwHeaderSize = sizeof(diprg.diph); 
	diprg.diph.dwObj        = DIJOFS_X; 
	diprg.diph.dwHow        = DIPH_BYOFFSET; 
	diprg.lMin              = -1000; 
	diprg.lMax              = +1000; 
 
   if FAILED( ppdev2->SetProperty( DIPROP_RANGE, &diprg.diph) ) 
   { 
      OutputDebugString("IDirectInputDevice::SetProperty(DIPH_RANGE) FAILED\n"); 
      ppdev2->Release(); 
      return FALSE; 
   } 


   diprg.diph.dwSize       = sizeof(diprg); 
   diprg.diph.dwHeaderSize = sizeof(diprg.diph); 
   diprg.diph.dwObj        = DIJOFS_Y; 
   diprg.diph.dwHow        = DIPH_BYOFFSET; 
   diprg.lMin              = -1000; 
   diprg.lMax              = +1000; 
 
   if FAILED( ppdev2->SetProperty( DIPROP_RANGE, &diprg.diph) ) 
   { 
      OutputDebugString("IDirectInputDevice::SetProperty(DIPH_RANGE) FAILED\n"); 
      ppdev2->Release(); 
      return FALSE; 
   } 

	ReacquireInput();

   return TRUE;
}
 
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
DWORD CDirectInput::ReadJoystickInput(void) 
{ 
    DWORD                   dwKeyState; 
    HRESULT                 hRes; 
    DIJOYSTATE              js; 
 
	if( active == 0 ) return 0; 

    // poll the joystick to read the current state
    hRes = ppdev2->Poll();
	if( hRes == DIERR_NOTACQUIRED ){			// when we swap programs we lose input here...
            ReacquireInput(); 
		    hRes = ppdev2->Poll();				// get it again...
	}
    // get data from the joystick 
    hRes = ppdev2->GetDeviceState( sizeof(DIJOYSTATE), &js); 
 
    if (hRes != DI_OK) 
    { 
        // did the read fail because we lost input for some reason? 
        // if so, then attempt to reacquire. If the second acquire 
        // fails, then the error from GetDeviceData will be 
        // DIERR_NOTACQUIRED, so we won't get stuck an infinite loop. 
        if(hRes == DIERR_INPUTLOST){ 
            ReacquireInput(); 
		}
        // return the fact that we did not read any data 
        return 0x80000000; 
    } 
 
    // Now study the position of the stick and the buttons. 
    dwKeyState = 0; 
    if (js.lX < -100) { 
        dwKeyState |= JOY_LEFT; 
    } else if (js.lX > 100) { 
        dwKeyState |= JOY_RIGHT; 
    } 
 
    if (js.lY < -100) { 
        dwKeyState |= JOY_UP; 
    } else if (js.lY > 100) { 
          dwKeyState |= JOY_DOWN; 
   } 
 
    if (js.rgbButtons[0] & 0x80) { 
        dwKeyState |= JOY_FIRE; 
    } 
 
/*    if (js.rgbButtons[1] & 0x80) { 
        dwKeyState |= KEY_SHIELD; 
    } 
 
    if (js.rgbButtons[2] & 0x80) { 
        dwKeyState |= KEY_STOP; 
    } 
 */
    return dwKeyState; 
} 
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
CDirectInput::CDirectInput()
{
	DWORD	joy;
	DirectInputCreate(Program, DIRECTINPUT_VERSION, &m_pDInput , NULL );
	if( m_pDInput == NULL ) return;

	//  LPDIRECTINPUT  pdi;  // previously initialized
 
	m_pDInput->EnumDevices(	DIDEVTYPE_JOYSTICK, InitJoystickInput, m_pDInput, DIEDFL_ATTACHEDONLY); 
	InitJoystick();
	joy = ReadJoystickInput();

}
 


