//************************************************************
//                                                           *
//   Name    : LoadFileFirst()								 *
//   Function: Whenever the disk systenm loads a file, it    *
//             load it into memory first for ease of use.    *
//             This section should also emulate the DIR      *
//             command.... filename of "$"?                  *
//                                                           *
//************************************************************
void LoadFileFirst( void )
{
			int		handle,err;
struct	find_t	DirInfo;
			char		s[256];
			char		Name[1024];

	FEnd=1;
	FIndex=0;
   FileLoading=0;
	//if (pFileName!=NULL)	chdir (pFileName);


	// *********************************************************
	//	If no disk selected use GAME directory as the disk image!
	// *********************************************************
	if (CurrentDisk[0]==0x0){
	   if (DMAFileName[0]=='$'){
			LoadGAMEdir();
	   } else {
			if (DMAFileName[nameindex-1]=='*'){
				DMAFileName[nameindex]='.';		// add what we need for MSDOS
				DMAFileName[nameindex+1]='*';
				nameindex+=2;
			}
			DMAFileName[nameindex]=0x0;
			sprintf	(&Name[0],"%s%s",pFileName,DMAFileName);
			err=_dos_findfirst(&Name[0],_A_NORMAL,&DirInfo);
			if (err==0){
			   FEnd=DirInfo.size;	//GetSize(&DirInfo.name);
			   if (FEnd!=0){
					sprintf	(&Name[0],"%s%s",pFileName,&DirInfo.name);
					strcpy (&LoadingName,&DirInfo.name);
	   	      handle=open (&Name[0],O_RDONLY|O_BINARY);	// open DOS file
				   read (handle,pFileSystem,FEnd);
				   close (handle);
               FileLoading=1;
			   }
			}
		}
	} else {

		// *******************************************************
		// IF we have a disk image... use THAT!
		// *******************************************************

	   handle=open (&CurrentDisk[0],O_RDONLY|O_BINARY);

	   if (DMAFileName[0]=='$'){									// directory asked for??
		   LoadDir( handle );
	   } else {
	      err=FindFileDir( handle );
	      if (err==0)	{
		      LoadD64FileSys( handle,TRACK, SECTOR );		// load file into memory
            FileLoading=1;
	      }
	   } 
	   close (handle);
	}
//	if (pFileName!=NULL)	chdir (pCurrPath);

	if (FileLoading==1){
		if (LoadingBar==0) {
	      pLoading=OpenWindow (NULL, 80,80,160,40);
	      pLoading->Options=0;			// border less, and stuff.
	      pLoading->flags|=wREFRESH;		// and refresh it!
         pLoading->clipx1=0;
         pLoading->clipx2=pLoading->maxxsize;
         pLoading->clipy1=0;
         pLoading->clipy2=pLoading->maxysize;
		   sprintf(s,"Loading...%s",&LoadingName);
	      pMessage=AddText(pLoading,2,2, &s);
	      InitWindow (pLoading);						// Clear window, and draw boarders
		}
	}
}


//************************************************************
//                                                           *
//   Name    :	ProcessDiskDrive                              *
//   Function: This is the disk drive emulation section.		 *
//                                                           *
//   In   : $FEF0 - Disk DMA byte									 *
//   Out  : $FEF0 - actual data etc..								 *
//                                                           *
//************************************************************
void ProcessDiskDrive ( void )
{
	int	i,handle;

	if (status==IDLE){
		switch (DMA_STORE){
			case 0x55	:	Memory[0xfef0]=0x55;			// init DMA...
								Memory[1]=Memory[1]&0x3f;
                        if (FileLoading==1) {
									if (LoadingBar==0) CloseWindow (pLoading);
                           pLoading=NULL;
                           FileLoading=0;
								}
								DMA_return;
			case 0x20	:  IO=IOWRITE;						// data write
								DMA_return;
			case 0x42	:
			case 0x40	:  IO=IOREAD;						// data write
								DMA_return;

			case 0x61	:	status=FILEDATA;				// file SAVE data
								FIndex=0;						// init file index
								return;

			case 0x62	:										// 0x62 is SEQ files
			case 0x60	:  status=FILEDATA;				// reveive file data
								LoadFileFirst();				// load requested file into memory first!
								DMA_return;
			case 0xe0   :  DMA_return;						// e0= close channel

			case 0xf1	:										// 0xf1 = GetName (save)
			case 0xf2	:
			case 0xff	:
			case 0xf0	:  status=GETNAME;				// reveive file data
								for (i=0;i<16;i++) DMAFileName[i]=0x0; 	// match ANY name
								nameindex=0;
								DMA_return;
			case 0x00	: 	DMA_return;						// end seq. (ignore)
		} 
	// ------------------------------------------------------------------
	} else if (status==GETNAME){
		if (DMA_STORE==0x81) {
			status=IDLE;
			DMA_return;											// end of seq?
		}

		if ((DMA_STORE!=0X83) AND (DMA_STORE!=0X00)){
			if (DMA_STORE=='*'){
				DMAFileName[nameindex]=DMA_STORE;				// store *
				nameindex++;											// and move to END of string
				status=IDLE;
				DMA_return;
			}
			if (DMA_STORE==',') DMA_STORE=0x0;					// some file names are "test,s,w" or "test,s,r"
			DMAFileName[nameindex]=DMA_STORE;				
			nameindex++;											
			if (nameindex==2){
         	if (((DMAFileName[0]=='0') AND						// the DLOAD will give a file name like "0:3dpool"
					 (DMAFileName[1]==':')) OR
         	    ((DMAFileName[0]=='@') AND						// save"@:????"
					 (DMAFileName[1]==':'))){                  // and we don't want the 0:
					for (i=0;i<16;i++) DMAFileName[i]='?'; 	// start again!
					nameindex=0;
				}
			}
		}
	// ------------------------------------------------------------------
	} else if (status==FILEDATA) {
		if ((LAST_DMA_STORE==0x0) AND (DMA_STORE==0x84))
		{
			if (IO==IOREAD)
			{
			   Memory[0xfef0]=pFileSystem[FIndex];
			   FIndex++;
			   if (FIndex==FEnd) {
               if (FileLoading==1){
					   if (LoadingBar==0) CloseWindow (pLoading);
                  pLoading=NULL;
                  FileLoading=0;
				   }
				   Memory[0xfef1]=3;			// flag file DONE
				   status=IDLE;
			   }
		  	}
		} else if ((LAST_LAST_DMA_STORE==0x0) AND  (LAST_DMA_STORE==0x83)) {
			if (IO==IOWRITE){
			   pFileSystem[FIndex]=DMA_STORE;
			   FIndex++;
		  	}
		} else if ((LAST_DMA_STORE==0x0) AND (DMA_STORE==0x81))  // end of file write
	   {			
			char		Name[1024];
			
			for (i=0;i<16;i++) {
				if (DMAFileName[i]=='?') DMAFileName[i]=0x0;
			}
			
			sprintf	(&Name[0],"%s%s",pFileName,DMAFileName);
		   handle=open (&Name[0],O_WRONLY|O_BINARY|O_CREAT,S_IRWXU|S_IRWXG);
   		write (handle,pFileSystem,FIndex);
   		close (handle);
				
		   Memory[0xfef1]=3;			// flag file DONE
		   status=IDLE;
		
		} else if (DMA_STORE==0x55){
			status=IDLE;
			Memory[0xfef0]=0x55;			// init DMA...
			Memory[1]=Memory[1]&0x3f;
			DMA_return;

		}
	}
	// ------------------------------------------------------------------
	LAST_LAST_DMA_STORE = LAST_DMA_STORE;
	LAST_DMA_STORE=DMA_STORE;
}
