//****************************************************************************
//fulllibc.lib 
//
//        The Minus4 project - Copyright (c) Mike Dailly 1996,97,98,99
//                          All rights reserved.
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//	Minus4j Written by:
// ------------------
//
// MD - Mike Dailly, Main framework and basic emulator.
//
//
//
//****************************************************************************
#include	<md.h>
#include	<all.h>
#include	<6502.h>
#include	<machine.h>
#include	<myprocess.h>
#include	<string.h>
#include	<windows.h>
#include	<stdio.h>
#include	"symbol.h"

#include <io.h>
#include <fcntl.h>
#include <commdlg.h>							//included for joystick functions
#include <sys/types.h>
#include <sys/stat.h>


#define	final
#define	IMM			0
#define	ABS			1
#define	ZPG			2
#define	IMP			3
#define	I__X		4
#define	I__Y		5
#define	Z__X		6
#define	A__X		7
#define	A__Y		8
#define	REL			9
#define	IND			10	
#define	Z__Y		11	
#define	DONE		0xf0

#define	OPCODE_MODE		0x0000000f
#define	NOLOCATION		0x00000010			// don't fill in a loction value
#define	NOLOCATIONVALUE	0x00000020			// don't fill in a PEEK of location value
#define	EXTENDEDOP		0x00000040			// Extended opcode

extern	int	DoGetAddress( void );
extern	int				KeyFlags[256];					// input key flags

	unsigned char	BreakPoints[65536];		// break on....blah
	char	InputSize[2049];
	char	InputEndAddress[2049];

typedef	struct	tDisasm {
	int				b;
	char			s[4];
	int				flags;
}tDisasm;
	tDisasm	Dtable[256];

	char	hexbuff[]={"0123456789ABCDEF"};
	char	ModeLine[1024];
	int		MODE;
	char	disline[1024];
	int		adder;					// number of bytes in instruction
	int		LocationValue;			// PEEK of location instruction is pointing to
	int		Location;				// Address indirection is pointing to

	char	s[256];

	int		CallBranchAddress;		// calculated address for BRANCH
	char	_OPCODE[1024];
//	int		opcode;

	uint8	*scr;		// scr

	int		currentindex=0;
//	disasm	Dtable[];
extern	char	C_Table[];


	int	col0=0xff;		// white background
	int	col1=0x00;		// black text

	char	InputAddress[2049];
	int		LastExecAddress=-1;
	int		LastBP;
	int		MemoryBase=0;
	int		WindowPC;					//  base address of window
	int		BarLine=0;					//  line the user bar is on
	int		WindowAddresses[256];		//
	int		ExtendedOp=0;
	int		CallStack[4096];
	int		BarStack[4096];
	int		CallStackPointer=-1;


//************************************************************
//
//************************************************************
int	Val( char* pStr )
{
	int	i,Value=0;
	int	base=10;

	while( *pStr!=0x00){
		char	a;

		a = *pStr++;
		if( a=='$' ) {
			base=16;
		}
		else
		{
			if((a>='a') && (a<='z')){
				a = a-('z'-'Z');
			}
			for(i=0;i<16;i++){
				if( hexbuff[i]==a){
					break;
				}
			}
			Value=Value*base;
			Value = Value+i;
		}		
	}
	return Value;
}



//************************************************************
//                                                           *
//   Name    :	SaveDIB                                      *
//   Function:  Save a DIB section inside a .BMP             *
//                                                           *
//   In   :	FileName = name to save as						 *
//          Width  = width of image                          *
//          Height = height of image                         *
//   Out  : none                                             *
//															 *
// Notes:													 *
//   GetPaletteEntry(i), returns THAT palette index			 *
//	 Watch for Red and Blue swapping						 *
//															 *
//	Author			Version		Comments					 *
//  ------													 *
//	Bigboy			1.0			First version 256 colour only*
//                                                           *
//************************************************************
extern	unsigned int GetPaletteEntry( int i );
extern	void Save( char *pszFileName, uint8* pData, int size );
extern	uint8	pScreen[360*240];

//
// must PACK struct, this is usually done using 1 ofthe following PACK methods
//
//#pragma pack(push,1)
//#pragma pack(1)
//___Attribute__((packed)) after each item to pack
//
typedef	struct tDIB 
{
	//
	//File header
	//
	uint16		ASCII_BM;					//"BM" ID string
	uint32		filesize;
	uint16		reserved1;
	uint16		reserved2;
	uint32		ImageOffset;
	//
	// Image header
	//
	uint32		SizeofImageHeader	;			// always 40 bytes
	uint32		ImageWidth			;			// in pixels
	uint32		ImageHeight			;			// in pixels
	uint16		Planes				;			// always 1
	uint16		BitsPerPixel		;			// (1,4,8,24)
	uint32		Compression			;			// 0=none, other=RLE
	uint32		CompressedImageSize	;			// in bytes
	uint32		HorizRes			;			// in pixels per meter?!?!?
	uint32		VertRes				;			// in pixels per meter?!?!?
	uint32		NumberCols			;			// palette entries used.
	uint32		NumberImport		;			// important colours in palette?
	uint8		Palette[256*4]		;			// palette 4*N (B,G,R)
}tDIB;
//#pragma pack()
//#pragma pack(pop)


void SaveDIB( char *FileName, int Width, int Height )
{
	int32		i,i2;
	tDIB	DIB;
	uint8	*pScr;
	uint32		c;

//	printf("Sizeof DIB:  %d\n",sizeof(tDIB));		// should be 1078 bytes - 54+(256*4)

	//
	// File Header
	//
	DIB.ASCII_BM=0x4d42;										//"BM"
	DIB.filesize=sizeof(tDIB)+(Width*Height);					// file size
	DIB.reserved1=0;
	DIB.reserved2=0;
	DIB.ImageOffset=sizeof(tDIB);								// start of image
	//
	// Image header
	//
	DIB.SizeofImageHeader=40;									// always 40
	DIB.ImageWidth=Width;										// in pixels
	DIB.ImageHeight=Height;										// in pixels
	DIB.Planes=1;												// always 1
	DIB.BitsPerPixel=8;											// (1,4,8,24)
	DIB.Compression=0;											// 0=none, other=RLE
	DIB.CompressedImageSize=0;									// in bytes
	DIB.HorizRes=0;												// in pixels per meter?!?!?
	DIB.VertRes=0;												// in pixels per meter?!?!?
	DIB.NumberCols=256;											// palette entries used.
	DIB.NumberImport=256;										// important colours in palette?

	i2=0;
	for (i=0;i<256;i++){
		uint32	ABGR;
		ABGR = GetPaletteEntry(i);
		DIB.Palette[i2  ]=(ABGR>>16)&0xff;						// B
		DIB.Palette[i2+1]=(ABGR>>8)&0xff;						// G
		DIB.Palette[i2+2]=(ABGR)&0xff;							// R
		DIB.Palette[i2+3]=0;
		i2+=4;
	}

	int	ghandle = _open( FileName, _O_CREAT|_O_TRUNC|_O_BINARY|_O_RDWR, _S_IREAD | _S_IWRITE );
	_write( ghandle, &DIB, sizeof(tDIB));						// write header

	// Now, write image out upside down...
	for (i=(Height-1);i>=0;i--)
	{
		c=(i*Width);
		pScr=pScreen;
		pScr+=c;
		_write( ghandle,pScr, Width);							// writes out a line at a time... slower... but less memory
	}
	_close( ghandle );
}

//****************************************************************************
//  Search the plus/4 character set for the correct character
//****************************************************************************
int	FindChar(char c)
{
	int	i;
	for (i=0;i<255;i++){
		if (C_Table[i]==c) return i;		// find the character number!
	}
	return 0;
}

//****************************************************************************
//  Print a single character to the screen
//****************************************************************************
void PrintChar (uint8 *V, int x, int y, int	c)
{
	int	Font=(0xd000+(c*8))-0x8000;			// index of FONT
	int	b,i;
	int	sindex=x+(y*360);

	for (i=0;i<8;i++){
		b=pROM[Font++];							// get base address of character data (FONT)								
		if ((b&0x80)==0) V[sindex++]=col0;	else V[sindex++]=col1; 
		if ((b&0x40)==0) V[sindex++]=col0;	else V[sindex++]=col1; 
		if ((b&0x20)==0) V[sindex++]=col0;	else V[sindex++]=col1; 
		if ((b&0x10)==0) V[sindex++]=col0;	else V[sindex++]=col1; 
		if ((b&0x8)==0)  V[sindex++]=col0;	else V[sindex++]=col1; 
		if ((b&0x4)==0)  V[sindex++]=col0;	else V[sindex++]=col1; 
		if ((b&0x2)==0)  V[sindex++]=col0;	else V[sindex++]=col1; 
		if ((b&0x1)==0)  V[sindex++]=col0;	else V[sindex++]=col1;
		sindex+=360-8;
	}
}

//****************************************************************************
//  Print a line of text on the screen using the Plus/4 FONT
//****************************************************************************
void	PrintLine (uint8 *V, int x,int y, char *line)
{
	int		i,len=Len(line)-1;		// get length of string to print
	int		Char;					// character to print
	int		ScreenIndex=x+(y*360);	// get X,Y screenindex (size assumed)

	for (i=0;i<len;i++){
		Char=FindChar(line[i]);			// get actual char to print
		PrintChar (V,x,y,Char);			// print a character
		x+=8;
	}
}


//****************************************************************************
//  Hex - return Hex dig
//****************************************************************************
void Hex (int number,int count)
{
   if (count==2){
	   s[0]=hexbuff[((number&0xF0)>>4)];
	   s[1]=hexbuff[(number&0x0F)];
	   s[2]=0;
   } else {
	   s[0]=hexbuff[( (number&0xF000)>>12)];
	   s[1]=hexbuff[((number&0x0F00)>>8)];
	   s[2]=hexbuff[((number&0xF0)>>4)];
	   s[3]=hexbuff[(number&0x0F)];
	   s[4]=0;
   }
}

//************************************************************
// Add an opcode to the table
//************************************************************
void AddOpcode(int a, char *s, int flags)
{
	Dtable[currentindex].b=a;
	strcpy (Dtable[currentindex].s,s);
	Dtable[currentindex].flags=flags;
	currentindex++;
}

//************************************************************
// Init debuggger 
//************************************************************
void InitDebug( )
{
		currentindex=0;

		AddOpcode(0x69,"ADC",IMM);
		AddOpcode(0x6d,"ADC",ABS);
		AddOpcode(0x65,"ADC",ZPG);
		AddOpcode(0x61,"ADC",I__X);
		AddOpcode(0x71,"ADC",I__Y);
		AddOpcode(0x75,"ADC",Z__X);
		AddOpcode(0x7d,"ADC",A__X);
		AddOpcode(0x79,"ADC",A__Y);
		AddOpcode(0x29,"AND",IMM);
		AddOpcode(0x2d,"AND",ABS);
		AddOpcode(0x25,"AND",ZPG);
		AddOpcode(0x21,"AND",I__X);
		AddOpcode(0x31,"AND",I__Y);
		AddOpcode(0x35,"AND",Z__X);
		AddOpcode(0x3D,"AND",A__X);
		AddOpcode(0x39,"AND",A__Y);
		AddOpcode(0x0e,"ASL",ABS);
		AddOpcode(0x1E,"ASL",A__X);
		AddOpcode(0x06,"ASL",ZPG);
		AddOpcode(0x0a,"ASL",IMP);
		AddOpcode(0x16,"ASL",Z__X);
		AddOpcode(0x90,"BCC",REL);
		AddOpcode(0xb0,"BCS",REL);
		AddOpcode(0xF0,"BEQ",REL);
		AddOpcode(0x2c,"BIT",ABS);
		AddOpcode(0x24,"BIT",ZPG);
		AddOpcode(0x30,"BMI",REL);
		AddOpcode(0xd0,"BNE",REL);
		AddOpcode(0x10,"BPL",REL);
		AddOpcode(0x00,"BRK",IMP);
		AddOpcode(0x50,"BVC",REL);
		AddOpcode(0x70,"BVS",REL);
		AddOpcode(0x18,"CLC",IMP);
		AddOpcode(0xd8,"CLD",IMP);
		AddOpcode(0x58,"CLI",IMP);
		AddOpcode(0xb8,"CLV",IMP);
		AddOpcode(0xc9,"CMP",IMM);
		AddOpcode(0xcd,"CMP",ABS);
		AddOpcode(0xc5,"CMP",ZPG);
		AddOpcode(0xc1,"CMP",I__X);
		AddOpcode(0xd1,"CMP",I__Y);
		AddOpcode(0xd5,"CMP",Z__X);
		AddOpcode(0xdd,"CMP",A__X);
		AddOpcode(0xD9,"CMP",A__Y);
		AddOpcode(0xe0,"CPX",IMM);
		AddOpcode(0xec,"CPX",ABS);
		AddOpcode(0xe4,"CPX",ZPG);
		AddOpcode(0xc0,"CPY",IMM);
		AddOpcode(0xcc,"CPY",ABS);
		AddOpcode(0xc4,"CPY",ZPG);
		AddOpcode(0xce,"DEC",ABS);
		AddOpcode(0xc6,"DEC",ZPG);
		AddOpcode(0xd6,"DEC",Z__X);
		AddOpcode(0xde,"DEC",A__X);
		AddOpcode(0xca,"DEX",IMP);
		AddOpcode(0x88,"DEY",IMP);
		AddOpcode(0x49,"EOR",IMM);
		AddOpcode(0x4D,"EOR",ABS);
		AddOpcode(0x45,"EOR",ZPG);
		AddOpcode(0x41,"EOR",I__X);
		AddOpcode(0x51,"EOR",I__Y);
		AddOpcode(0x55,"EOR",Z__X);
		AddOpcode(0x5D,"EOR",A__X);
		AddOpcode(0x59,"EOR",A__Y);
		AddOpcode(0xEE,"INC",ABS);
		AddOpcode(0xE6,"INC",ZPG);
		AddOpcode(0xF6,"INC",Z__X);
		AddOpcode(0xFE,"INC",A__X);
		AddOpcode(0xE8,"INX",IMP);
		AddOpcode(0xC8,"INY",IMP);
		AddOpcode(0x4C,"JMP",ABS|NOLOCATIONVALUE);
		AddOpcode(0x6C,"JMP",IND|NOLOCATIONVALUE);
		AddOpcode(0x20,"JSR",ABS|NOLOCATIONVALUE);
		AddOpcode(0xA9,"LDA",IMM);
		AddOpcode(0xAD,"LDA",ABS);
		AddOpcode(0xA5,"LDA",ZPG);
		AddOpcode(0xA1,"LDA",I__X);
		AddOpcode(0xB1,"LDA",I__Y);
		AddOpcode(0xB5,"LDA",Z__X);
		AddOpcode(0xBD,"LDA",A__X);
		AddOpcode(0xB9,"LDA",A__Y);
		AddOpcode(0xA2,"LDX",IMM);
		AddOpcode(0xAE,"LDX",ABS);
		AddOpcode(0xA6,"LDX",ZPG);
		AddOpcode(0xBE,"LDX",A__Y);
		AddOpcode(0xB6,"LDX",Z__Y);
		AddOpcode(0xA0,"LDY",IMM);
		AddOpcode(0xAC,"LDY",ABS);
		AddOpcode(0xA4,"LDY",ZPG);
		AddOpcode(0xB4,"LDY",Z__X);
		AddOpcode(0xBC,"LDY",A__X);
		AddOpcode(0x4E,"LSR",ABS);
		AddOpcode(0x46,"LSR",ZPG);
		AddOpcode(0x4A,"LSR",IMP);
		AddOpcode(0x56,"LSR",Z__X);
		AddOpcode(0x5E,"LSR",A__X);
		AddOpcode(0xEA,"NOP",IMP);
		AddOpcode(0x09,"ORA",IMM);
		AddOpcode(0x0D,"ORA",ABS);
		AddOpcode(0x05,"ORA",ZPG);
		AddOpcode(0x01,"ORA",I__X);
		AddOpcode(0x11,"ORA",I__Y);
		AddOpcode(0x15,"ORA",Z__X);
		AddOpcode(0x1D,"ORA",A__X);
		AddOpcode(0x19,"ORA",A__Y);
		AddOpcode(0x48,"PHA",IMP);
		AddOpcode(0x08,"PHP",IMP);
		AddOpcode(0x68,"PLA",IMP);
		AddOpcode(0x28,"PLP",IMP);
		AddOpcode(0x2E,"ROL",ABS);
		AddOpcode(0x26,"ROL",ZPG);
		AddOpcode(0x2A,"ROL",IMP);
		AddOpcode(0x36,"ROL",Z__X);
		AddOpcode(0x3E,"ROL",A__X);
		AddOpcode(0x6E,"ROR",ABS);
		AddOpcode(0x66,"ROR",ZPG);
		AddOpcode(0x6A,"ROR",IMP);
		AddOpcode(0x76,"ROR",Z__X);
		AddOpcode(0x7E,"ROR",A__X);
		AddOpcode(0x40,"RTI",IMP);
		AddOpcode(0x60,"RTS",IMP);
		AddOpcode(0xE9,"SBC",IMM);
		AddOpcode(0xED,"SBC",ABS);
		AddOpcode(0xE5,"SBC",ZPG);
		AddOpcode(0xE1,"SBC",I__X);
		AddOpcode(0xF1,"SBC",I__Y);
		AddOpcode(0xF5,"SBC",Z__X);
		AddOpcode(0xFD,"ORA",A__X);
		AddOpcode(0xF9,"SBC",A__Y);
		AddOpcode(0xEB,"SBC",IMM); // not a normalk SBC opcode
		AddOpcode(0x38,"SEC",IMP);
		AddOpcode(0xF8,"SED",IMP);
		AddOpcode(0x78,"SEI",IMP);
		AddOpcode(0x8D,"STA",ABS);
		AddOpcode(0x85,"STA",ZPG);
		AddOpcode(0x81,"STA",I__X);
		AddOpcode(0x91,"STA",I__Y);
		AddOpcode(0x95,"STA",Z__X);
		AddOpcode(0x9D,"STA",A__X);
		AddOpcode(0x99,"STA",A__Y);
		AddOpcode(0x8E,"STX",ABS);
		AddOpcode(0x86,"STX",ZPG);
		AddOpcode(0x96,"STX",Z__Y);
		AddOpcode(0x8C,"STY",ABS);
		AddOpcode(0x84,"STY",ZPG);
		AddOpcode(0x94,"STY",Z__X);
		AddOpcode(0xAA,"TAX",IMP);
		AddOpcode(0xA8,"TAY",IMP);
		AddOpcode(0xBA,"TSX",IMP);
		AddOpcode(0x8A,"TXA",IMP);
		AddOpcode(0x9A,"TXS",IMP);
		AddOpcode(0x98,"TYA",IMP);

		// Extended opcodes

		AddOpcode(0x02,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0x12,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0x22,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0x32,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0x42,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0x52,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0x62,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0x72,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0x92,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0xb2,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0xd2,"HLT",IMP|EXTENDEDOP);
		AddOpcode(0xf2,"HLT",IMP|EXTENDEDOP);
		
		AddOpcode(0x80,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x82,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0xc2,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0xe2,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x04,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x14,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x34,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x44,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x54,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x64,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x74,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0xd4,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0xf4,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x89,"SKB",ZPG|NOLOCATIONVALUE|EXTENDEDOP);
		
		AddOpcode(0x0c,"SKW",ABS|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x1c,"SKW",ABS|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x3c,"SKW",ABS|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x5c,"SKW",ABS|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0x7c,"SKW",ABS|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0xdc,"SKW",ABS|NOLOCATIONVALUE|EXTENDEDOP);
		AddOpcode(0xfc,"SKW",ABS|NOLOCATIONVALUE|EXTENDEDOP);

		AddOpcode(0xEF,"INS",ABS|EXTENDEDOP);
		AddOpcode(0xE7,"INS",ZPG|EXTENDEDOP);
		AddOpcode(0xE3,"INS",I__X|EXTENDEDOP);
		AddOpcode(0xF3,"INS",I__Y|EXTENDEDOP);
		AddOpcode(0xF7,"INS",Z__X|EXTENDEDOP);
		AddOpcode(0xFF,"INS",A__X|EXTENDEDOP);
		AddOpcode(0xFB,"INS",A__Y|EXTENDEDOP);
		AddOpcode(0x8F,"AXS",ABS|EXTENDEDOP);
		AddOpcode(0x87,"AXS",ZPG|EXTENDEDOP);
		AddOpcode(0x97,"AXS",Z__Y|EXTENDEDOP);
		AddOpcode(0x83,"AXS",I__X|EXTENDEDOP);
		AddOpcode(0x0F,"ASO",ABS|EXTENDEDOP);
		AddOpcode(0x07,"ASO",ZPG|EXTENDEDOP);
		AddOpcode(0x03,"ASO",I__X|EXTENDEDOP);
		AddOpcode(0x13,"ASO",I__Y|EXTENDEDOP);
		AddOpcode(0x17,"ASO",Z__X|EXTENDEDOP);
		AddOpcode(0x1F,"ASO",A__X|EXTENDEDOP);
		AddOpcode(0x1B,"ASO",A__Y|EXTENDEDOP);
		AddOpcode(0xCF,"DCM",ABS|EXTENDEDOP);
		AddOpcode(0xC7,"DCM",ZPG|EXTENDEDOP);
		AddOpcode(0xC3,"DCM",I__X|EXTENDEDOP);
		AddOpcode(0xD3,"DCM",I__Y|EXTENDEDOP);
		AddOpcode(0xD7,"DCM",Z__X|EXTENDEDOP);
		AddOpcode(0xDF,"DCM",A__X|EXTENDEDOP);
		AddOpcode(0xDB,"DCM",A__Y|EXTENDEDOP);
		AddOpcode(0xAF,"LAX",ABS|EXTENDEDOP);
		AddOpcode(0xA7,"LAX",ZPG|EXTENDEDOP);
		AddOpcode(0xA3,"LAX",I__X|EXTENDEDOP);
		AddOpcode(0xb3,"LAX",I__Y|EXTENDEDOP);
		AddOpcode(0xB7,"LAX",Z__X|EXTENDEDOP);
		AddOpcode(0xBF,"LAX",A__Y|EXTENDEDOP);
		AddOpcode(0x1A,"NOP",IMP|EXTENDEDOP);
		AddOpcode(0x3A,"NOP",IMP|EXTENDEDOP);
		AddOpcode(0x5A,"NOP",IMP|EXTENDEDOP);
		AddOpcode(0x7A,"NOP",IMP|EXTENDEDOP);
		AddOpcode(0xDA,"NOP",IMP|EXTENDEDOP);
		AddOpcode(0xFA,"NOP",IMP|EXTENDEDOP);
		AddOpcode(0xAB,"OAL",IMM|EXTENDEDOP);
		AddOpcode(0x4B,"ALR",IMM|EXTENDEDOP);
		AddOpcode(0xCB,"SAX",IMM|EXTENDEDOP);
		AddOpcode(0x4F,"LSE",ABS|EXTENDEDOP);
		AddOpcode(0x47,"LSE",ZPG|EXTENDEDOP);
		AddOpcode(0x57,"LSE",Z__X|EXTENDEDOP);
		AddOpcode(0x5F,"LSE",A__X|EXTENDEDOP);
		AddOpcode(0x5B,"LSE",A__Y|EXTENDEDOP);
		AddOpcode(0x43,"LSE",I__X|EXTENDEDOP);
		AddOpcode(0x53,"LSE",I__Y|EXTENDEDOP);
		AddOpcode(0x6F,"RRA",ABS|EXTENDEDOP);
		AddOpcode(0x7F,"RRA",A__X|EXTENDEDOP);
		AddOpcode(0x7B,"RRA",A__Y|EXTENDEDOP);
		AddOpcode(0x67,"RRA",ZPG|EXTENDEDOP);
		AddOpcode(0x77,"RRA",Z__X|EXTENDEDOP);
		AddOpcode(0x63,"RRA",I__X|EXTENDEDOP);
		AddOpcode(0x73,"RRA",I__Y|EXTENDEDOP);
		AddOpcode(0x2f,"RLA",ABS|EXTENDEDOP);
		AddOpcode(0x3f,"RLA",A__X|EXTENDEDOP);
		AddOpcode(0x3b,"RLA",A__Y|EXTENDEDOP);
		AddOpcode(0x27,"RLA",ZPG|EXTENDEDOP);
		AddOpcode(0x37,"RLA",Z__X|EXTENDEDOP);
		AddOpcode(0x23,"RLA",I__X|EXTENDEDOP);
		AddOpcode(0x33,"RLA",I__Y|EXTENDEDOP);
		AddOpcode(0x9c,"SAY",A__X|EXTENDEDOP);
		AddOpcode(0x8B,"XAA",IMM|EXTENDEDOP);
		AddOpcode(0xff,"???",IMP|DONE);
}
//****************************************************************************
//
// Define Opcode DIS-Table
//
//****************************************************************************
int	SearchOpcode (int opcode)
{
	int	i,done;

	done=0;
	i=0;
	while (done==0) {
		if ((opcode==Dtable[i].b) || ((Dtable[i].flags&0xf0)==DONE)) {
			if( (Dtable[i].flags&0xf0)==DONE){
					done=1;
					strcpy(_OPCODE,Dtable[i].s);
					MODE=(Dtable[i].flags);
					return MODE;
			}
			if( ExtendedOp==0 ){
				if(( Dtable[i].flags&EXTENDEDOP ) ==0 ){
					done=1;
					strcpy(_OPCODE,Dtable[i].s);
					MODE=(Dtable[i].flags);
					return MODE;
				}
			}else{
				done=1;
				strcpy(_OPCODE,Dtable[i].s);
				MODE=(Dtable[i].flags);
				return MODE;
			}
		}
		i++;
	}
	return 0;
}

//************************************************************
// Given an opcode, get the size of an instruction
//************************************************************
int	GetSizeOfInstruction(int _opcode)
{
	int	mode = SearchOpcode(_opcode);
	switch(mode&OPCODE_MODE)
	{
		case	IMM	: return 2;
		case	ABS	: return 3;
		case	ZPG	: return 2;
		case	IMP	: return 1;
		case	I__X: return 2;
		case	I__Y: return 2;
		case	Z__X: return 2;
		case	A__X: return 3;
		case	A__Y: return 3;
		case	REL	: return 2;
		case	IND	: return 2;
		case	Z__Y: return 2;
	}
	return 1;
}



//****************************************************************************
//
// Define Opcode DIS-Table
//
//****************************************************************************
void GetModeLine( int MODE )
{
	char	sb[5];
	char	sw[5];
	int		b;
	int		w,pc3;
	int		bb;
	char*	pbTxt;
	char*	pwTxt;
	char*	pTxt;
	char	TempStr1[1024];
	char	TempStr2[1024];

	pc3=__PC;
	w=GETAWORD();
	__PC=pc3;
	b=GETABYTE();

	pbTxt = FindValue( b );
	pwTxt = FindValue( w );

	// Execute call
	/*if ((opcode==0x20) OR (opcode==0x4c)) {	//OR (opcode==0x6c)){
		if ((w>=RangeLow) AND (w<=RangeHigh)) CallTable[w]=1;
		CallBranchAddress=w;
	}*/
	Hex (w, 4);
	strcpy(sw,s);
	Hex (b, 2);
	strcpy(sb,s);

	if( pbTxt == NULL ){
		sprintf( TempStr1, "$%s",sb);
		pbTxt = TempStr1;
	}
	if( pwTxt == NULL ){
		sprintf( TempStr2, "$%s",sw);
		pwTxt = TempStr2;
	}

	switch (MODE&OPCODE_MODE) {
		case	IMM	:		adder=2; sprintf (ModeLine,"#%s",sb);	break;
		case	ABS	:		adder=3; sprintf (ModeLine,"%s",pwTxt);	LocationValue=Peek(w); break;
		case	ZPG	:		adder=2; sprintf (ModeLine,"%s",pbTxt);	LocationValue=Peek(b); break;
		case	IMP	:		adder=1; sprintf (ModeLine," ");			break;
		case	I__X	:		adder=2; sprintf (ModeLine,"(%s,X)",pbTxt);	bb=b; Location=Deek((bb+__X)&255); LocationValue=Peek(Location); break;
		case	I__Y	:		adder=2; sprintf (ModeLine,"(%s),Y",pbTxt);	Location=Deek(b)+__Y; LocationValue=Peek(Location); break;
		case	Z__X	:		adder=2; sprintf (ModeLine,"%s,X",pbTxt);	LocationValue=Peek(b+__X); break;
		case	A__X	:		adder=3; sprintf (ModeLine,"%s,X",pwTxt);	LocationValue=Peek(w+__X); break;
		case	A__Y	:		adder=3; sprintf (ModeLine,"%s,Y",pwTxt);  LocationValue=Peek(w+__Y); break;
		case	REL	:		{
									adder=2; 
									if (b>127) {
										b=((-b)&0xff);
										__PC-=b;
									} else {
										__PC+=b;
									}
									CallBranchAddress=__PC;
									pTxt = FindValue( CallBranchAddress );
									pTxt=NULL;
									if( pTxt == NULL){
										//if ((__PC>=RangeLow) && (__PC<=RangeHigh)) CallTable[__PC]=1;
										Hex ( __PC, 4 );
										//sw=Hex ( __PC, 4 );
										sprintf(ModeLine,"$%s",s);
									}else{
										sprintf(ModeLine,"%s",pTxt);
									}
									break;
								};
		case	IND	:		adder=3; sprintf(ModeLine,"(%s)",pwTxt);	Location=Deek(w); break;
		case	Z__Y	:		adder=2; sprintf(ModeLine,"%s,Y",pbTxt);	LocationValue=Peek(b+__Y); break;
	}

}


//****************************************************************************
//
// Disassemble a single instruction
//
//****************************************************************************
void Disassemble( int	PC__Address )
{
	int		PC2;  
	char	s1[256];
	uint32	a;


	Location=0xffffffff;
	LocationValue=0xffffffff;
	CallBranchAddress=0xffffffff;
	PC2=__PC;						// Store PC temp
	__PC=PC__Address;

	opcode=GETABYTE();			// get a byte from memory
	Hex (PC__Address, 4);			// get HEX of address
	strcpy(s1,s);				
	SearchOpcode(opcode);
	GetModeLine(MODE);
	sprintf(disline,"%s  %s  %s",s1,_OPCODE,ModeLine);
	__PC=PC2;

	if ((MODE&NOLOCATION)!=0)		Location=0xffffffff;
	if ((MODE&NOLOCATIONVALUE)!=0)	LocationValue=0xffffffff;

	
	while ((Len(disline)-1)<19){	//0000  sta $0000,y
		a=(Len(disline)-1);
		disline[a]=' ';
		disline[a+1]=0x0;
	}
}

//************************************************************
// process debugger
//************************************************************
extern	void ProcessTape( void );
extern	int		RasterLine;
extern  int		g_LightPen;
extern	int		debugger;

void ProcessDebugger(uint8 *V )
{
	int		Value;
	int		TempPC,i,i2;
	char	sPC[20],sA[20],sX[20],sY[20],sSP[20],sF[20];
	char	line[256];
	int		updatePC=0;

	scr=V;
	if( (BreakPoints[__PC]&1)!=0){
		BreakPoints[__PC]|=2;
	}

	memset(scr,255,360*240);
	if(	LastExecAddress !=-1 ){
		BreakPoints[LastExecAddress]=LastBP;
		LastExecAddress=-1;
	}
	if (KeysPressed[13]!=0xff){
		KeysPressed[13]=0xff;
		if( (BreakPoints[__PC]&1)!=0){
			BreakPoints[__PC]|=2;
		}
		ProcessSingleTick();
		updatePC = 1;
		if( g_SampleStart == 1) ProcessTape();			// Play pressed, and sample loaded?
	}

	if (KeysPressed['R']!=0xff){
		KeysPressed['R']=0xff;
		Value = DoGetAddress();
		BreakPoints[Value]^=4;		// toggle BP
	}


	if (KeysPressed['G']!=0xff){	// goto PC
		KeysPressed['G']=0xff;
		Value = DoGetAddress();
		WindowPC=Value;
		BarLine = 0;
	}
	if (KeysPressed['M']!=0xff){
		KeysPressed['M']=0xff;
		Value = DoGetAddress();
		MemoryBase=Value;
	}

	// Save memory
	if (KeysPressed['S']!=0xff){
		unsigned char	m[65536];
		KeysPressed['S']=0xff;
		int Value1 = DoGetAddress();		// Start address
		int Value2 = DoGetAddress();		// end address
		int ind=0;
		for(int i=Value1;i<Value2;i++){
			m[ind++]=pMemory[i];
		}
		Save( "c:\\memdump.dat", &(m[0]), ind);
	}


//	int		CallStack[4096];
//	int		CallStackPointer=-1;
	if (KeyFlags[39]!=0){			// RIGHT
		KeyFlags[39]=0;
		int Address = WindowAddresses[BarLine];
		int OpCode = Peek( Address );
		if(( OpCode==0x20 ) || (OpCode==0x4c) || (OpCode==0x6c)){
			if( CallStackPointer<4090 ){
				CallStackPointer++;
				CallStack[CallStackPointer]=WindowAddresses[0];		// remember old window pointer
				BarStack[CallStackPointer] = BarLine;
				
				// Now get the new address
				Address = (Address+1)&0xffff;
				int Dest = Peek( Address );
				Address = (Address+1)&0xffff;
				Dest = (Peek( Address )<<8)+Dest;
				if( OpCode==0x6c ){
					Address = Dest;
					Dest = Peek( Address );
					Address = (Address+1)&0xffff;
					Dest = (Peek( Address )<<8)+Dest;
				}
				WindowPC = Dest;
				BarLine=0;
			}
		}
	}
	if (KeyFlags[37]!=0){			// LEFT
		KeyFlags[37]=0;
		if( CallStackPointer>=0 ){
			WindowPC  = CallStack[CallStackPointer];
			BarLine = BarStack[CallStackPointer];
			CallStackPointer--;
		}
	}



	// SHIFT pressed.
	if( KeyFlags[16]!=0){
		// Scroll memory window around
		if (KeyFlags[0x21]!=0){			// page UP
			KeyFlags[0x21]=0;
			MemoryBase-=64;
			if( MemoryBase<0 ) MemoryBase=0;
		}
		if (KeyFlags[0x22]!=0){			// page down
			KeyFlags[0x22]=0;
			MemoryBase+=64;
			if( MemoryBase>0xffb8 ) MemoryBase=0xffb8;
		}

		// Scroll memory window around
		if (KeyFlags[0x26]!=0){			// line UP
			KeyFlags[0x26]=0;
			MemoryBase-=8;
			if( MemoryBase<0 ) MemoryBase=0;
		}
		if (KeyFlags[0x28]!=0){			// page down
			KeyFlags[0x28]=0;
			MemoryBase+=8;
			if( MemoryBase>0xffb8 ) MemoryBase=0xffb8;
		}

		// Enter a breakpoint via an address or label/symbol
		if (KeysPressed['B']!=0xff){
			KeysPressed['B']=0xff;
			Value = DoGetAddress();
			BreakPoints[Value]^=1;		// toggle BP
		}

	}else{
		// Whole page UP
		if (KeyFlags[0x21]!=0){			// page UP
			KeyFlags[0x21]=0;

			// Find the next probable line up
			int index=0;
			int	Add[300];
			int pc = WindowAddresses[0]-256;
			for(i=0;i<280;i++){
				Disassemble( pc );
				Add[index++] = pc;
				pc+=adder;
			}
			int found = 0;
			for(i=0;i<280;i++){
				if( Add[i]==WindowAddresses[0] ){
					WindowPC = Add[i-14];
					found = 1;
					break;
				}
			}
			if( found==0 ){
				WindowPC--;
			}
			//BarPC = 0;
		}
		if (KeyFlags[0x22]!=0){			// page down
			KeyFlags[0x22]=0;
			WindowPC = WindowAddresses[14];
			//BarLine = 0;
		}

		// -------------------------------------------------------
		// Single line DOWN
		//
		if (KeyFlags[0x28]!=0){
			KeyFlags[0x28]=0;
			BarLine++;
			if( BarLine>13 ){
				BarLine=13;
				WindowPC = WindowAddresses[1];
			}
		}

		// Single Line UP
		if (KeyFlags[0x26]!=0)
		{
			KeyFlags[0x26]=0;
			BarLine--;
			if( BarLine<0 ){
				BarLine=0;

				// Find the next probable line up
				int index=0;
				int	Add[300];
				int pc = WindowAddresses[0]-256;
				for(i=0;i<280;i++){
					Disassemble( pc );
					Add[index++] = pc;
					pc+=adder;
				}
				int found=0;
				for(i=0;i<280;i++){
					if( Add[i]==WindowAddresses[0] ){
						found = 1;
						WindowPC = Add[i-1];
						break;
					}
				}
				if( found==0 ){
					WindowPC--;
				}
				//BarPC = WindowPC;
			}
		}

		// set a breakpoint on the current BAR address
		if (KeysPressed['B']!=0xff){
			KeysPressed['B']=0xff;
			BreakPoints[WindowAddresses[BarLine]]^=1;		// toggle BP
		}
	}

	//
	// Execute a breakpoint AFTER the current instruction. 
	//
	if (KeysPressed[' ']!=0xff)
	{
		if( (BreakPoints[__PC]&1)!=0){
			BreakPoints[__PC]|=2;
		}

		KeysPressed[' ']=0xff;
		Disassemble( __PC );
		
		LastExecAddress = __PC+adder;
		LastBP = BreakPoints[__PC+adder];
		BreakPoints[__PC+adder]|=1;
		debugger=0;
		return;
	}
		

	// **************************************************************************************************************
	// **************************************************************************************************************
	//
	// Print Registers
	//
	// **************************************************************************************************************
	// **************************************************************************************************************
	Hex(__PC,4);
	strcpy(sPC,s);
	Hex(__A,2);
	strcpy(sA,s);
	Hex(__X,2);
	strcpy(sX,s);
	Hex(__Y,2);
	strcpy(sY,s);
	Hex(__SP,2);
	strcpy(sSP,s);
		
	sprintf(sF,"0000000");
	if ((__F&__C)!=0){ sF[6]='1'; }
	if ((__F&__Z)!=0){ sF[5]='1'; }
	if ((__F&__I)!=0){ sF[4]='1'; }
	if ((__F&__D)!=0){ sF[3]='1'; }
	if ((__F&__B)!=0){ sF[2]='1'; }
	if ((__F&__V)!=0){ sF[1]='1'; }
	if ((__F&__N)!=0){ sF[0]='1'; }
		
	sprintf (line," PC  AR XR YR SP  NVBDIZC ");		//line="0000 00 00 00 00  0100101 ";
	PrintLine (V,20,4,line);
	sprintf (line,"%s %s %s %s %s  %s ",sPC,sA,sX,sY,sSP,sF);
	PrintLine (V,20,12,line);


	// ************************************************
	// Print Disassembly
	// ************************************************
	//TempPC=__PC;

	if( updatePC!=0 ){
		int found=0;
		for(i=0;i<14;i++){
			if( WindowAddresses[i]==__PC ) found=1;
		}
		if( found==0) WindowPC=__PC;
	}


	TempPC = WindowPC;
	for (i=0;i<14;i++)
	{
		int bars=0;
		col0=0xff;
		col1=0x00;
		Disassemble( TempPC );
		WindowAddresses[i] = TempPC;
			
		if( BarLine==i){
			col0=0x5f;
			bars = 1;
		}

		if( (BreakPoints[TempPC]&1)!=0){
			if( bars==0 ){
				col0=0x42;
				col1=0x67;
			}else{
				col0=0x52;
				col1=0x67;
			}
		}
		if( TempPC == __PC ){
			if( bars==0 ){
				col0 = 0x36;
				col1 = 0x67;
			}else{
				col0 = 0x46;
				col1 = 0x67;
			}
		}
		PrintLine (V,20,42+(i*8)-16,disline);
		TempPC+=adder;
	}
	WindowAddresses[14] = TempPC;
	col0=0xff;
	col1=0x00;


	// 
	// Print hardware registers as 2 lines of HEX
	//
	line[0]=0x00;
	for(i=0;i<15;i++){
		Hex((pMemory[0xff00+i]&0xff),2 );
		strcat( line, s);
		strcat( line, " ");
	}
	PrintLine (V,00,122+8+16-5,line);

	line[0]=0x00;
	for(i=0;i<15;i++){
		Hex((pMemory[0xff0f+i]&0xff),2 );
		strcat( line, s);
		strcat( line, " ");
	}
	PrintLine (V,00,122+24+8-4,line);


	//
	// Print 64 bytes of HEX data
	//
	for(i2=0;i2<8;i2++){
		line[0]=0x00;
		Hex(MemoryBase+(i2*8),4 );
		strcat( line, s);
		strcat( line, ": ");
		for(i=0;i<8;i++){
			Hex((pMemory[MemoryBase+(i2*8)+i]&0xff),2 );
			strcat( line, s);
			strcat( line, " ");
		}
		PrintLine (V,20,122+24+16+(i2*8),line);
	}
	
}

