#include <md.h>

#ifndef __ALL_H__
#define __ALL_H__

//****************************************************************************
//
//  Standard header file.
//
//****************************************************************************
#include "malloc.h"

//***************************************************************
// my malloc and free
//***************************************************************
#define     MALLOC(s)   malloc(s)
#define     FREE(p)     { free(p); p = NULL; }
#define		MyFree(n1)		{ DoFree(n1); n1=NULL; }

#define	xres	368
#define	yres	240
//#define	Xsize	xres
//#define	Ysize	yres

//
// flag for memory read and write
// Means that its NOT a memory location,
// but a routine to call!
//
#define	ROUTINE	0x00000001				// all JUMP routines are 4 byte aligned!

#define	MAXROM		9

#define  MODEX			1

#define	SCREEN_LINES		0x137						// 312 scan lines
// 8501

#define	__C	1
#define	__Z  2
#define	__I	4
#define	__D	8
#define	__B	16
#define	__V	64
#define	__N	128


#define	ColourNo		0x3c8
#define	ColourAttr	0x3c9
#define	AND			&&
#define	OR				||
#define	XOR				^
#define	EOR				^

//#ifndef TRUE
//#define	TRUE			255
//#endif
//#ifndef FALSE
//#define	FALSE			0
//#endif

//    1-17   21 sectors * 256 bytes
//   18-24   19 sectors * 256 bytes
//   25-30   18 sectors * 256 bytes
//   31-35   17 sectors * 256 bytes
//  *36-40*  17 sectors * 256 bytes
//					21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,
//					19,19,19,19,19,19,19,
//					18,18,18,18,18,18,
//					17,17,17,17,17,
//					17,17,17,17,17,

#define	IDLE			0		// nothing
#define	COMMAND		1		// command comming
#define	GETNAME		2
#define	SENDDATA		3
#define	FILEDATA		4
#define	IOREAD		1
#define	IOWRITE		2

typedef	struct tDir {
		uint8		FileType;
		uint8		Track;
		uint8		Sector;
		char		FileName[16];		// NO 0x0 end
		uint8		RelTrack;
		uint8		RelSector;
		uint8		RelRecordLen;
		uint8		Unused[4];
		uint8		OverwriteTrack;
		uint8		OverwriteSector;
		uint16		NumberBlocks;
		uint8		unused2;				// skip bytes
		uint8		unused3;
}tDir;

typedef	struct	tSector{
		uint8		Track;				// Next track
		uint8		Sector;				// and sector
		uint8		Data[254];			// 254 bytes of data.
}tSector;



#endif