#ifndef	__CSOUND_H__
#define	__CSOUND_H__

#include	<all.h>
#include	<memory.h>
#include	<dsound.h>
#include	<windows.h>


#define	MD_ERROR	1
#define	MD_OKAY		0



//
// The bigger the buffer, the more behind the audio we are. This sucks, since we actually WANT a 
// 1 frame buffer. But, my sound card at least can't cope with this. So we'll have to settle on a
// 2 frame buffer...and do a timer to get the 50Hz we need to get the game speed right...
//
#define	FRAMESIZE	(624)
#define	NUMFRAMES	(1)
#define	BUFFERSIZE	(FRAMESIZE*NUMFRAMES*2)		// a four frame buffer (312 scanlines*twice a scanline*50 frames) (16bit)
#define	BUFFERS		8							// double buffer sound...no real point in having more...
#define NUMEVENTS	BUFFERS

// ******************************************************************
//
//	Direct Sound system. dsound.lib
//
// ******************************************************************
class	CSound
{
public:
	LPDIRECTSOUND				lpds; 
	DSBUFFERDESC                dsbdesc;
//	LPDIRECTSOUNDBUFFER         lpdsb;
	LPDIRECTSOUNDBUFFER         lpdsbPrimary;
	LPDIRECTSOUNDNOTIFY         lpdsNotify;
	WAVEFORMATEX                *pwfx;
	HMMIO                       hmmio;
	MMCKINFO                    mmckinfoData, mmckinfoParent;



	CSound( HWND hwnd );
	~CSound( void );
	
	LPDIRECTSOUNDBUFFER		CSound::CreateSecondaryBuffer( void );
//	BOOL					Lock( LPDIRECTSOUNDBUFFER pSoundBuffer );
//	BOOL					Unlock( LPDIRECTSOUNDBUFFER pSoundBuffer );
	BOOL					Play( LPDIRECTSOUNDBUFFER pSoundBuffer );
	BOOL					Stop( LPDIRECTSOUNDBUFFER pSoundBuffer );
//	~CPlus4();
};



class	CSoundBuffer
{
public:
	LPDIRECTSOUNDBUFFER         m_pDSBuffer;
 	uint16						*m_pBuffer1;
	uint32						m_BufferSize1;
	uint16						*m_pBuffer2;
	uint32						m_BufferSize2;
	uint32						m_LockedSize;
	uint32						m_Index;

	BOOL					Lock( uint32 index,  uint32 size);
	BOOL					Unlock( void );
	void					Release( void );
};

#endif // __CSOUND_H__