// ******************************************************************
//
//	Plus4 hardware class!
//
// ******************************************************************
#include <CHardware.h>

class	CPlus4: CHardware
{
public:
	int		m_pMemory[65536];				// plus/4 memory
	int		m_ROMACTIVE;
	int		m_ROM;
	int		*m_pRomLo;
	int		*m_pRomHi;
	int		*m_pROM;
	int		m_Keys[13];
	int		m_skipit;

	int		m_ROM1[16384];				// the 8 paging ROM's
	int		m_ROM2[16384];
	int		m_ROM3[16384];
	int		m_ROM4[16384];
	int		m_ROM5[16384];
	int		m_ROM6[16384];
	int		m_ROM7[16384];
	int		m_ROM8[16384];

	int		*m_pRom0;
	int		*m_pRom1;
	int		*m_pRom2;
	int		*m_pRom3;
	int		*m_pRom4;
	int		*m_pRom5;
	int		*m_pRom6;
	int		*m_pRom7;

	int		m_TIMER1_ACTIVE;			// timer 1 active?
	int		m_Timer1Value;		// master reset value
	int		m_Timer1;			// current Timer value
	int		m_TimerTemp;					// temp reset checking value

	int		m_TIMER2_ACTIVE;			// timer 2 active?
	int		m_Timer2;			// current Timer 2 value
	int		m_TIMER3_ACTIVE;			// timer 3 active?
	int		m_Timer3;			// current Timer 3 value

	
	CPlus4();
	~CPlus4();

	// overload peek and poke to hit PLUS4 hardware
	void	Poke( int address, int val );			// writes to memory and affects hardware
	void	POKE( int address, int val );			// write to memory. doesn't affect hardware
	void	DOKE( int address, int val );			// write "WORD" to memory. Don't affect hardware
	int		Peek( int address );					// get byte from memory
	int		Deek( int address );					// get a WORD from memory

	int		GetByte( int address )	{ return 0; }	// get a byte from UNDER rom's - if possible, if not return rom byte
	int		GetWord( int address )	{ return 0; }	// get a word from UNDER rom's - if possible, if not return rom byte
	int		Init( void );							// Init machine


	int		ReadKeyboard( int a );
	void	SetTimer1LO(int val);
	void	SetTimer1(int val);
	void	SetTimer2LO(int val);
	void	SetTimer2(int val);
	void	SetTimer3LO(int val);
	void	SetTimer3(int val);

};

