#ifndef __PC_TYPES__
#define __PC_TYPES__

/* integer types */
typedef signed char     Int8;
typedef signed char     int8;
typedef signed short    Int16;
typedef signed short    int16;
typedef signed long     Int32;
typedef signed long     int32;
typedef signed __int64  Int64;
typedef signed __int64  int64;

/* unsigned integer types */
typedef unsigned char   UInt8;
typedef unsigned char   Uint8;
typedef unsigned char   uint8;
typedef unsigned short  UInt16;
typedef unsigned short  Uint16;
typedef unsigned short  uint16;
typedef unsigned long   UInt32;
typedef unsigned long   Uint32;
typedef unsigned long   uint32;
typedef unsigned __int64        UInt64;
typedef unsigned __int64        Uint64;
typedef unsigned __int64        uint64;

/* fixed point value types ( position of point not defined ) */
typedef signed char     Fix8;
typedef signed char     fix8;
typedef signed short    Fix16;
typedef signed short    fix16;
typedef signed long     Fix32;
typedef signed long     fix32;
typedef signed __int64  Fix64;
typedef signed __int64  fix64;

/* unsigned fixed point value types */
typedef unsigned char   UFix8;
typedef unsigned char   Ufix8;
typedef unsigned char   ufix8;
typedef unsigned short  UFix16;
typedef unsigned short  Ufix16;
typedef unsigned short  ufix16;
typedef unsigned long   UFix32;
typedef unsigned long   Ufix32;
typedef unsigned long   ufix32;
typedef unsigned __int64        UFix64;
typedef unsigned __int64        Ufix64;
typedef unsigned __int64        ufix64;

/* character types ( ASCII 8-bit ) */
typedef char            Char;
#ifndef CHAR
typedef char            CHAR;
#endif

/* Boolean types (TRUE/FALSE) */
typedef unsigned char   Bool8;
typedef unsigned char   bool8;
typedef unsigned char   BOOL8;
typedef unsigned short  Bool16;
typedef unsigned short  bool16;
typedef unsigned short  BOOL16;
typedef unsigned long   Bool32;
typedef unsigned long   bool32;
typedef unsigned long   BOOL32;
typedef unsigned __int64        Bool64;
typedef unsigned __int64        bool64;
typedef unsigned __int64        BOOL64;

/* Machine dependent macros */
#define LS8(a)          ((Int8)((a) & ((UInt16)(~0) >> 8)))
#define MS8(a)          ((Int8)((UInt16)(a) >> 8))
#define LS16(a)         ((Int16)((a) & ((UInt32)(~0) >> 16)))
#define MS16(a)         ((Int16)((UInt32)(a) >> 16))
#define LS32(a)         ((Int32)((a) & ((UInt64)(~0) >> 32)))
#define MS32(a)         ((Int32)((UInt64)(a) >> 32))

#endif

