#ifndef	__MACHINE__
#define	__MACHINE__

#define	XSIZE	(320+40)
#define	YSIZE	(200+40)
#define	YCHAROFFSET 20
#define	XCHAROFFSET 20

// *******************************************************************
// Tape loader constants
// *******************************************************************
#define  _1MHZ						0
#define  _1_78MHZ					1
#define	TONESIZE					144

#define	MACHINE_FPS					50.0f
#define	LINES						312.0f
#define	DOT_CLOCK					228.0f
#define	TAPE_SAMPLE_RATE			44100.0f

#define	TAPE_COUNT					((DOT_CLOCK*LINES*MACHINE_FPS)/TAPE_SAMPLE_RATE)


extern	int		g_TapeFileSize;
extern	uint8	*g_pTape;
extern	uint8	*g_pCurrentTape;
extern	int		g_SampleStart;
extern	int		g_TapeCountCheck;
extern	int		g_TapeSoFar;



extern	int	KeysPressed[1024];
extern	unsigned int	TIMER1_ACTIVE;			// timer 1 active? (0=yes)
extern	unsigned int	Timer1Value;			// master reset value
extern	unsigned int	Timer1;					// current Timer value
extern	unsigned int	TimerTemp;				// temp reset checking value
extern	unsigned int	TIMER2_ACTIVE;			// timer 2 active? (0=yes)
extern	unsigned int	Timer2;					// current Timer 2 value
extern	unsigned int	TIMER3_ACTIVE;			// timer 3 active? (0=yes)
extern	unsigned int	Timer3;					// current Timer 3 value


extern	int		g_YScrollingFudge;

extern	void ResetScreen( void );

extern	int	Len (char *pStr);
extern	void InitMachine ( );
//extern	void ProcessScanLine( uint8 *pScreen);
extern	void ProcessScanLine( uint8 *pScreen, int frame);
extern	void DoCursor( uint8 *pV );
extern	void DoVBlankStuff( uint8 *pV );
extern	void DrawScanLine(uint8 *V );

extern	int PressKey( int key );
extern	int	ReleaseKey( int key );
extern	int ProcessSingleTick( void );


#endif