#ifdef __cplusplus
extern "C" {
#endif

//
// Our bits and bobs header file...
//
#include <md.h>

//
// This messy little section defines a "pointer" calling 
// convention so both the Library AND the DLL caller can
// use the same header files!
//
#ifdef	_EXTERN_
#undef	_EXTERN_
#endif

#ifdef	_L_
#undef	_L_
#endif

#ifdef	_R_
#undef	_R_
#endif

/*#ifdef	_NOT_DLL_EXTERN_		// backup just in case....
#define _EXTERN_		extern
#else
#define _EXTERN_
#endif
*/
#ifdef	_NOT_EXTERN_
#define _EXTERN_
#else
#define _EXTERN_		extern
#endif

#ifdef	_NOT_DLL_
#define	_L_
#define	_R_
#else
#define	_L_		(*
#define	_R_		)
#endif



#ifndef	__MY_HEADER_FILE__	
#define	__MY_HEADER_FILE__	1

#define	DMA_MALLOC			malloc
#define	DMA_FREE(n1)		{ free(n1); n1=NULL; }

//
// Colour bar details... aaron still needs it!
//
#define	ColourNo		0x3c8
#define	ColourAttr	0x3c9

//
// replacements for ands and ors etc..
// NOTE: NOT is now "!" which has replaced "!="

#define	AND			&&
#define	OR				||
#define NOT                     !
#define	XOR			^
#define	EOR			^

#ifndef TRUE
#define	TRUE			255
#endif

#ifndef FALSE
#define	FALSE			0
#endif

//
// This is a small macro to load a DLL function and check for 
// errors. Then it returns with -1
//
#define LoadFunction(hDLL,Var,Name) \
	(FARPROC) Var =GetProcAddress(hDLL, (LPCSTR)Name);					\
	if (!Var){															\
		char s[120];													\
		sprintf( s,"Can't Find Function Called %s", Name );				\
		MessageBox ( NULL, s, "Error Patching DLL Function", MB_OK);	\
		FreeLibrary( hDLL );											\
		return	-1;														\
	}


#define DLL_LOADING_ERROR(pName)										\
		sprintf(s,"Error can't load DLL file: %s",pName);				\
		MessageBox (NULL, &(s[0]),"Error Loading DLL.",MB_OK);			\
		return -1;

// ************************************************************************************
//
// SAFE is used to switch off things like fround, to use the type case (int32) instead.
//
// ************************************************************************************
#ifndef DRAGON
//#define	SAFE
#else
#define	SAFE
#endif

#define	FRACTION(x)	(x-floor(x))			// return the fraction of a FLOAT

//***************************************************************
//																*
//   Name    :	fround											*
//				froundsafe										*
//   Function:	round a float to an INT quickly!				*
//																*
//   In   : i	  = float to round								*
//   Out  : int32 = rounded answer								*
//																*
//***************************************************************
#ifdef	SAFE
#define	fround(f)		((int32) f)
#define	froundsafe(f)	((int32) f)
#else
int32 __inline fround (float i)
{
	int	a;
	
	_asm {
		fld		i			// 1 cycle - Load float into FPU
		fistp	a			// 6 cycles- Save float top INT
	}
	return a;
}
int32 __inline froundsafe (float i)
{
	int	a;
	float	tempfloat;
	
	_asm {
		fstp	tempfloat	// 1 cycle - save stack
		fld		i			// 1 cycle - Load float into FPU
		fistp	a			// 6 cycles- Save float top INT
		fld		tempfloat	// 1 cycle - restore stack
	}
	return a;
}
#endif


// *******************************************************************************
//
// This section allows us to type in BINARY numbers at have them converted
// at compile type. (i.e. BIN(1111000011110000) will compile directly to
// 0xf0f0 or 61680
//
// NOTE: Only 16Bit binary. 32 bit must be entered as BINL(numberHI,numberLO)
//       Also, as "C" uses 0dddddd as Octal (ie 0200=128) you can't have leading zeros
//       so you must avoid BIN(0000000100000001) as this gives the WRONG answer.
//       Any bits over 16 will be ignored. so 10000000000000000=0
//       Use bit 17 IF you want to display leading zeros
//
// *******************************************************************************
#define	DIG(basenumber,divnumber,shift) ((uint32) \
	( ((basenumber%divnumber)/(divnumber/10))<<shift) )

#define BINB(i) (uint32) ( \
	DIG (i,10,0)+				\
	DIG (i,100,1)+			\
	DIG (i,1000,2)+			\
	DIG (i,10000,3)+			\
	DIG (i,100000,4)+			\
	DIG (i,1000000,5)+			\
	DIG (i,10000000,6)+			\
	DIG (i,100000000,7))

#define BIN(i) (uint32) ( \
	BINB(i%100000000)+		\
	(BINB(i/100000000)<<8) )

#define BINL(i,i2) (uint32) ( \
	(BIN(i2%10000000000000000)&0xffff)+ \
	((BIN(i%10000000000000000)&0xffff)<<16))

// *******************************************************************************


#endif
#ifdef __cplusplus
}
#endif
