#define DMA_BUF_SIZE    8192
#define DMA8_FF_REG      0xC
#define DMA8_MASK_REG    0xA
#define DMA8_MODE_REG    0xB
#define DMA16_FF_REG    0xD8
#define DMA16_MASK_REG  0xD4
#define DMA16_MODE_REG  0xD6

#define DMA0_ADDR        0
#define DMA0_COUNT       1
#define DMA0_PAGE     0x87
#define DMA1_ADDR        2
#define DMA1_COUNT       3
#define DMA1_PAGE     0x83
#define DMA3_ADDR        6
#define DMA3_COUNT       7
#define DMA3_PAGE     0x82
#define DMA5_ADDR     0xC4
#define DMA5_COUNT    0xC6
#define DMA5_PAGE     0x8B
#define DMA6_ADDR     0xC8
#define DMA6_COUNT    0xCA
#define DMA6_PAGE     0x89
#define DMA7_ADDR     0xCC
#define DMA7_COUNT    0xCE
#define DMA7_PAGE     0x8A

#define DSP_BLOCK_SIZE            0x0048
#define DSP_DATA_AVAIL               0xE
#define DSP_HALT_SINGLE_CYCLE_DMA 0x00D0
#define DSP_READ_PORT                0xA
#define DSP_READY                   0xAA
#define DSP_RESET                    0x6
#define DSP_TIME_CONSTANT         0x0040
#define DSP_WRITE_PORT               0xC
#define DSP_VERSION                    0xE1

#define AUTO_INIT                   1
#define FAIL                        0
#define FALSE                       0
#define MASTER_VOLUME            0x22
#define MIC_VOLUME               0x0A
#define MIXER_ADDR                0x4
#define MIXER_DATA                0x5
#define MONO                        0
#define PIC_END_OF_INT           0x20
#define PIC_MASK                 0x21
#define PIC_MODE                 0x20
#define SUCCESS                     1
#define SINGLE_CYCLE                0
#define STEREO                      1
//#define TRUE                        1
#define VOICE_VOLUME             0x04


	extern	volatile	uint32			SB_ready;	// 0 = sample STOP, 1 = sample playing
	extern	uint32	SB_ON;
	extern	uint32	BufferList[2];			// 2 rotating sample buffers
	extern	uint32	SBNextFrameReady;		// ready for NEXT frame (waiting on TIMER)
	extern	uint32	SBcount;
	extern	uint32	TIMECONST;
	extern	uint32	BUFFER_SIZE;
	extern	uint8		*pBuffer1;	// TED samples
	extern	uint8		*pBuffer2;	// TED samples
	extern	uint8		*pBuffer3;	// SID samples
	extern	uint8		*pBuffer4;	// SID samples
	extern	uint8		*pBuffer5;	// SID samples

	extern	int32	PLAYSAMPLE;
	extern	int32	PLAYSAMPLE2;

extern	void	StopSample	( void );
extern	void 	CopySample	( uint8 *pBuffer );
extern	void	InitSound	( void );
extern	int32	DisableSB 	( void );
extern	void Play( void );

