#ifndef	__SOUND_H__
#define __SOUND_H__


#include	<CSound.h>

#define	MIDDLEC	(4389.0f)

// 15 volume levels (should really be 255)
#define	VOLUME	   (15.0f)
#define	ATTACK	   (1)
#define	DECAY	   (2)
#define	SUSTAIN	   (3)
#define	RELEASE	   (4)
#define	VOICE_OFF	(0)


//
// Actual HARDWARE
//
typedef	struct	tSIDREG{
		uint16		pitch;
		uint16		PulseSize;
		uint8		control;
		uint8		AD;
		uint8		SR;
}tSIDREG;

//
// OUR sid data.
//
typedef	struct	tSID{
		uint32		active;		// channel active?
		int32		step;
		int32		stepdelta;
		int32		index;
		int32		samplesize;
		uint8		*pSample;
		uint8		*pBuffer;
		uint32		ADSR;			// ADSR "phase"
		int32		ADSRstep;		// ADSR volume step(delta)
		int32		ADSRvolume;		// Actual ADSR volume
		int32		TargetVolume;	// ADSR target volume
		tSIDREG		SidData;		// backup copy
}tSID;



#ifndef	__IN_SOUND__
#define	__IN_SOUND__
	extern	HANDLE			AudioMutex;
	extern	int				AudioDone;


	extern	tSID		Sid[3];
	extern	tSIDREG		*pSIDREG;
	extern	uint32		SoundActive;
	extern	uint32		TriSize;	// Triangle sample size
	extern	uint8		*pTri;		// Triangle sample base
	extern	uint32		SawSize;	// SAWtooth sample size
	extern	uint8		*pSaw;		// SAWtooth sample base
	extern	uint32		NoiSize;	// Pulse sample size
	extern	uint8		*pNoi;		// noise sample base
	extern	uint32		PulSize;	// Pulse sample size
	extern	uint8		*pPul[3];	// pulse sample base 1 for each channel


	extern	float		AttackRate[16];
	extern	float		DecayReleaseRate[16];
	extern	int32		AttackStep[16];
	extern	int32		DecayReleaseStep[16];

	extern	int32		g_HardSIDActive;		// HARDSID active?
	extern	int32		g_PlayAllSamples;	

	extern	uint8		*pTed1Buffer;
	extern	uint8		*pTed2Buffer;
	extern	uint8		*pSid1Buffer;
	extern	uint8		*pSid2Buffer;
	extern	uint8		*pSid3Buffer;
	extern	uint16		*pSampleBuffer;
	extern	uint32		g_SoundBufferIndex;


	extern	void WipeSID( void );
	extern	void DisableHardSID( void );
	extern	void InitMinus4Sound( void );
	extern	void InitSID ( void );
	extern	void FreeSID( void );
	extern	void MakePulseWave(uint8 *pPul, int16 PulseSize);
	extern	void ProcessSIDChannel(tSID *pSid, int32	channel, int32 Regoffset);
	extern	void InitChannel1( int32 address, int32 val );
	extern	void InitChannel2( int32 address, int32 val );
	extern	void InitChannel3( int32 address, int32 val );
	extern	void WriteChannelData( int32 address, int32 val);
//	extern	void InitChannel1 ( void );
//	extern	void InitChannel2 ( void );
//	extern	void InitChannel3 ( void );
	extern	void ProcessSID( int32 index );
	extern	void ProcessTEDSample( int32 index, int g_Tick );
	extern	void ProcessTEDsound( int32  sdIndex, int g_Tick );

#endif	//__IN_SOUND__



#endif //__SOUND_H__