
// ***********************************************************************************
//
// Defines needed for windows.c.... Windows.c includes this section only
//
// ***********************************************************************************

#ifndef	__WINDOWS_C_INIT_
#define	__WINDOWS_C_INIT_

#define WIN32_LEAN_AND_MEAN
#define FULL_SCREEN	FALSE

#define SCREENX 320
#define SCREENY 200
#define SCREENBPP 16

#define MY_NAME TEXT("Minus4")
#define MY_TITLE TEXT("Minus/4 For Windows V2.6")

#include <md.h>								// DMA headers

// include system, DDraw and windows headers
#include <windows.h>
#include <ddraw.h>
#include <malloc.h>
#include <string.h>
#include "cdirectinput.h"

#ifndef DRAGON
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <windowsx.h>
#include <mmsystem.h>
#include <fcntl.h>
#include <commdlg.h>							//included for joystick functions
#endif

extern char* D3DRMErrorToString( HRESULT error );

#endif


// ***********************************************************************************
//
//	Main externs from WINDOWS.C 
//
// ***********************************************************************************

#ifndef	__WINDOWS_HEADERS__
#define __WINDOWS_HEADERS__


	extern	LPDIRECTDRAW		lpDD;			// DirectDraw interface structure
	extern	LPDIRECTDRAW2		lpDD2;			// DirectDraw2 upgrade object
	extern	LPDIRECTDRAWSURFACE lpDDSPrimary;	// primary surface
	extern	LPDIRECTDRAWSURFACE lpDDSBack;		// back buffer surface
	extern	DDSURFACEDESC		ddsd;
	extern	HWND				MainWindow;		// main window
	extern	LPDIRECTDRAWCLIPPER lpClipper;		// windowed surface clipper


	extern	CDirectInput	*pJoystick;

	extern	HINSTANCE		Program;
	extern	int32			MouseX,MouseY;
	extern	uint8			MouseLButton,MouseRButton;
	extern	HCURSOR			MyCursor;
	extern	int32			Buffers;
	extern	uint32			ScreenX;
	extern	uint32			ScreenY;
	extern	uint32			ScreenBPP;
	extern	uint32			ScreenTable[1024];			// screen table (big enough for 1024 line display - increase if you need more!)
	extern	int				KeyFlags[256];					// input key flags
	extern	int				FullScreen;						// full-screen mode flag


extern	void DisplayMessage (char *msg);
extern	void GrabSurface (void);
extern	void ReleaseSurface( void );
extern	void FlipBuffers (void);
extern	BOOL GetFileName(HWND hwnd, char *pNameFilter, char *pFile, int StringSize);

#endif





