//#define WIN32_LEAN_AND_MEAN
#include <md.h>								// DMA headers
#include <windows.h>

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <direct.h>
#include "dos.h"
#include <conio.h>
#include "debug.h"


#include "All.h"
#include "6502.h"
//#include <windows.h>
#include "myprocess.h"
#include <cvideo.h>
//#include <csound.h>
#include <sound.h>

extern	char	szAutoLoad[2048];
extern	char	szRunLine[2048];
extern	int		TotalGameFrames;
extern	int		g_D64FileSize;


#define	XSIZE	(320+40)
#define	YSIZE	(200+40)
#define	YCHAROFFSET 20
#define	XCHAROFFSET 20

#define	_FF			0	 // unused
#define	_FE			1
#define	_FD			2
#define	_FB			3
#define	_F7			4
#define	_EF			5
#define	_DF			6
#define	_BF			7
#define	_7F			8


// *******************************************************************
// Tape loader constants
// *******************************************************************
#define  _1MHZ						0
#define  _1_78MHZ					1
#define	TONESIZE					144

#define	FPS							50.0f
#define	LINES						312.0f
#define	DOT_CLOCK					228.0f
#define	TAPE_SAMPLE_RATE			44100.0f

#define	TAPE_COUNT					((DOT_CLOCK*LINES*FPS)/TAPE_SAMPLE_RATE)

extern	int		g_TimerDelay1;



//	public	int	AutoLoadFile=0;
	char	*pGameToLoad;
	char	*pROMToLoad;

	int	SamplePhase=0;
	
	unsigned int	TIMER1_ACTIVE=0;			// timer 1 active?
	unsigned int	Timer1Value=0xffff0000;		// master reset value
	unsigned int	Timer1=0xffff0000;			// current Timer value
	unsigned int	TimerTemp;					// temp reset checking value

	unsigned int	TIMER2_ACTIVE=0;			// timer 2 active?
	unsigned int	Timer2=0xffff0000;			// current Timer 2 value
	unsigned int	TIMER3_ACTIVE=0;			// timer 3 active?
	unsigned int	Timer3=0xffff0000;			// current Timer 3 value

	int		g_YScrollingFudge = 0;
	//
	// Tape loading variables
	//
	int		g_TapeFileSize = 0;
	uint8	*g_pTape = NULL;
	uint8	*g_pCurrentTape = NULL;
	int		g_SampleStart = 0;
	int		g_TapeCountCheck = 0;
	int		g_TapeSoFar = 0;

	int		g_IRQTimer  = 0;
	int		g_SreenBlanked = 0;
	int		LineCycles,CyclesPerScanLine,NextCycles;
	int		RasterLine;
	int		ThisLine=0;
	int		test=0;
	int		CharacterRasterLine=0;
	int		ScreenLine=0,ScreenLineIndex=0;
	int		CharLine=0;
	int		FlashCount=0;
	int		frame=0;
	int		CYCLES_PER_LINE;
	uint8	Screen[360*240];
	uint8	*V=Screen;

	int		DMAChars[40];
	int		DMAAttrib[40];

	char	C_Table[] = {"@ABCDEFGHIJKLMNOPQRSTUVWXYZ[|].. !\"#$%&'()*+,-./0123456789:;<=>?-ABCDEFGHIJKLMNOPQRSTUVWXYZ                                                                                                     -                                                             "};

	int		KeyList[]={
				  1,_FD,			// SHIFT

				  10,_BF,			// ESC
				  11,_7F,			// Control

				  2,_FE,			// F1
				  3,_FE,			// F2
				  4,_FE,			// F3
				  5,_FE,			// F4
				  6,_FE,			// 
				  7,_7F,			// 

				  20,_DF,			// up
				  21,_DF,			// down
				  22,_BF,			// left
				  23,_BF,			// right
				  
				  9,_7F,
				  8,_FE,			// Delete

				  '*',_BF,			//

				']',_BF,
				'[',_DF,
				',',_DF,
				'.',_DF,
				'/',_BF,
				'@',_FE,
				';',_BF,			
				'=',_BF,
				'-',_DF,
				'+',_BF,
				'A',_FD,
				'B',_F7,
				'C',_FB,
				'D',_FB,
				'E',_FD,
				'F',_FB,
				'G',_F7,
				'H',_F7,
				'I',_EF,
				'J',_EF,
				'K',_EF,
				'L',_DF,
				'M',_EF,
				'N',_EF,
				'O',_EF,
				'P',_DF,
				'Q',_7F,
				'R',_FB,
				'S',_FD,
				'T',_FB,
				'U',_F7,
				'V',_F7,
				'W',_FD,
				'X',_FB,
				'Y',_F7,
				'Z',_FD,
				' ',_7F,
				 13,_FE,
				
				'1',_7F,
				'2',_7F,
				'3',_FD,
				'4',_FD,
				'5',_FB,
				'6',_FB,
				'7',_F7,
				'8',_F7,
				'9',_EF,
				'0',_EF,

				255,0x0};


	int	KeysPressed[1024];


	// *******************************************************************
	//
	// These strings are used to calculate "ff1e" lookup tables, and processor
	// cycles per line.
	//
	// End of horizontal blank is $D0, so $ff1e starts there each line
	//
	// p = Processor works
	// * = Processor can write
	// - = Empty
	// S = TED fetches memory (0th line=character number, 7th=Char attribute)
	// F = TED fetches FONT memeory
	// R = TED refreshes RAM
	//
	// CCCCCCDDDDDDDDEE00000000111111112222222233333333444444445555555566666666777777778888888899999999AAAAAAAABBBBBBBBCC
	// 468ACE02468ACE0202468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02

	// *******************************************************************
	//char		FastDMA[114]    ="pppp-*-*-*-SFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFpRpRpRpRpRppppppppppppp";
	//char		SlowDMA[114]    ="-p-p-*-*-*-SFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFpRpRpRpRpRp-p-p-p-p-p-p";
	char	FastDMA[115]={"pppp-p-p-p-SFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFpRpRpRpRpRppppppppppppp"};
	char	SlowDMA[115]={"-p-p-p-p-p-SFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFSFpRpRpRpRpRp-p-p-p-p-p-p"};
	char	FastNormal[115]={"pppp-p-p-p-pFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpRpRpRpRpRppppppppppppp"};
	char	SlowNormal[115]={"-p-p-p-p-p-pFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpFpRpRpRpRpRp-p-p-p-p-p-p"};
	char	FastBoarder[115]={"ppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppRpRpRpRpRppppppppppppp"};
	char	SlowBoarder[115]={"-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-p-pRpRpRpRpRp-p-p-p-p-p-p"};

	int		tfastdma[114];			// table
	int		cfastdma;				// count
	int		tslowdma[114];
	int		cslowdma;
	int		tfastnormal[114];
	int		cfastnormal;
	int		tslownormal[114];
	int		cslownormal;
	int		tfastboarder[114];
	int		cfastboarder;
	int		tslowboarder[114];
	int		cslowboarder;
	char	*pCurrentFF1E_Text;
	int		*pCurrentFF1E;
	int		ff1e_old;         // char counter..

#define	true	1
#define	false	0

int PressKey( int key )
{
	switch (key){
		case 0x26:	KeysPressed[20]=0xf7; break;		// UP
		case 0x28:	KeysPressed[21]=0xfe; break;		// DOWN
		case 0x25:	KeysPressed[22]=0xfe; break;		// LEFT
		case 0x27:	KeysPressed[23]=0xf7; break;		// RIGHT

		case 17:	KeysPressed[11]=0xfb; break;		// Control
		case 0xdc:	KeysPressed[7]=0xdf; break;			// C=
		case 0x10:	KeysPressed[01]=0x7f; break;		// Shift
//		case 223:	KeysPressed[10]=0xef; break;		// Escape
		case VK_ESCAPE:	KeysPressed[10]=0xef; break;		// Escape
		case 0x6a:	KeysPressed['*']=0xfd; break;		// *
		case 0xc0:	KeysPressed['@']=0x7f; break;		// @
		case 0xba:	KeysPressed[6]=0xfb; break;		// 
		case 0xbd:	KeysPressed['-']=0xbf; break;		// -
		case 0xbb:	KeysPressed['=']=0xdf; break;		// =
		case 0x6b:	KeysPressed['+']=0xbf; break;		// +
		case 0x6d:	KeysPressed['-']=0xbf; break;		// -
	
		case VK_F1:	KeysPressed[2]=0xef; break;
		case VK_F2:	KeysPressed[3]=0xdf; break;
		case VK_F3:	KeysPressed[4]=0xbf; break;
		case VK_F4:	KeysPressed[5]=0xf7; break;

		case 0x3ed:	KeysPressed[20]=0xfe; break;	// UP
		case 0x3ec:	KeysPressed[21]=0xf7; break;	// DOWN
		case 0x3ee:	KeysPressed[22]=0xfe; break;	// LEFT
		case 0x3ef:	KeysPressed[23]=0xf7; break;	// RIGHT

		case 0x9:	KeysPressed[0x9]=0x7f; break;

		case 0x8:	KeysPressed[0x8]=0xfe; break;
		case 0xdb:	KeysPressed['[']=0xdf; break;	// [
		case 0xdd:	KeysPressed[']']=0xfb; break;	// ]
		case '<':
		case 0xbc:	KeysPressed[',']=0x7f; break;	// ,
		case '>':
		case 0xbe:	KeysPressed['.']=0xef; break;	// .
		case 0xbf:	KeysPressed['/']=0x7f; break;	// ?
		case '@':	KeysPressed['@']=0x7f; break;
		case ';':	KeysPressed[';']=0xfd; break;
		case '=':	KeysPressed['=']=0xdf; break;
		case '-':	KeysPressed['-']=0xbf; break;
		case '+':	KeysPressed['+']=0xbf; break;
		case 'a':
		case 'A':   KeysPressed['A']=0xfb; break;
		case 'b':
		case 'B':   KeysPressed['B']=0xef; break;
		case 'c':
		case 'C':	KeysPressed['C']=0xef; break;
		case 'd':
		case 'D':   KeysPressed['D']=0xfb; break;
		case 'e':
		case 'E':	KeysPressed['E']=0xbf; break;
		case 'f':
		case 'F':   KeysPressed['F']=0xdf; break;
		case 'g':
		case 'G':   KeysPressed['G']=0xfb; break;
		case 'h':
		case 'H':   KeysPressed['H']=0xdf; break;
		case 'i':
		case 'I':   KeysPressed['I']=0xfd; break;
		//case 'j':
		case 'J':    KeysPressed['J']=0xfb; break;
		case 'K':    KeysPressed['K']=0xdf; break;
		case 'l':
		case 'L':    KeysPressed['L']=0xfb; break;
		case 'M':    KeysPressed['M']=0xef; break;
		case 'n':
		case 'N':    KeysPressed['N']=0x7f; break;
		case 'o':
		case 'O':    KeysPressed['O']=0xbf; break;
		case 'P':    KeysPressed['P']=0xfd; break;
		case 'Q':    KeysPressed['Q']=0xbf; break;
		case 'R':    KeysPressed['R']=0xfd; break;
		case 'S':    KeysPressed['S']=0xdf; break;
		case 't':
		case 'T':    KeysPressed['T']=0xbf; break;
		case 'u':
		case 'U':    KeysPressed['U']=0xbf; break;
		case 'v':
		case 'V':    KeysPressed['V']=0x7f; break;
		case 'w':
		case 'W':    KeysPressed['W']=0xfd; break;
		case 'x':
		case 'X':    KeysPressed['X']=0x7f; break;
		case 'y':
		case 'Y':    KeysPressed['Y']=0xfd; break;
		case 'z':
		case 'Z':    KeysPressed['Z']=0xef; break;
		case '!':
		case '1':	 KeysPressed['1']=0xfe; break;
		case '"':
		case '2':	 KeysPressed['2']=0xf7; break;
		case '#':
		case '3':	 KeysPressed['3']=0xfe; break;
		case '$':
		case '4':	 KeysPressed['4']=0xf7; break;
		case '5':	 KeysPressed['5']=0xfe; break;
		case '^':
		case '6':	 KeysPressed['6']=0xf7; break;
		case '7':	 KeysPressed['7']=0xfe; break;
		case '*':
		case '8':	 KeysPressed['8']=0xf7; break;
		case '9':	 KeysPressed['9']=0xfe; break;
		case '0':	 KeysPressed['0']=0xf7; break;
		case ' ':    KeysPressed[' ']=0xef; break;
		case '\n':
		case '\r':   KeysPressed[13]=0xfd; break;		// enter
	}
	return true;
} 

	
	
	
int	ReleaseKey( int key )
{
	switch (key){
		case 0x26:	KeysPressed[20]=0xff; break;		// UP
		case 0x28:	KeysPressed[21]=0xff; break;		// DOWN
		case 0x25:	KeysPressed[22]=0xff; break;		// LEFT
		case 0x27:	KeysPressed[23]=0xff; break;		// RIGHT

		case 17:	KeysPressed[11]=0xff; break;		// Control
//		case 223:	KeysPressed[10]=0xff; break;		// Escape
		case VK_ESCAPE:	KeysPressed[10]=0xff; break;		// Escape
		case 0xdc:	KeysPressed[7]=0xff; break;			// C=
		case 0x10:	KeysPressed[01]=0xff; break;		// Shift
		case 0x6a:	KeysPressed['*']=0xff; break;		// *
		case 0xc0:	KeysPressed['@']=0xff; break;		// @
		case 0xba:	KeysPressed[6]=0xff; break;		// 
		case 0xbd:	KeysPressed['-']=0xff; break;		// -
		case 0xbb:	KeysPressed['=']=0xff; break;		// =
		case 0x6b:	KeysPressed['+']=0xff; break;		// +
		case 0x6d:	KeysPressed['-']=0xff; break;		// +

		case VK_F1:	KeysPressed[2]=0xff; break;
		case VK_F2:	KeysPressed[3]=0xff; break;
		case VK_F3:	KeysPressed[4]=0xff; break;
		case VK_F4:	KeysPressed[5]=0xff; break;

		case 0x3ed:	KeysPressed[20]=0xff; break;	// UP
		case 0x3ec:	KeysPressed[21]=0xff; break;	// DOWN
		case 0x3ee:	KeysPressed[22]=0xff; break;	// LEFT
		case 0x3ef:	KeysPressed[23]=0xff; break;	// RIGHT

		case 0x9:	KeysPressed[0x9]=0xff; break;
		case 0x8:	KeysPressed[0x8]=0xff; break;
		case 0xdb:	KeysPressed['[']=0xff; break;	// [
		case 0xdd:	KeysPressed[']']=0xff; break;	// ]
		case '<':
		case 0xbc:	KeysPressed[',']=0xff; break;
		case '>':
		case 0xbe:	KeysPressed['.']=0xff; break;	// .
		case 0xbf:	KeysPressed['/']=0xff; break;	// ?
		case '@':	KeysPressed['@']=0xff; break;
		case ';':	KeysPressed[';']=0xff; break;
		case '=':	KeysPressed['=']=0xff; break;
		case '-':	KeysPressed['-']=0xff; break;
		case '+':	KeysPressed['+']=0xff; break;
		case 'a':
		case 'A':    KeysPressed['A']=0xff; break;
		case 'b':
		case 'B':    KeysPressed['B']=0xff; break;
		case 'c':
		case 'C':    KeysPressed['C']=0xff; break;
		case 'd':
		case 'D':    KeysPressed['D']=0xff; break;
		case 'e':
		case 'E':    KeysPressed['E']=0xff; break;
		case 'f':
		case 'F':    KeysPressed['F']=0xff; break;
		case 'g':
		case 'G':    KeysPressed['G']=0xff; break;
		case 'h':
		case 'H':    KeysPressed['H']=0xff; break;
		case 'i':
		case 'I':    KeysPressed['I']=0xff; break;
		case 'J':    KeysPressed['J']=0xff; break;
		case 'K':    KeysPressed['K']=0xff; break;
		case 'l':
		case 'L':    KeysPressed['L']=0xff; break;
		case 'M':    KeysPressed['M']=0xff; break;
		case 'n':
		case 'N':    KeysPressed['N']=0xff; break;
		case 'o':
		case 'O':    KeysPressed['O']=0xff; break;
		case 'P':    KeysPressed['P']=0xff; break;
		case 'Q':    KeysPressed['Q']=0xff; break;
		case 'R':    KeysPressed['R']=0xff; break;
		case 'S':    KeysPressed['S']=0xff; break;
		case 't':
		case 'T':    KeysPressed['T']=0xff; break;
		case 'u':
		case 'U':    KeysPressed['U']=0xff; break;
		case 'v':
		case 'V':    KeysPressed['V']=0xff; break;
		case 'w':
		case 'W':    KeysPressed['W']=0xff; break;
		case 'x':
		case 'X':    KeysPressed['X']=0xff; break;
		case 'y':
		case 'Y':    KeysPressed['Y']=0xff; break;
		case 'z':
		case 'Z':    KeysPressed['Z']=0xff; break;
		case '!':
		case '1':	 KeysPressed['1']=0xff; break;
		case '"':
		case '2':	 KeysPressed['2']=0xff; break;
		case '#':
		case '3':	 KeysPressed['3']=0xff; break;
		case '$':
		case '4':	 KeysPressed['4']=0xff; break;
		case '5':	 KeysPressed['5']=0xff; break;
		case '^':
		case '6':	 KeysPressed['6']=0xff; break;
		case '7':	 KeysPressed['7']=0xff; break;
		case '*':
		case '8':	 KeysPressed['8']=0xff; break;
		case '9':	 KeysPressed['9']=0xff; break;
		case ')':
		case '0':	 KeysPressed['0']=0xff; break;
		case ' ':    KeysPressed[' ']=0xff; break;
		case '\n':
		case '\r':   KeysPressed[ 13]=0xff; break;		// enter
	}
	return true;
}


//****************************************************************************
// Do a scan and pre-setup this frames keyboard table
//****************************************************************************
void ScanKeyboard( )
{
	int	i=0,v;
	Keys[0]=Keys[1]=Keys[2]=Keys[3]=Keys[4]=Keys[5]=Keys[6]=Keys[7]=Keys[8]=0xff;	//Keys[9]=Keys[10]=0xff;
	
	while (true)
	{
		v=KeyList[i];
		if (v==0xff) break;
		Keys[KeyList[i+1]]&=KeysPressed[v];
		i+=2;
	}
}


//****************************************************************************
// Init scanline counter... ($FF1E)
//****************************************************************************
int CountFF1E (char *pTable, int *pFF1E)
{
	int	i,index;
	int	count;
	
	count=0xd0;		//End of HBlank (old - 0xc4);			// start of SCAN line
	index=0;
	for (i=0;i<114;i++){
		if (pTable[i]=='p'){
			pFF1E[index]=count;
			index++;
		}
		count+=2;
		if (count>=0xe4) count-=0xe4;
	}
	return	index;
}


//****************************************************************************
// Count cycles per scanline and workout $FF1E at every CPU cycle
//****************************************************************************
void InitFF1e ( )
{
	cfastdma=CountFF1E (FastDMA,tfastdma);
	cslowdma=CountFF1E (SlowDMA,tslowdma);
	cfastnormal=CountFF1E (FastNormal,tfastnormal);
	cslownormal=CountFF1E (SlowNormal,tslownormal);
	cfastboarder=CountFF1E (FastBoarder,tfastboarder);
	cslowboarder=CountFF1E (SlowBoarder,tslowboarder);
}

//****************************************************************************
// Do stuff that gets done ONCE a frame... 
//****************************************************************************
void DoVBlankStuff( uint8 *V )
{
	ScanKeyboard();
}


//****************************************************************************
// init the plus/4 machine state 
//****************************************************************************
void InitMachine( )
{
	int	i;
		
	//AutoLoadFile=0;				// do NOT autoload a game
	//GameToLoad="";			// nothing to load

	LineCycles=0;
	RasterLine=0;
	NextCycles=0;
	CyclesPerScanLine=100;
	CYCLES_PER_LINE=109;
	ThisLine=0;
	CharacterRasterLine=0;
	ScreenLine=0;
	ScreenLineIndex=0;
	CharLine=0;

	for (i=0;i<1024;i++){
		KeysPressed[i]=0xff;
	}

	//cpu = new process();
	POKE( 0xff08, 0xff);
	pROM[0x7f08]=0xff;
	Keys[0]=Keys[1]=Keys[2]=Keys[3]=Keys[4]=Keys[5]=Keys[6]=Keys[7]=Keys[8]=Keys[9]=Keys[10]=0xff;
	InitFF1e();
	CYCLES_PER_LINE=cfastnormal;					// fast normal=65
	pCurrentFF1E=tfastnormal;
	pCurrentFF1E_Text = &FastNormal[0];
}


//****************************************************************************
// Load a file from a URL
//****************************************************************************
void LoadPRG (char *s, int *pMem, int address )
{
//	if (ad==-1){
//		DOKE(0x2b,0x1001);
//		DOKE(0x2d,StartAdd+size);
//		DOKE(0x9d,StartAdd+size);
//	}
}


//****************************************************************************
// Enter text into the plus/4 keyboard buffer, so we can auto RUN a GAME
//****************************************************************************
void RunIt( )
{
	int		a,i;
	
	if( szRunLine[0] == 0x00 ){
		strcpy(szRunLine,"run");
	}

	Poke(0xef,Len(szRunLine)+1);							// set buffer size+RET
	for (i=0;i<Len(szRunLine);i++){
		a=szRunLine[i];
		if ((a>='a') && (a<='z')){
			a-=32;
		}
		Poke(0x527+i,a);		// set buffer size
	}
	Poke(0x527+Len(szRunLine),0xd);		// set buffer size
}


//****************************************************************************
// Draw the cursor last... temp.. should be per scanline
//****************************************************************************
void DoCursor( uint8 *pV )
{
	int	x=0,y=0,index;

	if ((FlashCount&0x10)==0) return;
	
	index=pMemory[0xff0d]+((pMemory[0xff0c]&0x3)<<8);
	if (index>=1000) return;

	y=index/40;
	x=index%40;

	index=(((y*8)+24)*XSIZE) + ((x*8)+20);
	for (y=0;y<8;y++){
		for (x=0;x<8;x++){
			pV[index++]=0x0;
		}
		index+=(XSIZE-8);
	}
}

//****************************************************************************
// Draw the BITMAP screen "scanline"
//****************************************************************************
void DrawSideBoarders(uint8 *V,int sindex)
{
	int	col0;
	
	col0=pMemory[0xff19];			// get boarder colour
	V[sindex]=V[sindex+1]=V[sindex+2]=V[sindex+3]=V[sindex+4]=
	V[sindex+5]=V[sindex+6]=V[sindex+7]=V[sindex+8]=V[sindex+9]=
	V[sindex+10]=V[sindex+11]=V[sindex+12]=V[sindex+13]=V[sindex+14]=
	V[sindex+15]=V[sindex+16]=V[sindex+17]=V[sindex+18]=V[sindex+19]=col0;

	sindex+=20;
	// Draw extra bits for SMOOTH scroll window
	if ((pMemory[0xff07]&8)==0){
		V[sindex]=V[sindex+1]=V[sindex+2]=V[sindex+3]=
		V[sindex+4]=V[sindex+5]=V[sindex+6]=V[sindex+7]=col0;
		sindex+=(XSIZE-56+8);
		V[sindex]=V[sindex+1]=V[sindex+2]=V[sindex+3]=
		V[sindex+4]=V[sindex+5]=V[sindex+6]=V[sindex+7]=col0;
		sindex+=8;
	}else{
		sindex+=(XSIZE-40);
	}

	// and right hand side
	V[sindex]=V[sindex+1]=V[sindex+2]=V[sindex+3]=V[sindex+4]=
	V[sindex+5]=V[sindex+6]=V[sindex+7]=V[sindex+8]=V[sindex+9]=
	V[sindex+10]=V[sindex+11]=V[sindex+12]=V[sindex+13]=V[sindex+14]=
	V[sindex+15]=V[sindex+16]=V[sindex+17]=V[sindex+18]=V[sindex+19]=col0;
}


//****************************************************************************
// Draw the BITMAP screen "scanline"
//****************************************************************************
void DrawBitMapScreen(uint8 *V)
{
	int	charscreen,i,sindex,sindex2;
	int	b;
	int	bitmap,c1,c2,col0,col1,col2,col3;

	sindex2=sindex=ScreenLineIndex+XCHAROFFSET;	//+(YCHAROFFSET*XSIZE);
	sindex+=(pMemory[0xff07]&07);	// smooth scroll on "X"
//	charscreen=(((pMemory[0xff14]&0xf8)<<8))+CharLine;

	b = (CharacterRasterLine - (pMemory[0xff06]&0x7)  ) &7;
	charscreen=(((pMemory[0xff14]&0xf8)<<8))+CharLine;
	
	// get bitmap memory index
	bitmap =((pMemory[0xff12]&0x38)<<10);		// move bits to the TOP
	bitmap+=(CharLine*8)+b;		//CharacterRasterLine;	// get bit map index...
	
	
	// Multi colour mode bitmap enabled?
	if ((pMemory[0xff07]&0x10)==0){
	  for (i=0;i<40;i++){
				
		b=pMemory[bitmap];							// get base address of character data (FONT)
		bitmap+=8;

		c1=pMemory[charscreen];					// get data from LUMINANCE map (normal colour screen)
		c2=pMemory[charscreen+0x400];			// get data from COLOUR map	   (normal character screen)
		charscreen++;
		col0=(c1&0xf0)|(c2&0x0f);
		col1=((c1&0x0f)<<4)|((c2&0xf0)>>4);
		if (b==0){
			V[sindex]=  V[sindex+1]=V[sindex+2]=V[sindex+3]=
			V[sindex+4]=V[sindex+5]=V[sindex+6]=V[sindex+7]=col0;
			sindex+=8;
		}else if (b==255){
			V[sindex]=  V[sindex+1]=V[sindex+2]=V[sindex+3]=
			V[sindex+4]=V[sindex+5]=V[sindex+6]=V[sindex+7]=col1;
			sindex+=8;
		}else {
			if ((b&0x80)==0) V[sindex++]=col0;	else V[sindex++]=col1;
			if ((b&0x40)==0) V[sindex++]=col0;	else V[sindex++]=col1;
			if ((b&0x20)==0) V[sindex++]=col0;	else V[sindex++]=col1;
			if ((b&0x10)==0) V[sindex++]=col0;	else V[sindex++]=col1;
			if ((b&0x8)==0)  V[sindex++]=col0;	else V[sindex++]=col1;
			if ((b&0x4)==0)  V[sindex++]=col0;	else V[sindex++]=col1;
			if ((b&0x2)==0)  V[sindex++]=col0;	else V[sindex++]=col1;
			if ((b&0x1)==0)  V[sindex++]=col0;	else V[sindex++]=col1;
		}
	  }
	}else{
	  col0=pMemory[0xff15]&0xff;
	  col3=pMemory[0xff16]&0xff;
	  for (i=0;i<40;i++){
				
		b=pMemory[bitmap];							// get base address of character data (FONT)
		bitmap+=8;
		if (b==0){
			charscreen++;
			V[sindex]=  V[sindex+1]=V[sindex+2]=V[sindex+3]=
			V[sindex+4]=V[sindex+5]=V[sindex+6]=V[sindex+7]=col0;
			sindex+=8;
		}else{
			c1=pMemory[charscreen];					// get data from LUMINANCE map (normal colour screen)
			c2=pMemory[charscreen+0x400];			// get data from COLOUR map	   (normal character screen)
			charscreen++;
			col2=(c1&0xf0)|(c2&0x0f);
			col1=((c1&0x0f)<<4)|((c2&0xf0)>>4);
			switch (b&0xc0){
				case 0x00:	V[sindex]=V[sindex+1]=col0;break;
				case 0x40:	V[sindex]=V[sindex+1]=col1;break;
				case 0x80:	V[sindex]=V[sindex+1]=col2;break;
				default:	V[sindex]=V[sindex+1]=col3;break;
			}
			switch (b&0x30){
				case 0x00:	V[sindex+2]=V[sindex+3]=col0;break;
				case 0x10:	V[sindex+2]=V[sindex+3]=col1;break;
				case 0x20:	V[sindex+2]=V[sindex+3]=col2;break;
				default:	V[sindex+2]=V[sindex+3]=col3;break;
			}
			switch (b&0x0c){
				case 0x00:	V[sindex+4]=V[sindex+5]=col0;break;
				case 0x04:	V[sindex+4]=V[sindex+5]=col1;break;
				case 0x08:	V[sindex+4]=V[sindex+5]=col2;break;
				default:	V[sindex+4]=V[sindex+5]=col3;break;
			}
			switch (b&0x03){
				case 0x00:	V[sindex+6]=V[sindex+7]=col0;break;
				case 0x01:	V[sindex+6]=V[sindex+7]=col1;break;
				case 0x02:	V[sindex+6]=V[sindex+7]=col2;break;
				default:	V[sindex+6]=V[sindex+7]=col3;break;
			}
			sindex+=8;
		}
	  }
	}
	DrawSideBoarders(V,sindex2-XCHAROFFSET);
}

	
//****************************************************************************
// Drawing for HIRES characters here. 
//****************************************************************************
void DrawHiresChars(int *chdata,int charset,int charscreen,int sindex,uint8 *V)
{
	int	i,b;
	int	col0,col1,col2;
	int	Cursor;
	int	flash = 1;


	if ((FlashCount&0x10)==0) flash = 0;

	Cursor = pMemory[0xff0d] | ((pMemory[0xff0c]&3)<<8);
	col0=pMemory[0xff15]&0xff;		// Reverse OFF (256 chars avail)
	for (i=0;i<40;i++){
				
		// if character map screen
		//b=pMemory[charscreen++];
		b=DMAChars[i];

		// Check for REVERSE, and flip colours if we ARE reversed
		if (b<127){
			col2=col0;
//			col1=pMemory[charscreen-0x401];				// get colour from colour screen
			col1=DMAAttrib[i];
		}else{
			if ((pMemory[0xff07]&0x80)!=0){
				col2=col0;
				//col1=pMemory[charscreen-0x401];				// get colour from colour screen
				col1=DMAAttrib[i];
			}else{
				col1=col0;
				//col2=pMemory[charscreen-0x401];				// get colour from colour screen
				col2=DMAAttrib[i];
				b = b &0x7f;
			}
		}

		// Draw cursor.... IF hardware cursor matches current character location.. AND flash is visible
		if( flash == 1 ){
			if( Cursor == (CharLine+i) ){
				int	a;
				a= col1;
				col1=col2;
				col2=a;
			}
		}

		b=chdata[(b*8)+charset];							// get base address of character data (FONT)
		if (b==0){
			V[sindex]=  V[sindex+1]=V[sindex+2]=V[sindex+3]=
			V[sindex+4]=V[sindex+5]=V[sindex+6]=V[sindex+7]=col2;
			sindex+=8;
		}else{
								
			if ((b&0x80)==0) V[sindex++]=col2;	else V[sindex++]=col1; 
			if ((b&0x40)==0) V[sindex++]=col2;	else V[sindex++]=col1; 
			if ((b&0x20)==0) V[sindex++]=col2;	else V[sindex++]=col1; 
			if ((b&0x10)==0) V[sindex++]=col2;	else V[sindex++]=col1; 
			if ((b&0x8)==0)  V[sindex++]=col2;	else V[sindex++]=col1; 
			if ((b&0x4)==0)  V[sindex++]=col2;	else V[sindex++]=col1; 
			if ((b&0x2)==0)  V[sindex++]=col2;	else V[sindex++]=col1; 
			if ((b&0x1)==0)  V[sindex++]=col2;	else V[sindex++]=col1;
			//sindex+=8;
		}
	}
}
//****************************************************************************
// Drawing for Extended Colour Mode characters here. 
//****************************************************************************
void DrawECMChars(int *chdata,int charset,int charscreen,int sindex,uint8 *V)
{
	int	i,b;
	int	col0,col1;
	int	flash = 1;

	V = &(V[sindex]);
	for (i=0;i<40;i++){
				
		// if character map screen
		b=DMAChars[i];
		col0=pMemory[((b>>6)&0x3)+0xff15]&0xff;		// Get ECM colour to use
		col1=DMAAttrib[i];

		b=b&0x3f;
		b=chdata[(b*8)+charset];							// get base address of character data (FONT)
		if (b==0){
			V[0]=V[1]=V[2]=V[3]=V[4]=V[5]=V[6]=V[7]=col0;
		}else{
								
			if ((b&0x80)==0) V[0]=col0;	else V[0]=col1; 
			if ((b&0x40)==0) V[1]=col0;	else V[1]=col1; 
			if ((b&0x20)==0) V[2]=col0;	else V[2]=col1; 
			if ((b&0x10)==0) V[3]=col0;	else V[3]=col1; 
			if ((b&0x8)==0)  V[4]=col0;	else V[4]=col1; 
			if ((b&0x4)==0)  V[5]=col0;	else V[5]=col1; 
			if ((b&0x2)==0)  V[6]=col0;	else V[6]=col1; 
			if ((b&0x1)==0)  V[7]=col0;	else V[7]=col1;
		}
		V+=8;
	}
}

//****************************************************************************
// Drawing for MultiColour characters here. 
//****************************************************************************
void DrawMCMChars(int	*chdata,int charset,int charscreen,int sindex,uint8 *V)
{
	int	i,b;
	int	col0,col1,col2,col3;
	
	//
	// MultiColourMode drawing here
	//
	V = &(V[sindex]);
	col0=pMemory[0xff15]&0xff;
	col1=pMemory[0xff16]&0xff;
	col2=pMemory[0xff17]&0xff;
	for (i=0;i<40;i++){
				
		// if character map screen
		b=chdata[(DMAChars[i]<<3)+charset];							// get base address of character data (FONT)
		if (b==0){
			V[0]=V[1]=V[2]=V[3]=V[4]=V[5]=V[6]=V[7]=col0;
		}else{
			col3=DMAAttrib[i];

			// Hires character?
			if ((col3&8)==0){
				col3&=~8;
				if ((b&0x80)==0) V[0]=col0;	else V[0]=col3; 
				if ((b&0x40)==0) V[1]=col0;	else V[1]=col3; 
				if ((b&0x20)==0) V[2]=col0;	else V[2]=col3; 
				if ((b&0x10)==0) V[3]=col0;	else V[3]=col3; 
				if ((b&0x8)==0)  V[4]=col0;	else V[4]=col3; 
				if ((b&0x4)==0)  V[5]=col0;	else V[5]=col3; 
				if ((b&0x2)==0)  V[6]=col0;	else V[6]=col3; 
				if ((b&0x1)==0)  V[7]=col0;	else V[7]=col3;
			}else{
				col3&=~8;
				switch (b&0xc0){
					case 0x00:	V[0]=V[1]=col0;break;
					case 0x40:	V[0]=V[1]=col1;break;
					case 0x80:	V[0]=V[1]=col2;break;
					default:	V[0]=V[1]=col3;
				}
				switch (b&0x30){
					case 0x00:	V[2]=V[3]=col0;break;
					case 0x10:	V[2]=V[3]=col1;break;
					case 0x20:	V[2]=V[3]=col2;break;
					default:	V[2]=V[3]=col3;
				}
				switch (b&0x0c){
					case 0x00:	V[4]=V[5]=col0;break;
					case 0x04:	V[4]=V[5]=col1;break;
					case 0x08:	V[4]=V[5]=col2;break;
					default:	V[4]=V[5]=col3;
				}
				switch (b&0x03){
					case 0x00:	V[6]=V[7]=col0;break;
					case 0x01:	V[6]=V[7]=col1;break;
					case 0x02:	V[6]=V[7]=col2;break;
					default:	V[6]=V[7]=col3;
				}
			}
		}
		V+=8;
	}
}


//****************************************************************************
// Draw a SCANLINE into the display buffer
//****************************************************************************
void ResetScreen( void )
{
//	int	b;
	int	a;
//	CharLine = ((pMemory[0xff1d]|(pMemory[0xff1c]&3))/8)*40;
//	b = (CharacterRasterLine - (pMemory[0xff06]&0x7)  ) &7;
//	if( b == 7 ){
//		CharLine -=40;
//	}
	//b = (CharacterRasterLine - (pMemory[0xff06]&0x7)  ) &7;
	a = g_YScrollingFudge &1;
	CharacterRasterLine = (((7-(RasterLine&7))&7)-a)&7;
	//skipit=1;
}
void DrawScanLine(uint8 *V )
{
	int	b,charscreen;

	b = (CharacterRasterLine - (pMemory[0xff06]&0x7)  ) &7;
	//if ((ScreenLine>200) || (ScreenLine<0)) return;
	
	if( ((RasterLine>=4) && (RasterLine<204)) && ((ScreenLineIndex>=0) && (ScreenLineIndex<(240*XSIZE))) ){
		int	i,charset,sindex,sindex2;
		int	*chdata,col0;

		if( (pMemory[0xff06]&0x8)== 0 ){
			if( ( RasterLine<7 ) || ( RasterLine>200 ) ){
				col0=pMemory[0xff19]&0xff;			// get boarder colour
				sindex=ScreenLineIndex;	//+(YCHAROFFSET*XSIZE);
				for (i=0;i<36;i++){
					V[sindex]=V[sindex+1]=V[sindex+2]=V[sindex+3]=
					V[sindex+4]=V[sindex+5]=V[sindex+6]=V[sindex+7]=
					V[sindex+8]=V[sindex+9]=col0;
					sindex+=10;
				}
				goto SkipRest;
			}
		}

	// ECM+MCM mode? (also ECM+MCM Bitmapmode does the same)
	if( (((pMemory[0xff06]&0x40)!=0) && ((pMemory[0xff07]&0x10)!=0)) ||
		((pMemory[0xff06]&0x60)==0x60) ) {
			sindex2=sindex=ScreenLineIndex+XCHAROFFSET;	//+(YCHAROFFSET*XSIZE);
			for (i=0;i<32;i++){
				V[sindex]=V[sindex+1]=V[sindex+2]=V[sindex+3]=
				V[sindex+4]=V[sindex+5]=V[sindex+6]=V[sindex+7]=
				V[sindex+8]=V[sindex+9]=0;			// make BLACK!
				sindex+=10;
			}
			DrawSideBoarders( V,sindex2-XCHAROFFSET );
			return;
		}


		// Screen Blanked? 
		if( g_SreenBlanked == 1 ){
			col0=pMemory[0xff19]&0xff;			// get boarder colour
			sindex=ScreenLineIndex;//+(YCHAROFFSET*XSIZE);
			for (i=0;i<36;i++){
				V[sindex]=V[sindex+1]=V[sindex+2]=V[sindex+3]=
				V[sindex+4]=V[sindex+5]=V[sindex+6]=V[sindex+7]=
				V[sindex+8]=V[sindex+9]=col0;
				sindex+=10;
			}
//			return;
			goto SkipRest;
		}


		// BITMAP mode enabled? 
		if ((pMemory[0xff06]&0x20)!=0){
			DrawBitMapScreen(V);
			goto SkipRest;
		}


		//
		// Normal character mode is enabled... so fall through...
		//
		sindex2=sindex=ScreenLineIndex+XCHAROFFSET;	//+(YCHAROFFSET*XSIZE);

//		charscreen=(((pMemory[0xff14]&0xf8)<<8)+0x400)+CharLine;		// Get Screen BASE
//		charset =  (pMemory[0xff13]<<8)+CharacterRasterLine;			// Get character set BASE address
		sindex+=(pMemory[0xff07]&07);	// smooth scroll on "X"


		//*****************  FIX interaction with $FF1D/$FF1C ************
		charscreen = (((pMemory[0xff14]&0xf8)<<8)+0x400)+CharLine;
//		b = (CharacterRasterLine + (pMemory[0xff06]&0x7)  ) &7;
		charset =  (pMemory[0xff13]<<8) + b;
		//*****************  FIX interaction with $FF1D/$FF1C ************



/*		//*****************  FIX interaction with $FF1D/$FF1C ************
		charscreen = (((pMemory[0xff14]&0xf8)<<8)+0x400)+CharLine;
		a = ((pMemory[0xff06]&0x7)-4);
		if( a<=4){
			charscreen -=80;
		}
		a = 7-a;
//		charscreen += ((RasterLine+4+a)/8)*40;

		charset =  (pMemory[0xff13]<<8);
		charset += (CharacterRasterLine + ((7-(pMemory[0xff06]&0x7)-4) &0x7) )&7;
		//*****************  FIX interaction with $FF1D/$FF1C ************
*/

		

		if ((pMemory[0xff07]&0x80)!=0){
			charset&=0xf807;
		}else{
			charset&=0xfc07;
		}
			

		// Where is charset data to be found? RAM or ROM?
		if (((pMemory[0xff12]&4)==0) || (charset<0x8000)){
			chdata=pMemory;
		} else {
			charset=charset-0x8000;
			chdata=pROM;
		}
			
		// on FIRST line of characters... DMA in next charline.. (do attrib here to.. should be line 7).
		//if( (pMemory[0xff1f]&7) == 0x00) 
		//b = (CharacterRasterLine +   ((7-(pMemory[0xff06]&0x7)-4) &0x7) )&7;
		if( b == 0 ){
			for( int i = 0;i<40; i++){
				int	ch;
				ch = (((pMemory[0xff14]&0xf8)<<8)+0x400)+((CharLine+i)&0x3ff);
				DMAChars[i] = pMemory[ch];		// get characters from charmap
				DMAAttrib[i] = pMemory[ch-0x400];				// get colour from colour screen
			}
		}
			
		// Multi Colour Mode enabled?
		if ((pMemory[0xff07]&0x10)==0){
			if((pMemory[0xff06]&0x40)==0){
				DrawHiresChars(chdata,charset,charscreen,sindex,V);		// draw HIRES character
				sindex+=320;
			}
			else{
				DrawECMChars(chdata,charset,charscreen,sindex,V);		// draw ECM character
				sindex+=320;
			}
		}else{		
			DrawMCMChars(chdata,charset,charscreen,sindex,V);		// draw MCM character
			sindex+=320;
		}
		DrawSideBoarders(V,sindex2-XCHAROFFSET);	
	}
	else{
		int	col0;
		int	i,sindex;

		col0=pMemory[0xff19]&0xff;			// get boarder colour
		sindex=ScreenLineIndex;	//+(YCHAROFFSET*XSIZE);
		if( ((ScreenLineIndex>=0) && (ScreenLineIndex<(240*XSIZE))) ){
			for (i=0;i<36;i++){
				V[sindex]=V[sindex+1]=V[sindex+2]=V[sindex+3]=
				V[sindex+4]=V[sindex+5]=V[sindex+6]=V[sindex+7]=
				V[sindex+8]=V[sindex+9]=col0;
				sindex+=10;
			}
		}
		if ((pMemory[0xff06]&0x10)==0) {
			g_SreenBlanked = 1;
		}
		else{
			g_SreenBlanked = 0;
		}
	}
SkipRest:
	ScreenLine++;
	ScreenLineIndex += XSIZE;	
	CharacterRasterLine=pMemory[0xff1f]&7;
	if (skipit==0){
		CharacterRasterLine++;
		CharacterRasterLine&=0x07;
	}
	if( b == 7 ){
		CharLine+=40;                            // NEXT character ROW has been reached.
//		if( CharLine > 0x3e8 ){
//			CharLine -= 0x3e8;
//		}
		CharLine &=0x3ff;
	}
	skipit=0;
}

// **********************************************************************************
// Now work out next lines cycle usage, and new values for $FF1E for every line cycle
// **********************************************************************************
extern	int	ghandle;
void CalcNewCycles( )
{
	int	CharLine;

	// Get character line. If 0 or 7 then we are on a SLOW DMA line...
	CharLine=pMemory[0xff1f]&7;
	if (skipit==0){
		CharLine++;
		CharLine&=7;
	}else{
		CharLine=1;
	}

	// Test Fast/Slow cpu clock - Always slow?
	if ((pMemory[0xff13]&2)!=0){

		// First, is screen off or in upper or lower boarder area?
//g_SreenBlanked
//		if (((pMemory[0xff06]&0x10)==0) || ((RasterLine<=3) || (RasterLine>203))){
		if( (g_SreenBlanked==1) || ((RasterLine<=3) || (RasterLine>203))){
			CYCLES_PER_LINE=cslowboarder;				// slow boarder=57
			pCurrentFF1E=tslowboarder;
			pCurrentFF1E_Text = &SlowBoarder[0];

		// Or, are we on a slow "DMA" line (0 or 7)?
		}else if ((CharLine==0) || (CharLine==7)){
			CYCLES_PER_LINE=cslowdma;					// slow DMA=14 (+3 "write" cycles)
			pCurrentFF1E=tslowdma;
			pCurrentFF1E_Text = &SlowDMA[0];

		} else {
			CYCLES_PER_LINE=cslownormal;					// slow normal=57
			pCurrentFF1E=tslownormal;
			pCurrentFF1E_Text = &SlowNormal[0];
	
		}
	} else{
		  // First, is screen off or in upper or lower boarder area?
		if( (g_SreenBlanked==1) || ((RasterLine<=3) || (RasterLine>203))){
//		if (((pMemory[0xff06]&0x10)==0) || ((RasterLine<=3) || (RasterLine>203))){
			CYCLES_PER_LINE=cfastboarder;				// fast boarder=109
			pCurrentFF1E=tfastboarder;
			pCurrentFF1E_Text = &FastBoarder[0];

		}else if ((CharLine==0) || (CharLine==7)){
			CYCLES_PER_LINE=cfastdma;					// fast DMA=22 (+3 "write" cycles)
			pCurrentFF1E=tfastdma;
			pCurrentFF1E_Text = &FastDMA[0];
		} else {
			CYCLES_PER_LINE=cfastnormal;				// fast normal=65
			pCurrentFF1E=tfastnormal;
			pCurrentFF1E_Text = &FastNormal[0];
		}
	}
}


	//****************************************************************************
	// Process a NEW scanline
	//****************************************************************************
	int	CycleIndex[256];
	int	mem_ff1e;
	void NewScanLine( )
	{
		int	IRQrast;
		int	a;


		POKE(0xff1e,0xe2);
		RasterLine=pMemory[0xff1d]+((pMemory[0xff1c]&1)<<8);
		RasterLine++;

		if( (RasterLine>=254) && (RasterLine<=257) ){
			ScreenLineIndex = -35*XSIZE;
			ScreenLine = -35;
		}

		if (RasterLine>311) {
			int	charscreen;

			FlashCount++;
			if ((pMemory[0xff07]&0x80)!=0){
			   FlashCount=(FlashCount&0x0f)|0x10;
			}else{
			   FlashCount=FlashCount&0x1f;
			}
			pMemory[0xff1f]=((FlashCount&0xf)<<3)|0x80|0x40;
			RasterLine=0;
			POKE(0xff1f,CharacterRasterLine);
			//ScreenLine=0;
			//ScreenLineIndex=XSIZE*-5;
			CharLine=-40;	//-40;
			CharacterRasterLine=7;		//-5&0x7;
			a = pMemory[0xff06]&0x7;
			if( a>3){
				charscreen = -40;
			}
			frame++;
			
			charscreen = (((pMemory[0xff14]&0xf8)<<8)+0x400);
			for( int i = 0;i<40; i++){
				DMAChars[i] = pMemory[charscreen+i];		// get characters from charmap
				DMAAttrib[i] = pMemory[i+charscreen-0x400];				// get colour from colour screen
			}

			if (szAutoLoad[0]!=0x00){
				if ( TotalGameFrames >= 20 ){
					if (szAutoLoad[0]==0x01){
						//strcpy( &szD64Image[0],&szAutoLoad[0]);			// Set D64 image to use
						FileBuffer[0] = g_D64FileSize&0xff;
						FileBuffer[1] = (g_D64FileSize>>8)&0xff;
						LoadMemoryData ( pMemory, -2, (char*) &FileBuffer[0] );
						szAutoLoad[0]=0x00;
						RunIt();
					}
					else{
						LoadMemoryData( (int32*)&pMemory[0], -1, szAutoLoad );
						szAutoLoad[0]=0x00;
						RunIt();
					}
				}
			}
		}
		pROM[0x7f1d]=pMemory[0xff1d]=(RasterLine&0xff);
		pROM[0x7f1c]=pMemory[0xff1c]=(RasterLine>>8)|0xfe;
		
/*		// get current character raster line...
		CharacterRasterLine=pMemory[0xff1f]&7;
		if (skipit==0){
			CharacterRasterLine++;
			CharacterRasterLine&=0x07;
			if (CharacterRasterLine==0){
				CharLine+=40;                            // NEXT character ROW has been reached.
			}
		}
		skipit=0;
*/
		pROM[0x7f1f]=pMemory[0xff1f]=CharacterRasterLine|((FlashCount&0xf)<<3)|0x80;

		
//		ScreenLine++;
//		ScreenLineIndex+=XSIZE;

		// Check for RASTER "irq"  Is it on THIS line??
		IRQrast=pMemory[0xff0b]+((pMemory[0xff0a]&1)<<8);    // get raster IRQ line
		if ((IRQrast==RasterLine) && ((pMemory[0xff0a]&2)!=0))// && (ThisLine==0))
		//if( IRQrast==RasterLine )	// && ((pMemory[0xff0a]&2)!=0))// && (ThisLine==0))
		{
			ThisLine=2;
		} else if (IRQrast!=RasterLine) ThisLine=0;

		
		CalcNewCycles();

		int	mem_ff1e_delta;

		mem_ff1e_delta=0xE40000/CYCLES_PER_LINE;        // work out delta for scan line
		CycleIndex[0]=0;
		for (int i=1;i<25;i++){
			CycleIndex[i]=CycleIndex[i-1]+mem_ff1e_delta;      // work out deltas for EVERY instuction length
		}
		mem_ff1e=0;    //CycleIndex[LineCycles];              // Add on the number of cycles used.
	}

	//****************************************************************************
	// Process all timers
	//****************************************************************************
	int	g_TimePasted;
	void ProcessTimers( )
	{
		int	time;

		// First get REAL cycles past since LAST process...
		// we can use the HORIZONTAL dot clock for this, since its more acurate than
		// the timers themselves.

		if (ff1e_old>pMemory[0xff1e]){			// looped?
			time=0xe4-ff1e_old+pMemory[0xff1e];
		}else{
			time=pMemory[0xff1e]-ff1e_old;
		}
		g_TimePasted = (time<<14);					// get the 16.16 time oast value. (relative to timers)

		// Timer 1 processing
		if( g_TimerDelay1 == 0 ){
			if (TIMER1_ACTIVE==0){					// process TIMER1?
				TimerTemp=Timer1;	
				Timer1-=(time<<14);					// timer is 16.16
				if (Timer1>TimerTemp) {				// has timer gone PAST 0 and back to $ffff (reset)
					Timer1+=Timer1Value;			// reset timer
					if ((pMemory[0xff0a]&0x08)!=0){	// Gen IRQ for this timer
						pMemory[0xff09]|=0x88;		// set IRQ NOW!!!
						g_IRQTimer=2;
					}else{
						pMemory[0xff09]|=0x08;		// Just set - don't flag IRQ
					}
				}
				pMemory[0xff00]=((Timer1>>16)&0xff);    // write NEW timer LOW
				pMemory[0xff01]=((Timer1>>24)&0xff);    // write NEW timer HIGH
			}
		}
		else{
			g_TimerDelay1--;
		}


		// Timer 2 processing
		if (TIMER2_ACTIVE==0){					// process TIMER1?
			TimerTemp=Timer2;	
			Timer2-=(time<<14);					// timer is 16.16

			if (Timer2>TimerTemp) {				// has timer gone PAST 0 and back to $ffff (reset)
				if ((pMemory[0xff0a]&0x10)!=0){	// Gen IRQ for this timer
					pMemory[0xff09]|=0x90;		// set IRQ NOW!!!
					g_IRQTimer=2;
				}else{
					pMemory[0xff09]|=0x10;		// Just set - don't flag IRQ
				}
			}
			pMemory[0xff02]=((Timer2>>16)&0xff);    // write NEW timer LOW
			pMemory[0xff03]=((Timer2>>24)&0xff);    // write NEW timer HIGH
		}

		// Timer 3 processing
		if (TIMER3_ACTIVE==0){					// process TIMER1?
			TimerTemp=Timer3;	
			Timer3-=(time<<14);					// timer is 16.16
			if (Timer3>TimerTemp) {				// has timer gone PAST 0 and back to $ffff (reset)
				if ((pMemory[0xff0a]&0x08)!=0){	// Gen IRQ for this timer
					pMemory[0xff09]|=0xc0;		// set IRQ NOW!!!
					g_IRQTimer=2;
				}else{
					pMemory[0xff09]|=0x40;		// Just set - don't flag IRQ
				}
			}
			pMemory[0xff04]=((Timer3>>16)&0xff);    // write NEW timer LOW
			pMemory[0xff05]=((Timer3>>24)&0xff);    // write NEW timer HIGH
		}
	}

	//****************************************************************************
	// Process a single "tick" of plus/4 time.. inc timers, rasters etc...
	//****************************************************************************
extern	int g_Tick;
	int ProcessSingleTick( void )
	{
		int	done=0;
		
		Process6502();			// process a single 6502 instruction
		__F|=0x30;
			
		LineCycles += Cycles+NextCycles;
		NextCycles =  0;

		ff1e_old = pMemory[0xff1e];

		// check for interupts EVERY cycle... bummer..
		if ((ThisLine==2) && (LineCycles>0))		// check for RASTER irq..
		{
			pMemory[0xff09] |= 0x02;					// set IRQ NOW!!!
			if( (pMemory[0xff0a]&2 )!=0 ){
				pMemory[0xff09] |= 0x80;					// set IRQ NOW!!!
			}
			ThisLine=0;
			g_IRQTimer = 2;
		};


		if (LineCycles >= (CYCLES_PER_LINE>>1)) {
			if(SamplePhase==0){
				ProcessSID( g_SoundBufferIndex  );
				ProcessTEDsound( g_SoundBufferIndex,g_Tick  );
				ProcessTEDSample( g_SoundBufferIndex,g_Tick  );
				g_SoundBufferIndex++;
				g_Tick++;
				SamplePhase=1;
			}
		}	


		 // Check for NEXT scan line
		if (LineCycles >= CYCLES_PER_LINE){		//CyclesPerScanLine)	{
			LineCycles -= CYCLES_PER_LINE;
			NewScanLine();
			done=1;

			// Start of NEW scanline...		
			ProcessSID( g_SoundBufferIndex  );
			ProcessTEDsound( g_SoundBufferIndex,g_Tick  );
			ProcessTEDSample( g_SoundBufferIndex,g_Tick  );
			SamplePhase=0;
			g_SoundBufferIndex++;
			g_Tick++;
		}

		pMemory[0xff1e] = pCurrentFF1E[LineCycles];
			
		ProcessTimers();
			
		// ANY interupts happened? Timer 1,2,3 OR raster?
		if ((pMemory[0xff09]&0x80)!=0){				//pMemory[0xff0a]&0x5a)!=0){
//		if ((pMemory[0xff09]&0x2)!=0){				//pMemory[0xff0a]&0x5a)!=0){
//		if ((pMemory[0xff09]&pMemory[0xff0a]&(0x5a|0x80))!=0){
			g_IRQTimer--;
			if( g_IRQTimer == 0 )
			{
				g_IRQTimer = 1;
				int	data=pMemory[0xff0a];                // get IRQ switch
				if ((__F&__I)==0) {               		// IRQ's ON??
					DushReg (__PC);
					PushReg (__F&0xef);
					__F|=__I;                          // disable irqs...
					__PC=Deek(0xfffe);                // get IRQ vector
					NextCycles=7;                    // 7 for the START of an IRQ
				}
			}
		}

		
		
		return done;
	}


//****************************************************************************
// Process TAPE loading...( APE sample 
//****************************************************************************
int	mem_ff1e_old = 0;
uint8		TapeHighEdgeTable[5] ={0xf4,0xf8,0xe0,0xc0,0x80};	// Tape loading edge detection "screw"
uint8		TapeLowEdgeTable[5]  ={0x03,0x07,0x1f,0x3f,0x7f};
uint8		TapeHighEdge=0xe0;			
uint8		TapeLowEdge=0x1f;				
extern		int		g_Tester;

//--------------- MTAP header for load
typedef struct _MTAP {
	char string[12];
	unsigned char version;
	unsigned char platform;
	unsigned char video;
	unsigned char reserved;
} MTAPHEADER , * pMTAPHEADER;

//--------------- MTAP header for write
unsigned char tap_header[]={
	'C','1','6','-','T','A','P','E','-','R','A','W', 
	0x02, // version -> 1 - whole wave 2 - halfwave
	0x02, // 0 - C64, 1 - VIC20, 2 - C16/+4
	0x00, // Video standard ( 0= PAL, 1 =NTSC, 2 = NTSC2
	0x00, // empty
	// data length (4 byte) file size!!!!
	// data
};

	uint8			*pHeader = NULL;
	uint32			TapeSoFar = 0;
	uint32			TapeFileSize;
	bool			inwave = false;
	bool			sinus = false;
	int32			tapedelay;
	int32			origlength;

void ProcessTape( void )
{

	pMemory[0xfd10] &=~4;					// PLAY pressed
	mem_ff1e = pMemory[0xff1e]<<16;

	if( mem_ff1e_old > mem_ff1e ){
		g_TapeSoFar += (0xE40000-mem_ff1e_old+mem_ff1e);
	} else {
		g_TapeSoFar += (mem_ff1e-mem_ff1e_old);
	}

	
	if( g_TapeSoFar >= g_TapeCountCheck ){

		while( g_TapeSoFar >= g_TapeCountCheck){
			g_TapeSoFar -= g_TapeCountCheck;
			g_Tester++;
			if ( (pMemory[1]&8) == 0 ){
				g_pCurrentTape++;
			}
		}


		// Tape motor on?
		if ( (pMemory[1]&8) == 0 ){

			// Do actual BIT toggling here....
			if( *g_pCurrentTape >= TapeHighEdge ){
				pMemory[1]=((pMemory[1]&~0x10));	
			}
			else if( *g_pCurrentTape <= TapeLowEdge ){
				pMemory[1]=((pMemory[1]|0x10));	
			}

//			if( (pMemory[1]&0x10) == 0){
//				if( *g_pCurrentTape <= TapeLowEdge ){
//					pMemory[1]=((pMemory[1]|0x10));	
//				}
//			}
//			else{
//				if( *g_pCurrentTape >= TapeHighEdge ){
//					pMemory[1]=((pMemory[1]&~0x10));	
//				}
//			}

			if( g_pCurrentTape >= ( g_pTape + g_TapeFileSize ) ) {
				pMemory[0xfd10] |=4;								// press STOP
				g_SampleStart=0;									// flag stop tape!
				free( g_pTape );									// free TAPE sample
				g_pTape=NULL;
			}
		}
	}
	mem_ff1e_old = mem_ff1e;

/*

//--------------- MTAP read for halwave MTAPs

//void TAP::read_half_wave()
//{
	if( TapeSoFar == 0 ){
		TapeSoFar = sizeof( tap_header );
		origlength = g_TapeFileSize;
	}
	pMemory[0xFD10]&=~0x04;
	// if tape motor is on and we have a TAP buffer
	if ((pMemory[1]&8)==0 && g_pTape!=NULL) {
		
		
		// have we started the tape already?
		if (inwave) {
			if (TapeSoFar>=TapeFileSize)
				//mem->tapeload=false; // stop the tape
			// first or second half of sinus wave?
			if (!sinus && tapedelay==origlength){
				pMemory[1]&=~0x10;
			}
			if (sinus && tapedelay==origlength){
				pMemory[1]|=0x10;
			}
			tapedelay--;
			// have finished our half sinus wave already?
			if (tapedelay<0) {
				sinus=!sinus;
				TapeSoFar++;
				// fetch next byte from buffer
	
				origlength=tapedelay=((g_pTape[TapeSoFar])<<3);
				
				// did we get a special byte?
				if (tapedelay==0) {
					tapedelay=g_pTape[TapeSoFar+1];
					tapedelay+=g_pTape[TapeSoFar+2]<<8;
					tapedelay+=g_pTape[TapeSoFar+3]<<16;
	
					origlength=tapedelay;//=(tapedelay<<1);
					TapeSoFar+=3;
				}
			}
		} else {
			inwave=true;
			sinus=false;
			origlength=tapedelay=(g_pTape[TapeSoFar])<<3;
			if (tapedelay==0) {
				tapedelay=g_pTape[TapeSoFar+1];
				tapedelay+=g_pTape[TapeSoFar+2]<<8;
				tapedelay+=g_pTape[TapeSoFar+3]<<16;
				origlength=tapedelay;//=(tapedelay<<1);
				TapeSoFar+=3;
			}
		}
	}
//}*/

}


//****************************************************************************
// Process a SCAN line
//****************************************************************************
//int	g_Rast = 452;
//int	g_Rast2 = 40;
unsigned char BreakPoints[];
extern	int		debugger;
extern	int				g_LightPen;
		int				g_LastCounter = 0;
void ProcessScanLine( uint8 *pScreen, int frame)
{
	int	done=0;
	int	drawn = 0;
	int	LastPC;
	int	LastPC2;

	pMemory[ 0xfef2] += 16;               // disk emulation "fudging"
//	DrawScanLine(pScreen);
	while (true)
	{
		LastPC = __PC;

		// Ignore THIS time?
		if( (BreakPoints[__PC]&2)==0){
			if( (BreakPoints[__PC]&1)!=0){
				debugger=1; 
				done=1;
				WindowPC = __PC;
				CallStackPointer=-1;
				//return;
			}
		}
		else{
			BreakPoints[__PC]&=~2;		// clear... so it hits NEXT time
		}


		if( debugger!=0 ) return;
		LastPC2 = __PC;
		done=ProcessSingleTick();
		if( g_SampleStart == 1) {
			int	timer;

			g_LastCounter += g_TimePasted;
			timer = g_LastCounter>>16;
			g_LastCounter = g_LastCounter&0xffff;

			while( timer !=0 ){
				ProcessTape();			// Play pressed, and sample loaded?
				timer--;
			}
		}

//		if( RasterLine == 62 ){
//			if( g_LightPen == 1 ){
//				pMemory[0xfd0d] |= 0xff;
//				pMemory[0xff09] |= 0x04;					// set IRQ NOW!!!
//				g_LightPen = 0;
//				Keys[9] = 0;
//				Keys[10] = 0;
//			}
//		}

/*		if(drawn==0){
			if( (pMemory[0xff1e]>=(360/2)) && (pMemory[0xff1e]<=(420/2)) ){	
				if( frame == 0 ) {
					DrawScanLine(pScreen);
				}
				drawn = 1;	//pMemory[0xff1e];
			}
		}
*/
		if (done==1) break;	//return;
	}
	DrawScanLine(pScreen);
}

