//******************************************************************************
//
//								MINUS4W.C
//
//									By
//
//						        Mike Dailly
//
//			   Copyright (c). 1999,2000 All Rights reserved
//
//
//******************************************************************************


#define __WINDOWS_HEADERS__
#include "headers\wintest.h"			// define #defines etc..
#include "resource.h"
#include "cvideo.h"
#include "csound.h"
#include "main.h"
#include "machine.h"
#include "6502.h"
#include "myprocess.h"
#include "sound.h"
#include <mmsystem.h>
#include "cdirectinput.h"
#include "debug.h"
#include "symbol.h"
#include <sys/stat.h>

#include	<conio.h>

extern	BOOL ProfileDialog ( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam);
extern	void ResetProfile( void );



	CDirectInput	*pJoystick;
	HWND			MainWindow;					// main window
	int				KeyFlags[256];					// input key flags

	CVideo			*pVideo = NULL;

	HINSTANCE		Program;
	int32			MouseX,MouseY;
	uint8			MouseLButton,MouseRButton;
	HACCEL			hAccel;
	HCURSOR			MyCursor;
	int32			Buffers;
	char			FileName[512];

	BOOL			s_bFocus;			// flag if window is in focus

	UINT			g_TimerMessage;
	int				ghandle;
	char			g_ProgramPath[2048];
	char			szStr[2048];
	int				g_ScreenMode = 0;			// 0 = windowed

	int				g_RecordSound = 0;
	uint8			*g_SoundBuffer = NULL;
	uint32			g_SoundIndex = 0;
	int				g_TapeListen = 0;
	HWND			g_ProfileWindow = NULL;

	char*			SymbolLookUp[0x10000];				// "quick" symbol table lookup.

// Timer
#define TARGET_RESOLUTION			(1)         // 1-millisecond target resolution
	DWORD			gdTimerID;


			uint32			TimerActive=1;
			uint32			SoundBuffer;			// Current sound buffer ....
volatile	uint32			gTimerCounter;


			int xSize = 360;
			int ySize = 240;
			int	ClearScreenCounter = 0;
			int	DoClearScreen = 1;


extern		int		TestVar;

			char			szAutoLoad[2048];
			char			szRunLine[2048];
			uint32			D64ListBoxSelection;
			tList			*pList;

			int				g_D64FileSize = 0;
			int				g_LightPen = 0;
void ProcessSound( void );


		uint32		GetFileFlags = OFN_FILEMUSTEXIST;
//***************************************************************
//																*
// Function :	DisplayMessage									*
//																*
// Descript :	Displays a message box							*
//																*
// Params	:	msg - message string to display					*
//																*
// Returns	:	(void)											*
//																*
//***************************************************************

void DisplayMessage (char *msg)
{
    MessageBox (MainWindow, msg, "Message", MB_OK);
}


void ReadRegistry( const char* keyStr, uint8* val, char* defaultVal ) {

	HKEY RegCurrentUser, RegMINUS4, RegMINUS4TEST;
	DWORD type = REG_SZ;
	int DataLength = 100;

	strcpy( (char*)val, defaultVal );

	if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software", 0, KEY_READ, &RegCurrentUser ) != ERROR_SUCCESS)
		return;

	if (RegOpenKeyEx( RegCurrentUser, "MINUS4", 0, KEY_READ, &RegMINUS4 ) != ERROR_SUCCESS) {
		RegCloseKey( RegCurrentUser );
		return;
	}

	if (RegOpenKeyEx(RegMINUS4, "MINUS4 Test", 0, KEY_READ, &RegMINUS4TEST ) != ERROR_SUCCESS) {
		RegCloseKey( RegCurrentUser );
		RegCloseKey( RegMINUS4 );
		return;
	}

	if (RegQueryValueEx( RegMINUS4TEST, keyStr, 0, &type, val, (DWORD*)&DataLength) != ERROR_SUCCESS)
		return;
	
	RegCloseKey( RegCurrentUser );
	RegCloseKey( RegMINUS4 );
	RegCloseKey( RegMINUS4TEST );
}

void
WriteRegistry( const char* keyStr, uint8* val ) {

	HKEY RegCurrentUser, RegMINUS4, RegMINUS4TEST;
	int DataLength = 100;
	DWORD Result;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software", 0, NULL, REG_OPTION_NON_VOLATILE, 
						KEY_ALL_ACCESS, NULL, &RegCurrentUser, &Result) != ERROR_SUCCESS)
		return;

	if (RegCreateKeyEx(RegCurrentUser, "MINUS4", 0, NULL, REG_OPTION_NON_VOLATILE, 
						KEY_ALL_ACCESS, NULL, &RegMINUS4, &Result) != ERROR_SUCCESS) {
		RegCloseKey(RegCurrentUser);
		return;
	}

	if (RegCreateKeyEx(RegMINUS4, "MINUS4 Test", 0, NULL, REG_OPTION_NON_VOLATILE, 
						KEY_ALL_ACCESS, NULL, &RegMINUS4TEST, &Result) != ERROR_SUCCESS) {
		RegCloseKey(RegCurrentUser);
		RegCloseKey(RegMINUS4);
		return;
	}

	RegSetValueEx( RegMINUS4, keyStr, 0, REG_SZ, val, 100 );

	RegCloseKey( RegCurrentUser );
	RegCloseKey( RegMINUS4 );
	RegCloseKey( RegMINUS4TEST );
}

//***************************************************************
//																*
// Name:		WriteFileAss									*
// Function:	Writes up the windows file association details	*
//				(this maps .prg to minus4 etc.)					*
//																*
//***************************************************************
void
WriteFileAssociation( uint32  Selection ) {

	HKEY RegCurrentUser, RegMINUS4, RegOpen,RegIcon,RegCommand;
	int DataLength = 100;
	DWORD Result;
	char	S[3]="%L";

	if( ( Selection&1) != 0 ){
		// ********************************************************************************	
		// Create a ".PRG" file association.

		if (RegCreateKeyEx(	HKEY_CLASSES_ROOT, 
							".prg", 
							0, 
							NULL, 
							REG_OPTION_NON_VOLATILE, 
							KEY_ALL_ACCESS, 
							NULL, 
							&RegCurrentUser	, 
							&Result) != ERROR_SUCCESS)
			return;

		RegSetValueEx( RegCurrentUser, NULL, 0, REG_SZ, (uint8*) "minus4.prg", 100 );
		RegCloseKey( RegCurrentUser );


		// register a .PRG handler
		if (RegCreateKeyEx(	HKEY_CLASSES_ROOT,
							"minus4.prg",
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_ALL_ACCESS,
							NULL,
							&RegCurrentUser	,
							&Result
						) != ERROR_SUCCESS)
			return;
		RegSetValueEx( RegCurrentUser, NULL, 0, REG_SZ, (uint8*)"Plus4 Program File ", 100 );

		if (RegCreateKeyEx(	RegCurrentUser,
							"DefaultIcon",
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_ALL_ACCESS,
							NULL,
							&RegIcon,
							&Result
						) != ERROR_SUCCESS)
			return;

		sprintf(&szStr[0], "%s,2", &g_ProgramPath[0] );
		RegSetValueEx( RegIcon, NULL, 0, REG_SZ, (uint8*)&szStr[0], 100 );
		RegCloseKey( RegIcon );

		
		// Register "OPEN" .PRG command
		if (RegCreateKeyEx(	RegCurrentUser,
							"shell",
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_ALL_ACCESS,
							NULL,
							&RegMINUS4,
							&Result
						) != ERROR_SUCCESS)
			return;
		if (RegCreateKeyEx(	RegMINUS4,
							"open",
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_ALL_ACCESS,
							NULL,
							&RegOpen,
							&Result
						) != ERROR_SUCCESS)
			return;
		if (RegCreateKeyEx(	RegOpen,
							"command",
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_ALL_ACCESS,
							NULL,
							&RegCommand,
							&Result
						) != ERROR_SUCCESS)
			return;
		sprintf(&szStr[0], "\"%s\" -p \"%s\"", &g_ProgramPath[0],&S[0] );
//		RegSetValueEx( RegCommand, NULL, 0, REG_SZ, (uint8*)"\"c:\\source\\emulators\\minus4\\debug\\minus4w.exe\" -p \"%L\"", 100 );
		RegSetValueEx( RegCommand, NULL, 0, REG_SZ, (uint8*)&szStr[0], 100 );
		RegCloseKey( RegCommand);
		RegCloseKey( RegOpen);
		RegCloseKey( RegMINUS4);

		RegCloseKey( RegCurrentUser );
	}	
	
	
	
	if( ( Selection&2) != 0 ){
		// ********************************************************************************	
		// Now do a D64 program file

		// Create a ".D64" file association.
		if (RegCreateKeyEx(	HKEY_CLASSES_ROOT, 
							".d64", 
							0, 
							NULL, 
							REG_OPTION_NON_VOLATILE, 
							KEY_ALL_ACCESS, 
							NULL, 
							&RegCurrentUser	, 
							&Result) != ERROR_SUCCESS)
			return;

		RegSetValueEx( RegCurrentUser, NULL, 0, REG_SZ, (uint8*) "minus4.d64", 100 );
		RegCloseKey( RegCurrentUser );
		

		// register a .PRG handler
		if (RegCreateKeyEx(	HKEY_CLASSES_ROOT,
							"minus4.d64",
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_ALL_ACCESS,
							NULL,
							&RegCurrentUser	,
							&Result
						) != ERROR_SUCCESS)
			return;
		RegSetValueEx( RegCurrentUser, NULL, 0, REG_SZ, (uint8*)"Plus4 Disk Image ", 100 );

		if (RegCreateKeyEx(	RegCurrentUser,
							"DefaultIcon",
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_ALL_ACCESS,
							NULL,
							&RegIcon,
							&Result
						) != ERROR_SUCCESS)
			return;
		sprintf(&szStr[0], "%s,1", &g_ProgramPath[0] );
		RegSetValueEx( RegIcon, NULL, 0, REG_SZ, (uint8*)&szStr[0], 100 );
		RegCloseKey( RegIcon );

		
		// Register "OPEN" .PRG command
		if (RegCreateKeyEx(	RegCurrentUser,
							"shell",
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_ALL_ACCESS,
							NULL,
							&RegMINUS4,
							&Result
						) != ERROR_SUCCESS)
			return;
		if (RegCreateKeyEx(	RegMINUS4,
							"open",
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_ALL_ACCESS,
							NULL,
							&RegOpen,
							&Result
						) != ERROR_SUCCESS)
			return;
		if (RegCreateKeyEx(	RegOpen,
							"command",
							0,
							NULL,
							REG_OPTION_NON_VOLATILE,
							KEY_ALL_ACCESS,
							NULL,
							&RegCommand,
							&Result
						) != ERROR_SUCCESS)
			return;
		sprintf(&szStr[0], "\"%s\" -d \"%s\"", &g_ProgramPath[0],&S[0] );
		RegSetValueEx( RegCommand, NULL, 0, REG_SZ, (uint8*)&szStr[0], 100 );
		RegCloseKey( RegCommand);
		RegCloseKey( RegOpen);
		RegCloseKey( RegMINUS4);

	RegCloseKey( RegCurrentUser );
	}

	//"C:\Program Files\ZX Spectrum Emulator\zx32.exe" "%L"
}

/*
	HKEY_CLASSES_ROOT
    .myp=MyProgram.1

    ...
    MyProgram.1=MyProgram Application
        DefaultIcon=C:\MyDir\MyProgram.exe,2
*/

//***************************************************************
//																*
// Function :	GetFileName   									*
//																*
// Descript :	This functions passes the current window and    *
//				opens a filerequestor. You can also set a filter*
//				for files (like *.dat etc.)                     *
//																*
// Params	:	hwnd=		Window Handle						*
//				NameFilter=	Name of requestor box+filters!		*
//							seperate with end char				*
//				szFile=		Where to STORE the filename			*
//				StringSize=	MAX size path+name can be			*
//							(string size)						*
//																*
// Returns	:	True = file selected							*
//				False= escape or canceled request				*
//																*
//***************************************************************
BOOL GetFileName(HWND hwnd, char *pNameFilter, char *pFile, int StringSize)
{
	OPENFILENAME ofn;
	char szDirName[256] = { 0 };
	char szFileTitle[256] = { 0 };

	memset(pFile, 0, StringSize);
	memset(&ofn, 0, sizeof(OPENFILENAME));

	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hwnd;
	ofn.lpstrFilter = pNameFilter;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = pFile;
	ofn.nMaxFile = StringSize;
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFileTitle = sizeof(szFileTitle);
	ofn.lpstrInitialDir = szDirName;
	//ReadRegistry( "files", szDirName, "" );
	ofn.Flags = GetFileFlags;

	if (GetOpenFileName(&ofn)) {

		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		char fname[_MAX_FNAME];
		char ext[_MAX_EXT];
		char path[_MAX_DRIVE+_MAX_DIR+1];

		_splitpath( ofn.lpstrFile, drive, dir, fname, ext );
		strcpy( path, drive );
		strcat( path, dir );
		//WriteRegistry( "files", path );
		return TRUE;
	}
	return FALSE;
}

//***************************************************************
// UpdateScreen - refresh screen when dirty
//***************************************************************

	uint8	Updateusable = 0;												// switch for DLL loaded

void UpdateScreen (HWND hWnd)
{
	PAINTSTRUCT ps;
	HDC hdc;


	if (Updateusable)														// check the DLL is loaded
	{
		hdc = BeginPaint( hWnd, &ps );

		pVideo->Flip();

		EndPaint( hWnd, &ps );
	}
}

//***************************************************************
// About box code
//***************************************************************

BOOL ListBoxDialog ( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
    int i; 
    HWND hwndList; 
	tList	*pList = pFirst;
 

	switch (iMsg)
	{
		case WM_INITDIALOG:
			{
				hwndList = GetDlgItem(hDlg, IDC_LIST1 );
				tList	*pList = pFirst;

				i=0;
				while(pList!=NULL){
					SendMessage( hwndList, LB_ADDSTRING, 0,  (LPARAM) &(pList->item[0]) ); 
					SendMessage( hwndList, LB_SETITEMDATA, i, (LPARAM) i); 

					pList  = pList->pNext;
					i++;
				}
				SetFocus(hwndList); 

/*				// Initialize the list box (fill it with player names). 
				for (i = 0; i < 10; i++) 
				{ 
					SendMessage(hwndList, LB_ADDSTRING, 0,  (LPARAM) "Test" ); 
					SendMessage(hwndList, LB_SETITEMDATA, i, (LPARAM) i); 
				} 
				SetFocus(hwndList); */
				return FALSE; 
			}

		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
				case IDOK:
					hwndList = GetDlgItem(hDlg, IDC_LIST1 ); 
					D64ListBoxSelection = SendMessage(hwndList, LB_GETCURSEL, 0, 0 ); 
					EndDialog (hDlg, 0);
					return TRUE;
				case IDCANCEL:
					D64ListBoxSelection = 0xffffffff;
					EndDialog (hDlg, 0);
					return FALSE;
			}
			break;
	}
	return FALSE;
}

//***************************************************************
// Prefrences Dialog
//***************************************************************
extern	int	g_TedSamples;
BOOL PrefrencesDialog ( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
    HWND hwndList; 

	switch (iMsg)
	{
		case WM_INITDIALOG:
			{
				// Init TEXT boxes...
				SetDlgItemText(hDlg, IDC_ROM1, &Rom0Name[0] );
				SetDlgItemText(hDlg, IDC_ROM2, &Rom1Name[0] );
				SetDlgItemText(hDlg, IDC_ROM3, &Rom2Name[0] );
				SetDlgItemText(hDlg, IDC_ROM4, &Rom3Name[0] );
				SetDlgItemText(hDlg, IDC_ROM5, &Rom4Name[0] );
				SetDlgItemText(hDlg, IDC_ROM6, &Rom5Name[0] );
				SetDlgItemText(hDlg, IDC_ROM7, &Rom6Name[0] );
				SetDlgItemText(hDlg, IDC_ROM8, &Rom7Name[0] );

				hwndList = GetDlgItem(hDlg, IDC_JOY1ENABLE );
				SendMessage( hwndList, BM_SETCHECK, Joy1Enable, 0 ); 
				hwndList = GetDlgItem(hDlg, IDC_JOY2ENABLE );
				SendMessage( hwndList, BM_SETCHECK, Joy2Enable, 0 ); 
				hwndList = GetDlgItem(hDlg, IDC_PRGLOADING );
				SendMessage( hwndList, BM_SETCHECK, g_LoadOnlyPRG, 0 ); 
				hwndList = GetDlgItem(hDlg, IDC_HARDSID );
				SendMessage( hwndList, BM_SETCHECK, g_HardSIDActive, 0 ); 
				hwndList = GetDlgItem(hDlg, IDC_PLAYSAMPLES );
				SendMessage( hwndList, BM_SETCHECK, g_PlayAllSamples, 0 ); 
				hwndList = GetDlgItem(hDlg, IDC_YSCROLLFUDGE );
				SendMessage( hwndList, BM_SETCHECK, g_YScrollingFudge, 0 ); 
				hwndList = GetDlgItem(hDlg, IDC_TEDSAMPLES );
				SendMessage( hwndList, BM_SETCHECK, g_TedSamples, 0 ); 
				hwndList = GetDlgItem(hDlg, IDC_JOYKEYS );
				SendMessage( hwndList, BM_SETCHECK, g_JoyOnKeys, 0 ); 

				hwndList = GetDlgItem(hDlg, IDC_PRG );
				SendMessage( hwndList, BM_SETCHECK, 0, 0 ); 
				hwndList = GetDlgItem(hDlg, IDC_D64 );
				SendMessage( hwndList, BM_SETCHECK, 0, 0 ); 
				return FALSE; 
			}

		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
				case IDOK:
					GetDlgItemText(hDlg, IDC_ROM1, &Rom0Name[0], 2048 );
					GetDlgItemText(hDlg, IDC_ROM2, &Rom1Name[0], 2048 );
					GetDlgItemText(hDlg, IDC_ROM3, &Rom2Name[0], 2048 );
					GetDlgItemText(hDlg, IDC_ROM4, &Rom3Name[0], 2048 );
					GetDlgItemText(hDlg, IDC_ROM5, &Rom4Name[0], 2048 );
					GetDlgItemText(hDlg, IDC_ROM6, &Rom5Name[0], 2048 );
					GetDlgItemText(hDlg, IDC_ROM7, &Rom6Name[0], 2048 );
					GetDlgItemText(hDlg, IDC_ROM8, &Rom7Name[0], 2048 );

					hwndList = GetDlgItem(hDlg, IDC_JOY1ENABLE ); 
					Joy1Enable = SendMessage(hwndList, BM_GETCHECK, 0, 0 ); 
					hwndList = GetDlgItem(hDlg, IDC_JOY2ENABLE ); 
					Joy2Enable = SendMessage(hwndList, BM_GETCHECK, 0, 0 ); 
					hwndList = GetDlgItem(hDlg, IDC_PRGLOADING ); 
					g_LoadOnlyPRG = SendMessage(hwndList, BM_GETCHECK, 0, 0 ); 
					hwndList = GetDlgItem(hDlg, IDC_HARDSID ); 
					g_HardSIDActive = SendMessage(hwndList, BM_GETCHECK, 0, 0 ); 
					hwndList = GetDlgItem(hDlg, IDC_PLAYSAMPLES ); 
					g_PlayAllSamples = SendMessage(hwndList, BM_GETCHECK, 0, 0 ); 
					hwndList = GetDlgItem(hDlg, IDC_YSCROLLFUDGE ); 
					g_YScrollingFudge = SendMessage(hwndList, BM_GETCHECK, 0, 0 ); 
					hwndList = GetDlgItem(hDlg, IDC_TEDSAMPLES ); 
					g_TedSamples = SendMessage(hwndList, BM_GETCHECK, 0, 0 ); 

					hwndList = GetDlgItem(hDlg, IDC_JOYKEYS ); 
					g_JoyOnKeys = SendMessage(hwndList, BM_GETCHECK, 0, 0 ); 

					int Associate;
					int prg,d64;
					Associate = 0;
					hwndList = GetDlgItem(hDlg, IDC_PRG ); 
					prg  = SendMessage(hwndList, BM_GETCHECK, 0, 0 ); 
					hwndList = GetDlgItem(hDlg, IDC_D64 ); 
					d64  = SendMessage(hwndList, BM_GETCHECK, 0, 0 ); 
				
					if( prg!=0 ) Associate|=1;
					if( d64!=0 ) Associate|=2;

					WriteFileAssociation( Associate );

					EndDialog (hDlg, 0);
					return TRUE;

				case IDCANCEL:
					EndDialog (hDlg, 0);
					return FALSE;
			}
			break;
	}
	return FALSE;
}



//***************************************************************
// About box code
//***************************************************************

BOOL AboutDialogBox ( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg)
	{
		case WM_INITDIALOG:
			{        
				return TRUE;
			}

		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
				case IDOK:
					EndDialog (hDlg, 0);
					return TRUE;
				case IDCANCEL:
					EndDialog (hDlg, 0);
					return FALSE;
			}
			break;
	}
	return FALSE;
}

//***************************************************************
// About box code
//***************************************************************

extern	char	InputAddress[2049];
extern	char	InputSize[2049];
extern	char	InputEndAddress[2049];
BOOL GetAddressDialogBox ( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg)
	{
		case WM_INITDIALOG:
			{        
				return TRUE;
			}

		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
				case IDOK:
					GetDlgItemText(hDlg, IDC_ADDRESS, &InputAddress[0], 2048 );
					EndDialog (hDlg, 0);
					return TRUE;
				case IDCANCEL:
					EndDialog (hDlg, 0);
					return FALSE;
			}
			break;
	}
	return FALSE;
}
BOOL SaveMemoryDialogBox ( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg)
	{
	case WM_INITDIALOG:
		{        
			return TRUE;
		}

	case WM_COMMAND:
		switch (LOWORD (wParam))
		{
		case IDOK:
			GetDlgItemText(hDlg, IDC_START_ADDRESS, &InputAddress[0], 2048 );
			GetDlgItemText(hDlg, IDC_END_ADDRESS, &InputEndAddress[0], 2048 );
			GetDlgItemText(hDlg, IDC_MEMORY_SIZE, &InputSize[0], 2048 );
			EndDialog (hDlg, 0);
			return TRUE;
		case IDCANCEL:
			EndDialog (hDlg, 0);
			return FALSE;
		}
		break;
	}
	return FALSE;
}

//******************************************************************************************************************************
//
//
//
//******************************************************************************************************************************
extern	int	Val( char* pStr );
int	DoGetAddress( void )
{
	DialogBox ( Program ,"IDD_GETADDRESS" ,NULL , GetAddressDialogBox);
	
	if( ( InputAddress[0]=='$' ) || (( InputAddress[0]>='0' )&&( InputAddress[0]<='9' )) ){
		return Val( &InputAddress[0] );
	}

	for( int i=0;i< (int)strlen(InputAddress);i++){
		if( ( InputAddress[i]>='a') && ( InputAddress[i]<='z') ){
			InputAddress[i] = InputAddress[i]- ('a'-'A');
		}
	}
	PSym pSym = FindSymbol( InputAddress );
	if( pSym==NULL) return 0;
	return pSym->Value;
}


//******************************************************************************************************************************
//
//
//
//******************************************************************************************************************************
/*int	DoGetAddress2( void )
{
	DialogBox ( Program ,"IDD_GETADDRESS" ,NULL , GetAddressDialogBox);

	if( ( InputAddress[0]=='$' ) || (( InputAddress[0]>='0' )&&( InputAddress[0]<='9' )) ){
		return Val( &InputAddress[0] );
	}

	for(int i=0;i<strlen(InputAddress);i++){
		if( ( InputAddress[i]>='a') && ( InputAddress[i]<='z') ){
			InputAddress[i] = InputAddress[i]- ('a'-'A');
		}
	}
	PSym pSym = FindSymbol( InputAddress );
	if( pSym==NULL) return 0;
	return pSym->Value;
}*/


//***************************************************************
//																*
// Function :	DisplayMessage									*
//																*
// Descript :	Displays a message box							*
//																*
// Params	:	msg - message string to display					*
//																*
// Returns	:	(void)											*
//																*
//***************************************************************
void
LoadFromD64( HWND hWnd, char *pFileName )
{
	LoadD64( pFileName   );
	strcpy( &szD64Image[0],FileName);			// Set D64 image to use
	//AddD64Item( "Item 6", 6);
	int i = DialogBox ( Program ,"ID_LOADBOX" ,hWnd , ListBoxDialog);
	if( D64ListBoxSelection != 0xffffffff ){
		pList = FindD64Item( D64ListBoxSelection );
		strcpy(FileName, pList->item);					// Copy item name (also block size etc..)
		if( pList->Data2 != 0xffffffff ){
			g_D64FileSize = LoadPrgFromD64( &FileBuffer[2], (pList->Data2>>8)&0xff, (pList->Data2&0xff) );
		}
	}
	DeleteD64List();
}

//***************************************************************
//																*
// Function :	LoadSymbols  									*
//																*
// Descript :	Loads in a simple symbol file					*
//																*
//***************************************************************
void	LoadSymbols( char* pName )
{
	char	Name[4096];
	sprintf( Name,"%s.sym",pName);

	char* pBuffer = (char*)Load(Name);
	char* pBuffer2;

	pBuffer2 = pBuffer;
	if( pBuffer != NULL){
		FreeSymbols();
		InitSymbols();


		unsigned int* p32 = (unsigned int*)pBuffer;
		int	SymCount = *p32;
		pBuffer+=4;

		while(SymCount!=0){
			int	value;
			unsigned int* p32 = (unsigned int*)pBuffer;
			value = *p32;
			
			pBuffer+=4;

			PSym psymbol = AddSymbol( pBuffer, value, 0, 0 );
			if( value>=0 && value<0x10000){
				SymbolLookUp[value] = psymbol->Name;			// point this address to this symbol.
			}else{
				printf("Error: Value out of range!  ($%8X,%s)\n",value,psymbol->Name);
			}

			pBuffer+= (strlen(pBuffer)+1);
			SymCount--;
		}

		free( pBuffer2 );
	}
}

//***************************************************************
//																*
// Function :	LoadD64Files									*
//																*
// Descript :	Loads in a d64 file								*
//																*
//***************************************************************
void
LoadPRGFiles( HWND hWnd )
{
	if (GetFileName(hWnd, "Program Files(*.prg)\0*.prg\0All Files (*.*)\0*.*\0\0", FileName, 512))
	{
		LoadMemoryData  ((int32*)&pMemory[0],-1, FileName  );
		{
			LoadSymbols( FileName );
		}
	}
}

//***************************************************************
//																*
// Function :	LoadD64Files									*
//																*
// Descript :	Loads in a d64 file								*
//																*
//***************************************************************
void
LoadD64Files( HWND hWnd )
{
 	if (GetFileName(hWnd, "Program Files(*.d64)\0*.d64\0All Files (*.*)\0*.*\0\0", FileName, 512))
	{
		LoadFromD64( hWnd, FileName );
		FileBuffer[0] = g_D64FileSize&0xff;
		FileBuffer[1] = (g_D64FileSize>>8)&0xff;
		LoadMemoryData ( pMemory, -2, (char*) &FileBuffer[0] );

/*										LoadD64( FileName  );
		strcpy( &szD64Image[0],FileName);			// Set D64 image to use
		//AddD64Item( "Item 6", 6);
		int i = DialogBox ( Program ,"ID_LOADBOX" ,hWnd , ListBoxDialog);
		if( D64ListBoxSelection != 0xffffffff ){
			pList = FindD64Item( D64ListBoxSelection );
			if( pList->Data2 != 0xffffffff ){
				int	Size;
				Size = LoadPrgFromD64( &FileBuffer[2], (pList->Data2>>8)&0xff, (pList->Data2&0xff) );
			}
		}
		DeleteD64List();
		*/
	}
}
extern	int	EmuPause;
//***************************************************************
//																*
// Function :	WindowFunc										*
//																*
// Descript :	This function is called when an event occurs in	*
//				the window, and passes a suitable message to	*
//				the main program.								*
//																*
// Params	:	Some Windows thingies							*
//																*
// Returns	:	(long)											*
//																*
//***************************************************************
extern	int	ChannelsActive;
long FAR PASCAL WindowFunc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HINSTANCE hInstance;
	int	mode;

    switch (message)
    {
		case WM_TIMER:
			gTimerCounter++;
			break;

		case WM_ACTIVATEAPP:
            break;

        case WM_SETCURSOR:
			SetCursor( MyCursor );
            return (TRUE);

		case WM_PAINT :																// if window made dirty, refresh window
				UpdateScreen (hWnd);
				break;

		case WM_SIZE:
				if (wParam == SIZE_MINIMIZED)										// if minimised, disable game process
					s_bFocus = FALSE;
				return 0;
        case WM_CREATE:
			hInstance = ((LPCREATESTRUCT) lParam)->hInstance;
            break;


        case WM_KEYDOWN:
			if (wParam == VK_F12 ){	//VK_ESCAPE
                    PostMessage(hWnd, WM_CLOSE, 0, 0);
			}
			else if(wParam==VK_F5){
				framerate^=4;
				//if (framerate>4) framerate=0;
				FrameRateCounter=200;
			}
			//else if (wParam == VK_F6 ){
			//	g_LightPen = 1;
			//}
			else if (wParam == VK_NUMPAD1 )
			{
				ChannelsActive=ChannelsActive^1;
			}
			else if (wParam == VK_NUMPAD2 )
			{
				ChannelsActive=ChannelsActive^2;
			}
			else if (wParam == VK_NUMPAD3 )
			{
				ChannelsActive=ChannelsActive^4;
			}
			else if (wParam == VK_NUMPAD4 )
			{
				ChannelsActive=ChannelsActive^8;
			}
			else if (wParam == VK_NUMPAD5 )
			{
				ChannelsActive=ChannelsActive^16;
			}
			else if (wParam == VK_NUMPAD6 )
			{
				ChannelsActive=ChannelsActive^32;
			}
			else if (wParam == VK_F8 )
			{
				LoadPRGFiles(hWnd);
				return TRUE;
			}
			else if (wParam == VK_F9 )
			{
				LoadD64Files(hWnd);
				return TRUE;
			}
			else{
				KeyFlags[wParam] = TRUE;			// VK_F12
				PressKey( wParam );
			}
            return TRUE;
			break;

		case WM_KEYUP:
			KeyFlags[wParam] = FALSE;
			ReleaseKey( wParam );
            return TRUE;
			break;

        case WM_DESTROY:															
            PostMessage(hWnd, WM_QUIT, 0, 0);
            break;
		case WM_LBUTTONDOWN : {
			MouseLButton = 1;
			break;
		}
		case WM_LBUTTONUP : {
			MouseLButton = 0;
			break;
		}
		case WM_RBUTTONDOWN : {
			MouseRButton = 1;
			break;
		}
		case WM_RBUTTONUP : {
			MouseRButton = 0;
			break;
		}
		case WM_MOUSEMOVE : {
			MouseX = LOWORD(lParam);
			MouseY = HIWORD(lParam);
			break;
		}			
		case WM_SETFOCUS:															// if put in focus, re-enable game process
				s_bFocus = TRUE;
				return 0;

		case WM_KILLFOCUS:															// if put out of focus, disable game process
				s_bFocus = FALSE;
				return 0;

		case WM_COMMAND :
		{
			switch (LOWORD(wParam)) {


			case IDM_TOGGLEFULLSCREEN:
				{
						EmuPause++;		// Baby mutex
						if( g_ScreenMode == 0 ){
							mode = pVideo->CheckMode(320, 240, 16);
							pVideo->SetMode( MainWindow, mode, VIDEO_DOUBLEBUFFER );
							SetupColours();
							g_ScreenMode = 1;
							EmuPause--;
							return 0;
							break;
						}
						else{
							DWORD style;
							int xMax,yMax;
							int xLeft,yTop;
							RECT rcClient;


							style = WS_OVERLAPPEDWINDOW|WS_CAPTION|WS_SYSMENU;
							xMax = GetSystemMetrics( SM_CXSCREEN );
							yMax = GetSystemMetrics( SM_CYSCREEN );
							xLeft = (xMax-360)/2;
							yTop  = (yMax-240)/2;

							rcClient.left = xLeft;
							rcClient.top = yTop;
							rcClient.right = xLeft+xSize;
							rcClient.bottom = yTop+ySize;
							AdjustWindowRectEx( &rcClient, style, TRUE, 0 );

							pVideo->CloseScreen();
							SetWindowPos( MainWindow,		//HWND hWnd, 
										  HWND_TOP ,		//HWND hWndInsertAfter, 
										  rcClient.left, 
										  rcClient.top,
										  rcClient.right-rcClient.left, 
										  rcClient.bottom-rcClient.top,
										  SWP_NOMOVE		//UINT uFlags 
										);

							mode = VIDEO_WINDOWED;
							pVideo->SetMode( MainWindow, mode, VIDEO_VIDEORAM );
							SetupColours();
							g_ScreenMode = 0;
							EmuPause--;
							return 0;
							break;
						}
						break;
				}
			case ID_FILE_EXIT:		PostMessage( hWnd, WM_CLOSE, 0, 0 );			// check for menu exit
									return 0;
			case ID_OPTIONS_SOFTRESET:	{
										WipeSID();
										ResetPlus4(); 
										return 0; 
										break;
									}
			case ID_OPTIONS_HARDRESET:	{
										WipeSID();
										Poke(0xff3e,1);		// ROM active
										InitProcessor();	// reset Plus/4
										return 0; 
										break;
									}
			case ID_OPTIONS_DEBUGGER: {
										WindowPC = __PC;
										CallStackPointer=-1;

										debugger ^=1;
										if( debugger == 1)
											CheckMenuItem ( GetMenu ( MainWindow ), ID_OPTIONS_DEBUGGER, MF_CHECKED );
										else
											CheckMenuItem ( GetMenu ( MainWindow ), ID_OPTIONS_DEBUGGER, MF_UNCHECKED );
										return 0;
										break;

									  }
			case ID_OPTIONS_UNDOCUMENTEDOPCODES:
										{
											ExtendedOp ^=1;
											if( ExtendedOp == 1)
												CheckMenuItem ( GetMenu ( MainWindow ), ID_OPTIONS_UNDOCUMENTEDOPCODES, MF_CHECKED );
											else
												CheckMenuItem ( GetMenu ( MainWindow ), ID_OPTIONS_UNDOCUMENTEDOPCODES, MF_UNCHECKED );
											return 0;

										}
			case ID_OPTIONS_FRAMERATE: {
										DisplayFPS = DisplayFPS^1;
										if( DisplayFPS == 1)
											CheckMenuItem ( GetMenu ( MainWindow ), ID_OPTIONS_FRAMERATE, MF_CHECKED );
										else
											CheckMenuItem ( GetMenu ( MainWindow ), ID_OPTIONS_FRAMERATE, MF_UNCHECKED );
										return 0;
										break;

									  }

			case IDTAPE_LISTEN:		  {
										g_TapeListen = g_TapeListen^1;
										if( g_TapeListen == 1)
											CheckMenuItem ( GetMenu ( MainWindow ), IDTAPE_LISTEN, MF_CHECKED );
										else
											CheckMenuItem ( GetMenu ( MainWindow ), IDTAPE_LISTEN, MF_UNCHECKED );
										return 0;
										break;
									  }	
			case ID_OPTIONS_50HZTIMERACTIVE:
										TimerActive = TimerActive^1;
										if( TimerActive == 1)
											CheckMenuItem ( GetMenu ( MainWindow ), ID_OPTIONS_50HZTIMERACTIVE, MF_CHECKED );
										else
											CheckMenuItem ( GetMenu ( MainWindow ), ID_OPTIONS_50HZTIMERACTIVE, MF_UNCHECKED );
										return 0;
										break;
			case ID_OPTIONS_CLEARSCREENALWAYS:
										DoClearScreen = DoClearScreen^1;
										if( DoClearScreen == 1)
											CheckMenuItem ( GetMenu ( MainWindow ), ID_OPTIONS_CLEARSCREENALWAYS, MF_CHECKED );
										else
											CheckMenuItem ( GetMenu ( MainWindow ), ID_OPTIONS_CLEARSCREENALWAYS, MF_UNCHECKED );
										return 0;
										break;
			case ID_FILE_SAVEBMP:{
									GetFileFlags = 0;
 									if (GetFileName(hWnd, "WIndows BMP files(*.bmp)\0*.bmp\0All Files (*.*)\0*.*\0\0", FileName, 512))
									{
										EmuPause++;		// Baby mutex
										SaveDIB( FileName, 360, 240 );
										EmuPause--;		// Baby mutex
										GetFileFlags = OFN_FILEMUSTEXIST;
										return 0; 
									}
									GetFileFlags = OFN_FILEMUSTEXIST;
									break;
								 }
			case ID_FILE_LOADPRG:{				
									//DialogBox ( Program ,"ID_LOADBOX" ,hWnd , AboutDialogBox);
 									//if (GetFileName(hWnd, "Program Files(*.prg)\0*.prg\0Disk Images(*.D64)\0*.d64\0All Files (*.*)\0*.*\0\0", FileName, 512))
									LoadPRGFiles(hWnd);
// 									if (GetFileName(hWnd, "Program Files(*.prg)\0*.prg\0All Files (*.*)\0*.*\0\0", FileName, 512))
//									{
//										LoadMemoryData  ((int32*)&pMemory[0],-1, FileName  );
//									}
//									gTimerCounter = 0;
									return 0;
									break;
								 }
			case ID_FILE_LOADFROMD64:{
									LoadD64Files(hWnd);
									return 0; 
								   }
			case ID_FILE_SELECTD64IMAGE:{
 									if (GetFileName(hWnd, "Program Files(*.d64)\0*.d64\0All Files (*.*)\0*.*\0\0", FileName, 512))
									{
										strcpy( &szD64Image[0],FileName);			// Set D64 image to use
										return 0; 
									}
									szD64Image[0] = 0x00;
									return 0; 
								   }

			case ID_TOOLS_REMOVED64IMAGE:	szD64Image[0] = 0x00;
											return 0;

			case ID_FILE_SELECTTAPIMAGE:{
 									if (GetFileName(hWnd, "Program Files(*.tap)\0*.tap\0All Files (*.*)\0*.*\0\0", FileName, 512))
									{
										strcpy( &g_szTAPImage[0],FileName);			// Set D64 image to use
										return 0; 
									}
									g_szTAPImage[0] = 0x00;
									return 0; 
								   }
			case ID_TOOLS_PRESSPLAYONTAPE:{
										pMemory[0xfd10] = ( pMemory[0xfd10]&~4 );						// press PLAY on TAPE
										if( g_szTAPImage[0]==0x00 ) return 0;

										int handle=_open( g_szTAPImage, O_RDONLY|O_BINARY );
										if (handle != -1) {
											g_TapeFileSize = _lseek(handle, 0, SEEK_END );
											_lseek( handle, 0, SEEK_SET );
											g_pCurrentTape = g_pTape = (uint8*) malloc( g_TapeFileSize );
											_read (handle, g_pTape, g_TapeFileSize);
											_close (handle);
											g_SampleStart=1;
											g_TapeCountCheck=(int32)(TAPE_COUNT*65536.0f);			// 0x504ca0 (pal)
											g_TapeSoFar=0;

										}
										return 0;
									}
			case ID_TOOLS_REMOVETAPIMAGE: {
											if( g_pTape != NULL ) free( g_pTape );		// free TAPE sample
											g_pTape = NULL;
											g_SampleStart = 0;
											return 0;
										  }
			case	ID_TOOLS_VIEWPROFILE:	{
												if( g_ProfileWindow==NULL )
												{
													g_ProfileWindow = CreateDialog( Program ,"IDD_VIEWPROFILE" ,hWnd , ProfileDialog);
													if(g_ProfileWindow!= NULL){
														ShowWindow(g_ProfileWindow, SW_SHOW);
													}
												}
												break;
											}


			case	ID_TOOLS_RESETPROFILE: {
												ResetProfile();
										   }
											break;


			case ID_OPTIONS_SCREENMODE_WINDOWEDMODE:{
													EmuPause++;		// Baby mutex
													DWORD style;
													int xMax,yMax;
													int xLeft,yTop;
													RECT rcClient;


													style = WS_OVERLAPPEDWINDOW|WS_CAPTION|WS_SYSMENU;
													xMax = GetSystemMetrics( SM_CXSCREEN );
													yMax = GetSystemMetrics( SM_CYSCREEN );
													xLeft = (xMax-360)/2;
													yTop  = (yMax-240)/2;

													rcClient.left = xLeft;
													rcClient.top = yTop;
													rcClient.right = xLeft+xSize;
													rcClient.bottom = yTop+ySize;
													AdjustWindowRectEx( &rcClient, style, TRUE, 0 );

													pVideo->CloseScreen();
													SetWindowPos( MainWindow,		//HWND hWnd, 
																  HWND_TOP ,		//HWND hWndInsertAfter, 
																  rcClient.left, 
																  rcClient.top,
																  rcClient.right-rcClient.left, 
																  rcClient.bottom-rcClient.top,
																  SWP_NOMOVE		//UINT uFlags 
																);

													mode = VIDEO_WINDOWED;
													pVideo->SetMode( MainWindow, mode, VIDEO_VIDEORAM|VIDEO_DOUBLEBUFFER );
													SetupColours();
													g_ScreenMode = 0;
													EmuPause--;		// Baby mutex
													return 0;
													break;
													}
			case ID_OPTIONS_SCREENMODE_320X20016BIT:{
													EmuPause++;		// Baby mutex
													mode = pVideo->CheckMode(320, 200, 16);
													pVideo->SetMode( MainWindow, mode,VIDEO_DOUBLEBUFFER );
													//ClearScreenCounter = 5;
													g_ScreenMode = 1;
													SetupColours();
													EmuPause--;		// Baby mutex
													return 0;
													break;
													}
			case ID_OPTIONS_SCREENMODE_320X240X16:{
													EmuPause++;		// Baby mutex
													mode = pVideo->CheckMode(320, 240, 16);
													pVideo->SetMode( MainWindow, mode, VIDEO_DOUBLEBUFFER );
													//ClearScreenCounter = 5;
													SetupColours();
													g_ScreenMode = 1;
													EmuPause--;		// Baby mutex
													return 0;
													break;
													}
			case ID_OPTIONS_SCREENMODE_400X300X16:{
													EmuPause++;		// Baby mutex
													mode = pVideo->CheckMode(400, 300, 16);
													pVideo->SetMode( MainWindow, mode, VIDEO_DOUBLEBUFFER );
													ClearScreenCounter = 5;
													SetupColours();
													g_ScreenMode = 1;
													EmuPause--;		// Baby mutex
													return 0;
													break;
													}
			case ID_OPTIONS_SCREENMODE_512X384X16:{
													EmuPause++;		// Baby mutex
													mode = pVideo->CheckMode(512, 384, 16);
													pVideo->SetMode( MainWindow, mode, VIDEO_DOUBLEBUFFER );
													ClearScreenCounter = 5;
													SetupColours();
													g_ScreenMode = 1;
													EmuPause--;		// Baby mutex
													return 0;
													break;
													}
			case ID_OPTIONS_SCREENMODE_640X480X16:{
													EmuPause++;		// Baby mutex
													mode = pVideo->CheckMode(640, 480, 16);
													pVideo->SetMode( MainWindow, mode, VIDEO_DOUBLEBUFFER );
													SetupColours();
													ClearScreenCounter = 5;
													g_ScreenMode = 1;
													EmuPause--;		// Baby mutex
													return 0;
													break;
													}

			case ID_OPTIONS_PREFRENCES:{
											DialogBox ( Program ,"IDD_MINUS4W_PREFRENCES" ,hWnd , PrefrencesDialog);
											return 0;
									   }

			case ID_HELP_ABOUT:{				
									DialogBox ( Program ,"IDD_ABOUT" ,hWnd , AboutDialogBox);
									return 0; 
							   }
			default:				return 0; 
				break;
			}	
		}
		case WM_CLOSE:
			//pVideo->CloseScreen();				// Close Screen Mode HERE since the window is destroyed later..
			break;
    }
    return DefWindowProc (hWnd, message, wParam, lParam);
}



//***************************************************************
//
//
//
//
//***************************************************************
void CALLBACK OneShotTimer(UINT dTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2) 
{ 
	int		b;

	gTimerCounter++;
	if( TimerActive !=0 ) {
		gTimerCounter++;
		b = PostMessage( MainWindow, g_TimerMessage, 1,2);				// post "50Hz" message
	}
} 


//***************************************************************
//
//
//
//
//***************************************************************
void DestroyTimer( void )
{
	if(gdTimerID) {                // is timer event pending?
		timeKillEvent( gdTimerID);  // cancel the event
        gdTimerID = 0;
	}
} 



//***************************************************************
//
//
//
//
//***************************************************************
void InitTimer( void )
{

	TIMECAPS tc;
	UINT     wTimerRes;

	if (timeGetDevCaps(&tc, sizeof(TIMECAPS)) != TIMERR_NOERROR) 
	{
		// Error; application can't continue.
	}

	wTimerRes = min(max(tc.wPeriodMin, TARGET_RESOLUTION), tc.wPeriodMax);
	timeBeginPeriod(wTimerRes); 


    gdTimerID = timeSetEvent(
					20,							//msInterval ( delay = 20, 1 50Hz frame )
					wTimerRes,                  // resolution (global variable)
					&OneShotTimer,              // callback function
					(DWORD)NULL,                // user data
					TIME_PERIODIC 
				);                // single timer event

    if( !gdTimerID )
        return;	//ERR_TIMER;
    else
        return;	//ERR_NOERROR;
} 


//***************************************************************
//
//
//
//
//***************************************************************
int ProfileUpdate = 50;
extern int g_ProfileUpdateCurrent;
extern int g_ProfileUpdateRate;
extern int g_ResetProfile;
void	ProcessEmulator( void )
{
	if( (DoClearScreen!=0) || (ClearScreenCounter>0) ){
		pVideo->ClearScreen( 0x00000000 );
		if(ClearScreenCounter>0) ClearScreenCounter--;
	}
	if( g_ProfileWindow!=NULL ){
		if( g_ResetProfile==1 ){
			if( g_ProfileUpdateCurrent==g_ProfileUpdateRate ) {
				ResetProfile();
			}
		}
	}
	ProcessMain();
	pVideo->Flip();

	CopySoundBuffers( dReady );

	if( g_ProfileWindow!=NULL ){
		g_ProfileUpdateCurrent--;
		if( g_ProfileUpdateCurrent<=0 ){
			RECT rect;
			rect.top = 0;
			rect.bottom = 360;
			rect.left  = 0;
			rect.right  = 850;
			InvalidateRect( g_ProfileWindow, &rect, TRUE );
			g_ProfileUpdateCurrent = g_ProfileUpdateRate;

		}
	}
}


//***************************************************************
//																*
// Function :	ProcessCommandLine								*
//				Process the command line						*
//																*
//***************************************************************
int ReadString( char *pszStr,int i )
{
	int	s = Len(pszStr);
	int	d;

	while(i<s){
		if( pszStr[i]=='"' ) break;
		i++;
	}
	if( i>= s ) return i;

	i++;
	d = 0;
	while(i<s){
		if( pszStr[i]=='"' ) break;
		szStr[d++] = pszStr[i];
		i++;
	}
	szStr[d] = 0x00;
	i++;
	return i;
}

//***************************************************************
//																*
// Function :	ProcessCommandLine								*
//				Process the command line						*
//																*
//***************************************************************
void	GetProgramNameAndPath( void )
{
	char	*pCommandLine = GetCommandLine();
	ReadString( pCommandLine ,0);
	strcpy(&g_ProgramPath[0], &szStr[0]);
}


//***************************************************************
//																*
// Function :	ProcessCommandLine								*
//				Process the command line						*
//																*
//***************************************************************
void	ProcessCommandLine( char *pszCmdLine )
{
	int	s = Len( pszCmdLine );
	int	i = 0;

	Rom0Name[0]=0x00;
	Rom1Name[0]=0x00;
	Rom2Name[0]=0x00;
	Rom3Name[0]=0x00;
	Rom4Name[0]=0x00;
	Rom5Name[0]=0x00;
	Rom6Name[0]=0x00;
	Rom7Name[0]=0x00;

	while( i<s ){
		if( pszCmdLine[i] == '-' ){
			i++;
			if( pszCmdLine[i] == 'p' ){
				i = ReadString( pszCmdLine, i );
				strcpy( szAutoLoad, &szStr[0]);
				LoadSymbols( szStr );
			}
			else if( pszCmdLine[i] == 'd' ){
				i = ReadString( pszCmdLine, i );
				strcpy( szAutoLoad, &szStr[0]);
				LoadFromD64( NULL, szAutoLoad );
				strcpy( &szD64Image[0], &szStr[0]);			// Set D64 image to use
				szAutoLoad[0]=0x01;
				szAutoLoad[1]=0x00;
			}
			// "r" to run a program, but also part of rom loading
			else if( pszCmdLine[i] == 'r' )
			{
				if( pszCmdLine[i+1] == 'o' ){
					if( pszCmdLine[i+2] == 'm' ){
						i+=3;
						if( pszCmdLine[i] == '0' ){
							i = ReadString( pszCmdLine, i );
							strcpy( &Rom0Name[0], &szStr[0]);				// ROM file names
						}										// 20 Meg buffer (10 min)
						else if( pszCmdLine[i] == '1' ){
							i = ReadString( pszCmdLine, i );
							strcpy( &Rom1Name[0], &szStr[0]);				// ROM file names
						}										// 20 Meg buffer (10 min)
						else if( pszCmdLine[i] == '2' ){
							i = ReadString( pszCmdLine, i );
							strcpy( &Rom2Name[0], &szStr[0]);				// ROM file names
						}										// 20 Meg buffer (10 min)
						else if( pszCmdLine[i] == '3' ){
							i = ReadString( pszCmdLine, i );
							strcpy( &Rom3Name[0], &szStr[0]);				// ROM file names
						}										// 20 Meg buffer (10 min)
						else if( pszCmdLine[i] == '4' ){
							i = ReadString( pszCmdLine, i );
							strcpy( &Rom4Name[0], &szStr[0]);				// ROM file names
						}										// 20 Meg buffer (10 min)
						else if( pszCmdLine[i] == '5' ){
							i = ReadString( pszCmdLine, i );
							strcpy( &Rom5Name[0], &szStr[0]);				// ROM file names
						}										// 20 Meg buffer (10 min)
						else if( pszCmdLine[i] == '6' ){
							i = ReadString( pszCmdLine, i );
							strcpy( &Rom6Name[0], &szStr[0]);				// ROM file names
						}										// 20 Meg buffer (10 min)
						else if( pszCmdLine[i] == '7' ){
							i = ReadString( pszCmdLine, i );
							strcpy( &Rom7Name[0], &szStr[0]);				// ROM file names
						}										// 20 Meg buffer (10 min)
					}
				}

				i = ReadString( pszCmdLine, i );
				strcpy( szRunLine, &szStr[0]);
			}
			else if( pszCmdLine[i] == 't' ){
				TimerActive = 0;					// Disable timer
			}
			else if( pszCmdLine[i] == 's' ){
				g_SoundActive = 0;					// Disable sound
			}
			else if( pszCmdLine[i] == 'R' ){
				g_RecordSound = 2;					// Save music to memory, and then save on exit
			}										// 20 Meg buffer (10 min)
		}
		else{
			int index = 0;
			while(1){
				if( ( i>= s) || (pszCmdLine[i]==' ') || (pszCmdLine[i]==0x9) || (pszCmdLine[i]==0x00)){
					break;
				}
				szAutoLoad[index++] = pszCmdLine[i++];
			}
			szAutoLoad[index] = 0x00;
		}
		i++;
	}
}
//			char			szRunLine[2048];

//***************************************************************
//																*
// Function :	WinMain											*
//																*
// Descript :	Windows main program.  Calls initialisation		*
//				functions, then performs main processing loop.	*
//																*
// Params	:	Standard WinMain params							*
//																*
// Returns	:	(int) - status									*
//																*
//***************************************************************
const int n = 5; 

int i, array[ n ]; 
extern	int		g_Ticker;

int PASCAL WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
//	while(1){
//		int a;
//		a = a+1;
//	}
	MSG         msg;
	int			count1 = 0;
	int			err,mode = VIDEO_WINDOWED;
	WNDCLASS	wc;
	BOOL		Done = FALSE;

	szRunLine[0]  = 0x00;
	szAutoLoad[0] = 0x00;
	strcpy(FileName,"Basic");
	GetProgramNameAndPath();

	g_ProfileWindow = NULL;
	DWORD style = WS_OVERLAPPEDWINDOW|WS_CAPTION|WS_SYSMENU;
	int xMax = GetSystemMetrics( SM_CXSCREEN );
	int yMax = GetSystemMetrics( SM_CYSCREEN );


	int xLeft = (xMax-xSize)/2;
	int yTop  = (yMax-ySize)/2;

	RECT rcClient = { xLeft, yTop, xLeft+xSize, yTop+ySize };
	AdjustWindowRectEx( &rcClient, style, TRUE, 0 );


	Program=hInstance;

	// set up window creation parameters
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowFunc;								// this function called to handle input
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon (hInstance, "AAA_PLUS4");
    wc.hCursor = LoadCursor (hInstance, "POINTER" );
    wc.hbrBackground = NULL;
	wc.lpszMenuName	= (LPCSTR)IDR_MENU1;
    wc.lpszClassName = MY_NAME;
    RegisterClass(&wc);

	hAccel = LoadAccelerators( hInstance, "IDR_ACCELERATOR1" );	// load accelerator keys
	MyCursor = LoadCursor (hInstance, "POINTER");				// set default pointer
	
	// create window   
    MainWindow = CreateWindowEx (0,
								MY_NAME,
								MY_TITLE,
								style,
								rcClient.left, rcClient.top,
								rcClient.right-rcClient.left, rcClient.bottom-rcClient.top,
								NULL,
								NULL,
								hInstance,
								NULL);
    if (!MainWindow) return (FALSE);
	GetClientRect( MainWindow, &rcClient );

	// show and update window
    ShowWindow (MainWindow, nCmdShow);
    UpdateWindow (MainWindow);


	pVideo = new CVideo(hInstance);
	pVideo->Init();
//	mode = pVideo->CheckMode(400, 300, 16);
//	pVideo->SetMode( MainWindow, mode );					
	ClearScreenCounter = 5;

	mode = VIDEO_WINDOWED;
	pVideo->SetMode( MainWindow, mode, VIDEO_VIDEORAM );					
//	pVideo->SetMode( MainWindow, mode, 0 );	//VIDEO_VIDEORAM );					
	//err = pVideo->SetMode( MainWindow, mode, VIDEO_VIDEORAM );					
	//if( err != 0 ) return 1;

//	pDDraw=DD_Init( hInstance,0 );
//	pDDraw->flags|=DD_VIDEORAM|DD_TRIPPLEBUFFER|DD_FLIPNOW;

	//Vid_SetDevice ( pHardware, 2);
//	DD_SetMode ( pDDraw, MainWindow , DD_WINDOWED);
//	mode=pVideo->CheckMode ( 320, 200, 16 );
//	pVideo->SetMode ( MainWindow , mode, VIDEO_DOUBLEBUFFER);

	// clear all key input flags
	memset (KeyFlags, 0, sizeof(int)*256);
	memset( SymbolLookUp,0, sizeof(char*)*0x10000);

	ProcessCommandLine( lpCmdLine );


	pJoystick = new CDirectInput();				// Create joystick, under NT this will fail
	if( pJoystick->m_pDInput == NULL ) {		// if it has, clear handle so we can ignore it..
		pJoystick = NULL;
	}


	err=InitProgram ();
	if (err!=0) return err;

 
	g_TimerMessage = RegisterWindowMessage( "Timer Message" );
	InitTimer();
	dReady = 0;
	g_SoundBufferIndex= 0;
	Updateusable = 1;											// DLL is loaded and update screen can be used
	// main game loop

//	SoundActive=0;

	if( g_RecordSound == 1 ){
		ghandle = _open( "c:\\test.raw", _O_CREAT|_O_TRUNC|_O_BINARY|_O_RDWR );
		g_SoundBuffer = NULL;
	}
	if( g_RecordSound == 2 ){
		g_SoundBuffer = (uint8*) malloc( 40*1024*1024 );		// 40 Meg buffer (around 10 min of audio)
		g_SoundIndex=0;
	}
	while (TRUE)
	{
		// **********************************************************************************
		//
		// Sound active, use sample tick as framerate....
		//
		// **********************************************************************************
/*		if( SoundActive == 1 )
		{
			int	DoLoop = 0;
			DWORD dwEvt = MsgWaitForMultipleObjects(
					NUMEVENTS,      // How many possible events
					rghEvent,      // Location of handles
					FALSE,          // Wait for all?
					1,				// How long to wait (ms)
					QS_ALLEVENTS
					);
 
			// WAIT_OBJECT_0 == 0 but is properly treated as an arbitrary
			// index value assigned to the first event, therefore we subtract
			// it from dwEvt to get the zero-based index of the event.
 			dwEvt -= WAIT_OBJECT_0;
 

			// If the event was set by the buffer, there's input
			// to process. 
			
			if (dwEvt < NUMEVENTS) 
			{
				ProcessSound( dwEvt );	
				if( dReady > NUMFRAMES ) {
					ProcessEmulator();
				}
			}

			// If it's the last event, it's a message 
 			else if (dwEvt == NUMEVENTS) 
			{         
  				BOOL	GotOne;
				GotOne = PeekMessage( &msg, 0, 0, 0, PM_REMOVE);			// check for messages
				while(GotOne)
//				if(GotOne)				// check for messages
				{
					if( msg.message == g_TimerMessage ){
						gTimerCounter = 0;
						if( dReady < NUMFRAMES ) {
							ProcessEmulator();
						}
					 	dReady++;
					}
					else if (msg.message == WM_QUIT){						// exit program on quit message
						if( g_RecordSound==1){
							close( ghandle);
						}
						if( ( g_RecordSound==2) || ( g_RecordSound==3) ){
							ghandle = open( "c:\\test.raw", _O_CREAT|_O_TRUNC|_O_BINARY|_O_RDWR, _S_IREAD | _S_IWRITE );
							write( ghandle, &g_SoundBuffer[0], g_SoundIndex );
							close( ghandle);
							free( g_SoundBuffer );
						}
						if( g_SoundActive != 0 ){
							DisableHardSID( );
							FreeSound();
						}
						delete pVideo;
						pVideo = NULL;
						DestroyWindow (MainWindow);
						return (msg.wParam);
					}
					else 
					if (!TranslateAccelerator( MainWindow , hAccel, &msg )) 
					{
						TranslateMessage (&msg);						// 'standard windows calls'
						DispatchMessage (&msg);							// (yes, but what do they do????)
					}
					GotOne = PeekMessage( &msg, 0, 0, 0, PM_REMOVE);			// check for messages
				}
			}


			//if (s_bFocus)											// is the window in focus
			if( (dwEvt < NUMEVENTS) || ( DoLoop==1) )
			{																
				if( TimerActive==0 ) {
					gTimerCounter = 0;
					ProcessEmulator();
				}
			}
		} 
		else	// if( SoundActive == 1 ){
*/		{
		// **********************************************************************************
		//
		// If NO sound to time a frame by, then use standard message loop
		//
		// **********************************************************************************
			BOOL	GotOne;
			GotOne = PeekMessage( &msg, 0, 0, 0, PM_REMOVE);			// check for messages
			if(GotOne)				// check for messages
			{
				if( msg.message == g_TimerMessage ){
					if( TimerActive!=0 ) 
					{
						if( SoundActive == 0 )
						{
							gTimerCounter = 0;
							ProcessEmulator();
							g_SoundBufferIndex = 0;
						}
					}
				}
				else if (msg.message == WM_QUIT){						// exit program on quit message
					if( g_SoundActive != 0 ){
						DisableHardSID( );
						g_SoundActive=0;
						FreeSound();
						if( g_RecordSound==2){
							ghandle = _open( "c:\\test.raw", _O_CREAT|_O_TRUNC|_O_BINARY|_O_RDWR, _S_IREAD | _S_IWRITE );
							_write( ghandle, &g_SoundBuffer[0], g_SoundIndex );
							_close( ghandle);
							free( g_SoundBuffer );
						}
					}
					delete pVideo;
					pVideo = NULL;
					DestroyWindow (MainWindow);
					//DestroyTimer();
					return (msg.wParam);
				}
				if (!TranslateAccelerator( MainWindow , hAccel, &msg )) 
				{
					TranslateMessage (&msg);						// 'standard windows calls'
					DispatchMessage (&msg);							// (yes, but what do they do????)
				}
			}
			else
			if (s_bFocus)											// is the window in focus
			{	
				if( TimerActive==0 ) 
				{
					if( SoundActive == 0 )
					{
						gTimerCounter = 0;
						ProcessEmulator();
						g_SoundBufferIndex = 0;
					}
				}
			}
			else 
				Sleep ( 10 );										// if not in focus, sleep
		}
	}// while (!Done)
	return 0;
}
