//****************************************************************************
//
//
//     The Minus4 project - Copyright (c) Mike Dailly 1996,97,98, 99, 2000
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//	Minus4 Written by:
// ------------------
//
// MD - Mike Dailly, Main framework and basic emulator.
// TB - Tibor Biczo, Debuging and tecnical issues.
//
// 
//
//****************************************************************************
#include <stdio.h>
#include <windows.h>

#include <io.h>
#include <fcntl.h>
#include <commdlg.h>							//included for joystick functions
#include <sys/types.h>
#include <sys/stat.h>

#include <md.h>
#include <all.h>
#include <main.h>
#include <6502.h>
#include "machine.h"
#include "debug.h"
//#include "headers\disasm.h"

	extern	int		pROM[];				// plus/4 ROM
	extern	int		ROM3PLUS1[];				// plus/4 ROM

typedef	struct	tList{
		char	item[32];		// List box item...
		uint32	Data1;
		uint32	Data2;
struct	tList	*pNext;			// pointer to NEXT text item...
}tList;


						//	 {"@ABCDEFGHIJKLMNOPQRSTUVWXYZ[].. !"#$%&'()*+,-./0123456789:;<=>?-ABCDEFGHIJKLMNOPQRSTUVWXYZŰ ޱܱ                                                                                      -                                                               "};
extern	char 		C_Table[256];
	char 		Table[256];

	uint32		FIndex=0;
	uint32		FEnd=1;
	char		CurrentDisk[2048];
	char		DMAFileName[32];
	uint32		status=0;
//	uint8		DMA_STORE;				// value being stored into DISK system
	uint32		FileLoading=0;
	uint8		LAST_DMA_STORE;
	uint8		LAST_LAST_DMA_STORE;
	uint32		IO=0;
	uint32		nameindex=0;
//	uint8		*pFileSystem;
	uint32		FileSize;
	uint8		lastbyte=0;
	uint16		baseadd=0x800;
	int			TRACK;
	int			SECTOR;
	char		szD64Image[2048];
	char		g_szTAPImage[2048];
	uint8		pFileSystem[1024*512];					// ****** BIG ARRAY *********
	int			g_LoadOnlyPRG = 1;


	uint8		CharScreen[0x400];
	uint8		*pD64File = NULL;

	char		LoadingName[128];
	tDir		*pDir;

	// D64 List box stuff...
	tList		*pFirst = NULL;					// pointer to FIRST item...
	tList		*pLast  = NULL;					// pointer to FIRST item...

	uint8		FileBuffer[65536];
	uint8		SectorBuffer[256];
	int			sectors[40]={
					0,21,42,63,84,105,126,147,168,189,210,231,252,273,294,315,336,	// tracks 1-17
					357,376,395,414,433,452,471,
					490,508,526,544,562,580,
					598,615,632,649,666,
					683,700,717,734,751
				};


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void GetText (char *pText)
{
	int32	temp;

	temp=0;
	while (pText[temp]!=0){
			 pText[temp]=Table[pText[temp]];
				temp++;
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void GetSector( uint8 Track, uint8 Sector )
{
	int32	i;
	uint8	*pMemory;
	pMemory = &pD64File[ (sectors[Track-1]+Sector)*256 ];

	// Copy from BYTE array into INT array..
	for (i=0;i<256;i++){
		SectorBuffer[i] = pMemory[i];
	}
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
int LoadPrgFromD64 ( uint8 *pMemory, uint8 Track, uint8 Sector )
{
	uint32	i,i2;
	uint8	first=0;
	uint32	FileSize = 0;

//	FIndex=0;
//	FEnd=1;

	//if (handle!=-1) {
	if ( pD64File != NULL ) {
	
		while (Track!=0){
			GetSector( Track, Sector );				// copy correct sector into sector buffer...
			Track=SectorBuffer[0];					// Get NEXT track and sector
			Sector=SectorBuffer[1];

			if (first==0){
				FileSize=0;
				first=1;
				if (Track==0) i2=Sector+1; else i2=256;		//+0
			} else {
				if (Track==0) i2=Sector+1; else i2=256;		//+3
			}

			for (i=2;i<i2;i++){
				pMemory[FileSize]=SectorBuffer[i];
				FileSize++;
			}
		}
//		FEnd=FileSize;
	}
	return FileSize;
}

//***************************************************************
//
// Add item to list box...
//
//typedef	struct	tList{
//		char	item[32];		// List box item...
//		uint32	Data1;
//		uint32	Data2;
//struct	tList	*pNext;			// pointer to NEXT text item...
//}tList;
//***************************************************************
tList* AddD64Item( char *pText, uint32 ID1, uint32 ID2 )
{
	tList *pList;
	
	pList = (tList*) malloc(sizeof(tList));
	
	if(pFirst==NULL) {
		pFirst = pList;
	}
	else{
		pLast->pNext  = pList;
	}
	pLast  = pList;

	strcpy( &(pList->item[0]), pText);
	pList->Data1 = ID1;
	pList->Data2 = ID2;
	pList->pNext = NULL;
	return pList;
}

void DeleteD64List( void )
{
	tList *pList2;
	tList *pList;
	
	pList = pFirst;
	while(pList!=NULL){
		pList2 = pList->pNext;
		free(pList);
		pList  = pList2;
	}
	pFirst = NULL;
}


tList* FindD64Item( uint32 i )
{
	tList	*pList = pFirst;

	while(i!=0){
		pList  = pList->pNext;
		i--;
		if( pList==NULL ) return NULL;
	}
	return pList;
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void PrintDir( void )
{
	int32		i,i2;
	char		s[17];
	char		info[128];
	int			track;
	int			sector;
	char		*ptype;
//	uint8		ty;
	char		prot;
	int			Counter = 1;		// Disk name is ID "0"


	track=18;
	sector=1;
	while (track!=0){
		GetSector( track, sector );
		for (i=0;i<8;i++){
			pDir=(tDir *) &SectorBuffer[2+(sizeof(tDir)*i)];
			if ((pDir->Track!=0) OR (pDir->Sector!=0)){

				switch (pDir->FileType&0x3f){
					case 0:	ptype="DEL"; break;
					case 1:	ptype="SEQ"; break;
					case 2:	ptype="PRG"; break;
					case 3:	ptype="USR"; break;
					case 4:	ptype="REL"; break;
				}
				if ((pDir->FileType&4)!=0) prot='>'; else prot=' ';

				s[16]=0x0;
				for (i2=0;i2<17;i2++) s[i2]=pDir->FileName[i2];
				sprintf (info,"%c%s    %s    %d",prot,ptype,s,pDir->NumberBlocks);
//				GetText((char*) &info);

				if ((pDir->FileType&0x3f)==2){
					AddD64Item( &info[0], Counter, (pDir->Track<<8)|pDir->Sector );
					//AddMenu(1,&info, pDir->Track, pDir->Sector);				// CAN select
				}
				else{
					AddD64Item( &info[0], Counter, 0xffffffff );
					//AddMenu(0,&info,0,0);				// CAN'T select
				}
		
				Counter++;
				//printf (info);
				//printf ("\n");
			}
		}
		track = SectorBuffer[0];
		sector= SectorBuffer[1];
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void PrintName ( void )
{
	char	s[32];
	int32	i,i2;

	GetSector ( 18, 0 );		// get header block
	i2=1;
	s[0]='"';
	for (i=144;i<162;i++) {
		s[i2]=SectorBuffer[i]; 
		i2++;
	}
	s[i2]='"';
	i2++;
	for (i=162;i<167;i++) {
		s[i2]=SectorBuffer[i]; 
		i2++;
	}
	s[i2]=0x0;
//	GetText((char*) &s[0]);
//	AddMenu(0xff,&s[0],0,0);				// "special" select
	AddD64Item( &s[0], 0, 0xffffffff );
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//************************************************************

uint32 GetSize (char *pName)
{
	uint32	Size=0;
	int handle=_open( pName, O_RDONLY|O_BINARY );
	if( handle<0 ) return 0;
	Size = _lseek( handle, 0, SEEK_END);
	_close( handle);
	return Size;
}


//****************************************************************************
//
// Load data
//
//****************************************************************************
uint8* Load ( char *name )
{
	int		handle;
	uint32  Size;
	uint8	*pMem;

	Size = GetSize(name);
	if( Size == 0 ) return NULL;
	pMem = (uint8*) malloc( Size );

	handle=_open( name, O_RDONLY|O_BINARY );
	if (handle!=-1) {
		_read ( handle, pMem, Size );
		_close( handle );
	}
	return	pMem;
}


//****************************************************************************
//
// Load data
//
//****************************************************************************
uint8* LoadD64 ( char *name )
{
	pD64File = Load( name );
	PrintName ();
	PrintDir();
	return	pD64File;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
int	AddSpaces (int curr, char *s, int max)
{
	int	i2,i=0;

	while ((s[i]!=0x0) AND (i<max)){
		i++;
	}

	if (i>=max) return curr;

	for (i2=0;i2<max-i;i2++){
	   pFileSystem[curr]=0x20;	// space
		curr++;
	}
	return curr;
}



//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
uint32	AddDirEntry (uint32 index, int blocks, char *s,char *ptype, char prot)
{
	char			t[17];
	int32			i2;

	pFileSystem[ index ]=(baseadd+index+0x1e-2)&0xff;				// point to NEXT basic line
	pFileSystem[ index+1 ]=((baseadd+index+0x1e)&0xff00)>>8;
	index+=2;

	pFileSystem[index]=blocks&0xff;					// make line number
	pFileSystem[index+1]=((blocks&0xff00)>>8);
	index+=2;
	sprintf(t,"%d",blocks);
	index=AddSpaces(index,t,4);

	pFileSystem[index]=0x22; 											// start "
	index++;

	i2=0;
	while ((((uint8)s[i2])!=160) AND (i2<16)){								// filename
		pFileSystem[index]=s[i2];
		index++;
		i2++;
	}
	pFileSystem[index]=0x22;   										// end "
	index++;
	while (i2<16){
	  pFileSystem[index]=0x20;											// and pad with spaces
	  index++;
	  i2++;
	}

	pFileSystem[index]=0x20; 											// space
	pFileSystem[index+1]=ptype[0];									// store program type
	pFileSystem[index+2]=ptype[1];
	pFileSystem[index+3]=ptype[2];
	pFileSystem[index+4]=prot;											// protected?
	pFileSystem[index+5]=0;												// and end line
	index+=6;				

	return index;
}
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void GetSector (int handle, uint8 Track, uint8 Sector)
{
	_lseek (handle,(sectors[Track-1]+Sector)*256, SEEK_SET);
	_read (handle,&SectorBuffer[0],256);
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
int FindFileDir( int handle )
{
	int32	i,i2,i3;
	char	s[17];
	int	track;
	int	sector;
	char	*ptype;
	char	prot;
//	tMenuList	*pMenu;
	uint8	found;

	
	TRACK=0; SECTOR=0;		// init to NOT found
	track=18;
	sector=1;
	while (track!=0){
		GetSector(handle,track,sector);
		for (i=0;i<8;i++){
			pDir=(tDir *) &SectorBuffer[2+(sizeof(tDir)*i)];
			if ((pDir->Track!=0) OR (pDir->Sector!=0)){

				switch (pDir->FileType&0x3f){
					case 0:	ptype="DEL"; break;
					case 1:	ptype="SEQ"; break;
					case 2:	ptype="PRG"; break;
					case 3:	ptype="USR"; break;
					case 4:	ptype="REL"; break;
				}
				if ((pDir->FileType&4)!=0) prot='>'; else prot=' ';

				s[16]=0x0;
				for (i2=0;i2<17;i2++) s[i2]=pDir->FileName[i2];
				GetText(&s[0]);


				found=0;
				for (i2=0;i2<(int)nameindex;i2++){
					if (DMAFileName[i2]=='*'){		// ANY thing now?
						break;							// from now on is OKAY!
					}
					if (DMAFileName[i2]!='?'){
						if (s[i2]!=DMAFileName[i2]) found=1;
					}
				}

				// FOUND IT!!
				if (found==0){
					i2=0; i3=0;
					while ((s[i2]!=160) AND (i2<16)){								// filename
						LoadingName[i3]=s[i2];
						i3++;
						i2++;
					}
					LoadingName[i3]='.';
					LoadingName[i3+1]=ptype[0];
					LoadingName[i3+2]=ptype[1];
					LoadingName[i3+3]=ptype[2];
					LoadingName[i3+4]=0x0;

					TRACK=pDir->Track;
					SECTOR=pDir->Sector;
					return 0;
				}
			}
		}
		track=SectorBuffer[0];
		sector=SectorBuffer[1];
	}
	return 1;
}
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void LoadD64FileSys (int handle,uint8 Track, uint8 Sector)
{
	//int 		handle;
	uint32	i,i2;
	uint8	first=0;
	uint32	FileSize;

	FIndex=0;
	FEnd=1;
	//Size=GetSize(pD64Name);
	
  //	handle=open (pD64Name,O_RDONLY|O_BINARY);
	if (handle!=-1) {
	
		while (Track!=0){
			GetSector(handle,Track,Sector);
			Track=SectorBuffer[0];
			Sector=SectorBuffer[1];

			if (first==0){
				FileSize=0;
				first=1;
				if (Track==0) i2=Sector+1; else i2=256;		//+0
			} else {
				if (Track==0) i2=Sector+1; else i2=256;	//+3
			}

			for (i=2;i<i2;i++){
				pFileSystem[FileSize]=SectorBuffer[i];
				FileSize++;
			}
		}
		//close (handle);
		FEnd=FileSize;
	}
}




//************************************************************
//                                                           *
//   Name    : LoadDir                                       *
//   Function: Load the directory into memory                *
//             Makes up a plus/4 directory. And stores it in *
//             pFileSystem ready for loading.                *
//                                                           *
//   In   : handle = pointer to open file...                 *
//   Out  : 1=okay!                                          *
//                                                           *
//************************************************************

int LoadDir( int handle )
{
	int32	    i,i2;
	char	    s[17];
	int			track;
	int			sector;
	char	    *ptype;
	char	    prot;
//	tMenuList	*pMenu;
	uint32		index=0;
	char		Free[23]="BLOCKS FREE.          ";


	pFileSystem[index]=0x0;		// set file address
	pFileSystem[index+1]=0x8;
	index+=2;


	TRACK=0; SECTOR=0;		// init to NOT found

	// ************************************************************
	//								 Load Disk Name 
	// ************************************************************
	track=18;
	sector=0;
	GetSector (handle,18,0);		// get header block

	pFileSystem[index]=(baseadd+index+0x1e-2)&0xff;				// Next Line pointer
	pFileSystem[index+1]=((baseadd+index+0x1e)&0xff00)>>8;
	pFileSystem[index+2]=0;			// line number
	pFileSystem[index+3]=0;
	pFileSystem[index+4]=0x12;		// inverse!
	pFileSystem[index+5]=0x22;		// "
	index+=6;

	// Now get DISK name...
	for (i=144;i<160;i++) {
		pFileSystem[index]=SectorBuffer[i]; 
		index++;
	}
	pFileSystem[index]=0x22;		// end "
	pFileSystem[index+1]=0x20;		// space
	index+=2;

	for (i=162;i<167;i++) {			// and finally the disk ID
		pFileSystem[index]=SectorBuffer[i];
		index++;
	}
	pFileSystem[index]=0;		// and end the line
	index++;


	// ************************************************************
	//								Now Load Directory! 
	// ************************************************************

	sector=1;		// now load actual directory!
	while (track!=0){
		GetSector(handle,track,sector);
		for (i=0;i<8;i++){
			pDir=(tDir *) &SectorBuffer[2+(sizeof(tDir)*i)];
			if ((pDir->Track!=0) OR (pDir->Sector!=0)){
				switch (pDir->FileType&0x3f){
					case 0:	ptype="DEL"; break;
					case 1:	ptype="SEQ"; break;
					case 2:	ptype="PRG"; break;
					case 3:	ptype="USR"; break;
					case 4:	ptype="REL"; break;
				}
				if ((pDir->FileType&4)!=0) prot='<'; else prot=' ';

				for (i2=0;i2<17;i2++) s[i2]=pDir->FileName[i2];
				index=AddDirEntry(index,pDir->NumberBlocks,&s[0],ptype,prot);
			}
		}
		track=SectorBuffer[0];
		sector=SectorBuffer[1];
	}

	// ************************************************************
	//						   And display blocks free.
	// ************************************************************

	pFileSystem[index]=(baseadd+index+0x1e-2)&0xff;
	pFileSystem[index+1]=((baseadd+index+0x1e)&0xff00)>>8;
	pFileSystem[index+2]=0;
	pFileSystem[index+3]=0;
	index+=4;
	for (i=0;i<22;i++){
		pFileSystem[index]=Free[i];
		index++;
	}
	pFileSystem[index]=0;		// end this line
	pFileSystem[index+1]=0;		// next line BLANK
	pFileSystem[index+2]=0;
	index+=3;

	FileSize=index;
	FEnd=index;
	return 1;
}


//************************************************************
//                                                           *
// Name    : LoadGAMEdir									 *
// Function: This "fakes" a real directory from a .D64 file  *
//           for one from the GAME directory. This allows    *
//           .PRG files to be loaded from minus/4 and NOT    *
//           F10. This would also allow cool and simple      *
//           file saving...                                  *
//                                                           *
//   In   : none                                             *
//   Out  : pFileSystem has a fake DIR                       *
//          FEnd has the size                                *
//                                                           *
//************************************************************
int LoadGAMEdir( void )
{
	uint32				index=0,i;
	char				Minus4Dir[17]="MINUS4 DIRECTORY";
	char				Minus4Dir2[6]="FF 2A";
	char				Free[23]="BLOCKS FREE.          ";
	uint32				size;
	char				type[4]="PRG";
	char				name[2048];
	char				Name[1024]="*.prg";
struct	_finddata_t		DirInfo;
	long				handle;
	int					done;
	
	pFileSystem[index]=0x0;			// set file address
	pFileSystem[index+1]=0x8;
	index+=2;

	// ************************************************************
	//								 Load Disk Name 
	// ************************************************************

	pFileSystem[index]=(baseadd+index+0x1e-2)&0xff;				// Next Line pointer
	pFileSystem[index+1]=((baseadd+index+0x1e)&0xff00)>>8;
	pFileSystem[index+2]=0;			// line number
	pFileSystem[index+3]=0;
	pFileSystem[index+4]=0x12;		// inverse!
	pFileSystem[index+5]=0x22;		// "
	index+=6;

	// Now get DISK name...
	for (i=0;i<16;i++) {
		pFileSystem[index]=Minus4Dir[i];
		index++;
	}
	pFileSystem[index]=0x22;		// end "
	pFileSystem[index+1]=0x20;		// space
	index+=2;

	for (i=0;i<5;i++) {			// and finally the disk ID
		pFileSystem[index]=Minus4Dir2[i];
		index++;
	}
	pFileSystem[index]=0;		// and end the line
	index++;

	// ************************************************************
	//			      make up directory from GAME directory
	// ************************************************************
	//sprintf	(&Name[0],"%s*.prg",pFileName);
	if( g_LoadOnlyPRG == 1 ){
		handle = _findfirst( "*.PRG", &DirInfo );    
	}
	else{
		handle = _findfirst( "*.*", &DirInfo );    
	}

	done = 0;
	while(  done == 0){
		size = DirInfo.size;		//GetSize(&pDir->d_name[0]);
		i=Len (&DirInfo.name[0]); i--;				// back one to get rid of 0x00
		strcpy( &name[0], &DirInfo.name[0] );
		
		// Pad out rest on name with Plus/4 spaces
		while (i<17){
			name[i]=(char) 160;
			i++;
		}

		size=((size+255)&0xffff00)/256;
		index=AddDirEntry (index, size, &name[0],type, ' ');
		done = _findnext( handle, &DirInfo );
	}
	_findclose( handle );

	// ************************************************************
	//						   And display blocks free.
	// ************************************************************

	pFileSystem[index]=(baseadd+index+0x1e-2)&0xff;
	pFileSystem[index+1]=((baseadd+index+0x1e)&0xff00)>>8;
	pFileSystem[index+2]=0;
	pFileSystem[index+3]=0;
	index+=4;
	for (i=0;i<22;i++){
		pFileSystem[index]=Free[i];
		index++;
	}
	pFileSystem[index]=0;		// end this line
	pFileSystem[index+1]=0;		// next line BLANK
	pFileSystem[index+2]=0;
	index+=3;

	FileSize=index;
	FEnd=index;
	return 1;
}



//************************************************************
//                                                           *
//   Name    : LoadFileFirst()								 *
//   Function: Whenever the disk systenm loads a file, it    *
//             load it into memory first for ease of use.    *
//             This section should also emulate the DIR      *
//             command.... filename of "$"?                  *
//                                                           *
//************************************************************

#define	DMA_return	lastbyte=DMA_STORE; return

void LoadFileFirst( void )
{
			int			handle;
			char		Name[1024];

	FEnd=1;
	FIndex=0;
	FileLoading=0;

	// *********************************************************
	//	If no disk selected use GAME directory as the disk image!
	// *********************************************************
	if( szD64Image[0]==0x0 ){
	   if (DMAFileName[0]=='$'){
			LoadGAMEdir();
	   } 
	   else {
			if (DMAFileName[nameindex-1]=='*'){
				DMAFileName[nameindex]='.';		// add what we need for MSDOS
				DMAFileName[nameindex+1]='*';
				nameindex+=2;
			}
			DMAFileName[nameindex]=0x0;
			//sprintf	(&Name[0],"%s%s",pFileName,DMAFileName);		// append current directory to filename
			sprintf	(&Name[0],"%s",DMAFileName);
			handle = _open( &Name[0], O_RDONLY|O_BINARY);	// open DOS file
			if( handle > 0 ){
				FEnd = _lseek( handle, 0, SEEK_END );
				_lseek( handle, 0, SEEK_SET );
				if (FEnd!=0){
					_read( handle, pFileSystem, FEnd );
					_close (handle);
					FileLoading=1;
				}
			}
		}
	} else {

		// *******************************************************
		// IF we have a disk image... use THAT!
		// *******************************************************

		handle=_open (&szD64Image[0],O_RDONLY|O_BINARY);

		if (DMAFileName[0]=='$'){									// directory asked for??
			LoadDir( handle );
		} else {
			int	err;
			err = FindFileDir( handle );
			if (err==0)	{
				LoadD64FileSys( handle, TRACK, SECTOR );		// load file into memory
				FileLoading=1;
			}
		} 
		_close (handle);
	}
//	if (pFileName!=NULL)	chdir (pCurrPath);
}


//************************************************************
//                                                           *
//   Name    :	ProcessDiskDrive                             *
//   Function: This is the disk drive emulation section.	 *
//                                                           *
//   In   : $FEF0 - Disk DMA byte							 *
//   Out  : $FEF0 - actual data etc..						 *
//                                                           *
//************************************************************
void ProcessDiskDrive ( int	DMA_STORE )
{
	int	i,handle;

	if (status==IDLE){
		switch ( DMA_STORE ){
			case 0x55	:	pMemory[0xfef0]=0x55;			// init DMA...
							pMemory[1]=pMemory[1]&0x3f;
							if (FileLoading==1) {
								FileLoading=0;
							}
							DMA_return;

			case 0x20	:	IO=IOWRITE;						// data write
							DMA_return;
			case 0x42	:
			case 0x40	:	IO=IOREAD;						// data write
							DMA_return;

			case 0x61	:	status=FILEDATA;				// file SAVE data
							FIndex=0;						// init file index
							return;

			case 0x62	:									// 0x62 is SEQ files
			case 0x60	:	status=FILEDATA;				// reveive file data
							if (FileLoading==0) {
								LoadFileFirst();				// load requested file into memory first!
							}
							DMA_return;

			case 0xe0   :	DMA_return;						// e0= close channel

			case 0xf1	:									// 0xf1 = GetName (save)
			case 0xf2	:
			case 0xff	:
			case 0xf0	:	status=GETNAME;					// reveive file data
							for (i=0;i<16;i++) DMAFileName[i]=0x0; 	// match ANY name
							nameindex=0;
							DMA_return;
			case 0x00	: 	DMA_return;						// end seq. (ignore)
		} 
	// ------------------------------------------------------------------
	} else if (status==GETNAME){
		if (DMA_STORE==0x81) {
			status=IDLE;
			DMA_return;											// end of seq?
		}

		if ((DMA_STORE!=0x83) AND (DMA_STORE!=0x00)){
			if (DMA_STORE=='*'){
				DMAFileName[nameindex]=DMA_STORE;				// store *
				nameindex++;											// and move to END of string
				status=IDLE;
				DMA_return;
			}
			if (DMA_STORE==',') DMA_STORE=0x0;					// some file names are "test,s,w" or "test,s,r"
			DMAFileName[nameindex]=DMA_STORE;				
			nameindex++;											
			if (nameindex==2){
         	if (((DMAFileName[0]=='0') AND						// the DLOAD will give a file name like "0:3dpool"
					 (DMAFileName[1]==':')) OR
         	    ((DMAFileName[0]=='@') AND						// save"@:????"
					 (DMAFileName[1]==':'))){                  // and we don't want the 0:
					for (i=0;i<16;i++) DMAFileName[i]='?'; 	// start again!
					nameindex=0;
				}
			}
		}
	// ------------------------------------------------------------------
	} else if (status==FILEDATA) {
		if ((LAST_DMA_STORE==0x0) AND (DMA_STORE==0x84))
		{
			if (IO==IOREAD)
			{
				pMemory[0xfef0]=pFileSystem[FIndex];
				FIndex++;
				if (FIndex==FEnd) {
					if (FileLoading==1){
						FileLoading=0;
				   }
				   pMemory[0xfef1]=3;			// flag file DONE
				   status=IDLE;
				}
			}
		} 
		else if ((LAST_LAST_DMA_STORE==0x0) AND  (LAST_DMA_STORE==0x83)) {
			if (IO==IOWRITE){
				pFileSystem[FIndex]=DMA_STORE;
				FIndex++;
			}
		} 
		else if ((LAST_DMA_STORE==0x0) AND (DMA_STORE==0x81)) {	 // end of file write

			char		Name[1024];
			
			for (i=0;i<16;i++) {
				if (DMAFileName[i]=='?') DMAFileName[i]=0x0;
			}
			
			sprintf	( &Name[0],"%s",DMAFileName );		// make PATH+filename
			handle=_open (&Name[0],O_WRONLY|O_BINARY|O_CREAT,_S_IREAD | _S_IWRITE);
			_write (handle,pFileSystem,FIndex);
			_close (handle);
				
			pMemory[0xfef1]=3;			// flag file DONE
			status=IDLE;
		
		} 
		else if ( DMA_STORE == 0x55) {			//(DMA_STORE==0x55){
			status=IDLE;
			pMemory[0xfef0]=DMA_STORE;			// init DMA...
			pMemory[1]=Memory[1]&0x3f;
			DMA_return;

		}
	}

	// ------------------------------------------------------------------
	LAST_LAST_DMA_STORE = LAST_DMA_STORE;
	LAST_DMA_STORE=DMA_STORE;
}


//****************************************************************************
//
// Load data
//
//****************************************************************************
int	LoadData ( uint8 *pMemory, int address, char *name )
{
   int handle;
   uint32   Size;

   Size=GetSize(name);
   
   handle=_open (name,O_RDONLY|O_BINARY);
   if (handle!=-1) {
      _read (handle,pMemory+address,Size);
      _close (handle);
	  return 1;
   }
   return 0;
}

void Save( char *pszFileName, uint8* pData, int size )
{
	int	ghandle = _open( pszFileName, _O_CREAT|_O_TRUNC|_O_BINARY|_O_RDWR, _S_IREAD | _S_IWRITE );
	_write( ghandle, pData, size );
	_close( ghandle);
}
//****************************************************************************
//
// Load data into MEMORY
//
//****************************************************************************
int  LoadMemoryData ( int *pMemory, int address, char *name )
{
	int		handle,i,Size;
	uint8	Mem[65536];
	int		*pMem;
	uint32	StartAdd,add=address,start;

	if (address==-2){
		add=-1;
		Size=(uint8)name[0];
		Size+=((uint8)name[1]*256);
		address=(uint8)name[2];
		StartAdd=address+=((uint8)name[3]*256);
		name+=4;
		pMem=(int*) name;
		for (i=0;i<Size;i++){
		  pMemory[address]=(int) ((uint8)name[i]);
		  address++;
		}
		//DOKE(0x2b,0x1001);
		//DOKE(0x2d,0x1001+Size-2);
		//DOKE(0x9d,0x1001+Size-2);

		DOKE(0x2b,0x1001);								// setup start of basic
		DOKE(0x2d,(Size+StartAdd-2));					// setup END of basic
		DOKE(0x2f,(Size+StartAdd-2));					// setup END of basic
		DOKE(0x31,(Size+StartAdd-2));					// setup END of basic
		DOKE(0x9d,(Size+StartAdd-2));					// setup END of basic
		return 0;

	}else{
#ifndef DRAGON
		Size=GetSize(name);
   
		handle=_open (name,O_RDONLY|O_BINARY);
		if (handle!=-1) {
			_read (handle,&Mem[0],Size);
			_close (handle);
		}else{
			return 1;		// error!
		}
#endif
	}

	// If NO address get from file 
	if (add==-1){
		address=Mem[0];
		address|=(Mem[1]*256);
		start=2;
		StartAdd=address;
	}else{
		start=0;
		StartAdd=address;
	}

	// Read BYTE file into INT space!
	for (i=start;i<Size;i++){
      pMemory[address]=Mem[i];
	  address++;
	}

	// Set START address of program
	if (add==-1){
		DOKE(0x2b,0x1001);
		DOKE(0x2d,StartAdd+Size-2);
		DOKE(0x9d,StartAdd+Size-2);
	}
	return 0;
}
	char 		C_Table2[256]={"@ABCDEFGHIJKLMNOPQRSTUVWXYZ[].. !\"#$%&'()*+,-./0123456789:;<=>?-ABCDEFGHIJKLMNOPQRSTUVWXYZŰ ޱܱ                                                                                      -                                                             "};
void ConvertScreen ( void )
{
	int32	i;

	for (i=0;i<0x3ff;i++){
		CharScreen[i]=C_Table2[ pMemory[i+0xc00] ];
	}
}
//****************************************************************************
//
//
//
//****************************************************************************
int	LoadROM( int *pRom, char *pszName )
{
	int		a;
	uint8	Rom[16384];

/*	if( strcmp(pszName, "KERNAL" ) == 0 ){
		memcpy( pRom, &pROM[16384], 16384*4 );
		return 1;
	}
	if( strcmp(pszName, "BASIC" ) == 0 ){
		memcpy( pRom, &pROM[0], 16384*4 );
		return 1;
	}
	if( strcmp(pszName, "3-PLUS-1 LO" ) == 0 ){
		memcpy( pRom, &ROM3PLUS1[0], 16384*4 );
		return 1;
	}
	if( strcmp(pszName, "3-PLUS-1 HI" ) == 0 ){
		memcpy( pRom, &ROM3PLUS1[16384], 16384*4 );
		return 1;
	}
*/
	a = LoadData ( &Rom[0], 0, pszName );
	if(a == 1 ){
		for( a = 0; a<16384; a++ ){
			pRom[a] = (int)Rom[a];
		}
		return 1;
	}
	else{
		return a;
	}
}

//****************************************************************************
//
//
//
//****************************************************************************
void	InitProcessor( void )
{
	int	i;

	// Make compare table
	for (i=0;i<256;i++){
		Table[i]=i&0xff;
		if (C_Table[i]!=0x20) Table[i]=C_Table[i];
	}

	
	Init6502( );
	InitMachine ();
	InitDebug();

	__PC=Deek(0xfffc)&0xffff;    // 0xf2a4;        // reset computer
	__SP=0x1ff;
	__A=0;
	__Y=0;
	__X=0;
	__F=0;

	memset( ROM1, 0, 16384*4 );
	memset( ROM2, 0, 16384*4 );
	memset( ROM3, 0, 16384*4 );
	memset( ROM4, 0, 16384*4 );
	memset( ROM5, 0, 16384*4 );
	memset( ROM6, 0, 16384*4 );
	memset( ROM7, 0, 16384*4 );
	memset( ROM8, 0, 16384*4 );

	pRom0 = &pROM[0];
	pRom1 = &ROM3PLUS1[0];
	pRom2 = &ROM3[0];
	pRom3 = &ROM4[0];
	pRom4 = &pROM[16384];
	pRom5 = &ROM3PLUS1[16384];
	pRom6 = &ROM7[0];
	pRom7 = &ROM8[0];

	if( strcmp(&Rom0Name[0], "none" ) != 0 ){
		i = LoadROM( &ROM1[0], &Rom0Name[0]);
		if( i != 0 ) {
			pRom0 = &ROM1[0];
		}
	}
	else{
		pRom0 = &ROM1[0];
	}
	if( strcmp(&Rom1Name[0], "none" ) != 0 ){
		i = LoadROM( &ROM2[0], &Rom1Name[0]);
		if( i != 0 ) {
			pRom1 = &ROM2[0];
		}
	}
	else{
		pRom1 = &ROM2[0];
	}
	if( strcmp(&Rom2Name[0], "none" ) != 0 ){
		i = LoadROM( &ROM3[0], &Rom2Name[0]);
		if( i != 0 ) {
			pRom2 = &ROM3[0];
		}
	}
	else{
		pRom2 = &ROM3[0];
	}
	if( strcmp(&Rom3Name[0], "none" ) != 0 ){
		i = LoadROM( &ROM4[0], &Rom3Name[0]);
		if( i != 0 ) {
			pRom3 = &ROM4[0];
		}
	}
	else{
		pRom3 = &ROM4[0];
	}
	//
	// HI roms
	// 
	if( strcmp(&Rom4Name[0], "none" ) != 0 ){
		i = LoadROM( &ROM5[0], &Rom4Name[0]);
		if( i != 0 ) {
			pRom4 = &ROM5[0];
		}
	}
	else{
		pRom4 = &ROM5[0];
	}
	if( strcmp(&Rom5Name[0], "none" ) != 0 ){
		i = LoadROM( &ROM6[0], &Rom5Name[0]);
		if( i != 0 ) {
			pRom5 = &ROM6[0];
		}
	}
	else{
		pRom5 = &ROM6[0];
	}
	if( strcmp(&Rom6Name[0], "none" ) != 0 ){
		i = LoadROM( &ROM7[0], &Rom6Name[0]);
		if( i != 0 ) {
			pRom6 = &ROM7[0];
		}
	}
	else{
		pRom6 = &ROM7[0];
	}
	if( strcmp(&Rom7Name[0], "none" ) != 0 ){
		i = LoadROM( &ROM8[0], &Rom7Name[0]);
		if( i != 0 ) {
			pRom7 = &ROM8[0];
		}
	}
	else{
		pRom7 = &ROM8[0];
	}
}
