//****************************************************************************
//
//
//        The Minus4 project - Copyright (c) Mike Dailly 1996,97,98,99
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//	Minus4 Written by:
// ------------------
//
// MD - Mike Dailly, Main framework and basic emulator.
//
// 
//
//****************************************************************************
#include <md.h>
#include <windows.h>

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <direct.h>
#include "dos.h"
#include <conio.h>
#include "debug.h"
#include	<process.h>
#include	<dmusici.h>

//#include "dvant.h"
//#include "gbh.h"
//#include "camera.h"
//#include "3dma.h"
//#include "softdll\3d_data.h"
#include <stdio.h>
#include <io.h>
#include <sys\stat.h>
#include <fcntl.h>
#include <windows.h>

#include "main.h"



#define	__IN_SOUND__
#include "sound.h"

//#include "headers\all.h"
//#include "headers\disasm.h"
#include "headers\machine.h"
#include "headers\myprocess.h"
#include "headers\6502.h"
#include "debug.h"

extern		unsigned char TedMiddleC[286];
extern		unsigned char TedMiddleCSample[286];
extern		unsigned char TedNoise[15327];
extern		int				g_SoundActive;

#define	t_BUFFERSIZE			(BUFFERSIZE/2)
#define	TedMiddleCFreq			(109.2390f)			//(110.0f)			//($007)
#define	TedToneSize				(286)
#define	TedNoiseSize			(35208)
typedef	struct tTedChannel{
	uint32		SampleIndex;
	uint32		sampledelta;
	uint32		samplesize;
	uint8		*pSample;
}tTedChannel;

	int				ChannelsActive=0xff;
	
	void			(* InitHardSID_Mapper )( void );
	uint8			(* GetHardSIDCount)	( void );
	void			(* MuteHardSID_Line) (uint8 Mute);
	void			(* WriteToHardSID) (uint8 DeviceID, uint8 SID_reg,uint8  data);
	uint8			(* ReadFromHardSID)	(uint8 DeviceID, uint8  SID_reg);
	void			(* SetDebug) (uint8 Enabled); 


	tTedChannel		Ted[2];
	uint32			SoundActive=0;			// Sound On/OFF ( 1 = ON )
	uint32			g_SoundBufferIndex=0;

	int32			g_HardSIDActive = 0;	// HARDSID active?
	int32			g_HardSIDAvailable = 0;	// HARDSID actually there???
	int32			g_PlayAllSamples = 0;	

	int				g_TedSamples=0;			// use samples for TED?

	// pointers to RAW buffers
	uint8			*pTed1Buffer;
	uint8			*pTed2Buffer;
	uint8			*pSid1Buffer;
	uint8			*pSid2Buffer;
	uint8			*pSid3Buffer;
	uint16			*pSampleBuffer;

	uint8			*pTed1BufferFrame;
	uint8			*pTed2BufferFrame;
	uint16			*pSampleBufferFrame;
	uint16			*pMixedFrame;

	uint16			TEDSample[256];
	uint16			TEDSample2[256];
//	int				LastFF11=0;

	extern	uint8	MidCTri[];
	extern	uint8	MidCSaw[];
	extern	uint8	NoiseWave[];

	HANDLE			AudioMutex;
	int				AudioDone;


	unsigned char	*pTestSound;
	int				EmuPause=0;

	int				NewTedFreq1=0;
	int				NewTedFreq2=0;

//******************************************************************************
//
// SID sound emulation starts here!!
//
// Sample rate = 31200, sample sizes vary for each mode.
//
// To get new sample size we divide the RecordedSampleFreq/RequestedSampleFreq
// and then Xply by the original sample size. Then we simply scale the sample
// into its new size! Simple!
//
//	                          OrgFREQ
//	stepdelta = samplesize / --------*SampleSize
//	                         NoteFreq
//
// 
// Value	Attack Rate		Decay/Release Rates
// ----- -----------    -------------------
//  0		2 ms			  6 ms
//  1		8 ms			 24 ms
//  2      16 ms             48 ms
//  3      24 ms             72 ms
//  4      38 ms            114 ms
//  5      56 ms            168 ms
//  6      68 ms            204 ms
//  7      80 ms            240 ms
//  8     100 ms            300 ms
//  9     240 ms            750 ms
// 10     500 ms            1.5 seconds
// 11     800 ms            2.4 seconds
// 12       1 second          3 seconds
// 13       3 seconds         9 seconds
// 14       5 seconds        15 seconds
// 15       8 seconds        25 seconds
//
//
// Frame rate       = 50Hz 
// ms			    = 1sec/1000
// ms in a frame	= 1sec/50	= 20ms
//
// So 20 Steps per frame. (This right?)
// We have 624 "clicks" per frame (sample rate is 31200)=31.2 clicks per ms
// 
// NOTE
// ----
// Since 25 seconds is 25000*31.2=780,000 steps (15/780000)(!) we
// can't use 16.16, but must use 8.24
//
//******************************************************************************

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************


		tSIDREG		SidReg;
		tSID		Sid[3];
		tSIDREG		*pSidReg;
		uint32		TriSize;	// Triangle sample size
		uint8		*pTri;		// Triangle sample base
		uint32		SawSize;	// SAWtooth sample size
		uint8		*pSaw;		// SAWtooth sample base
		uint32		NoiSize;	// Pulse sample size
		uint8		*pNoi;		// noise sample base
		uint32		PulSize;	// Pulse sample size
		uint8		*pPul[3];	// pulse sample base 1 for each channel

		float		AttackRate[16]		={2,8,16,24,38,56,68,80,100,240,500,800,1000,3000,5000,8000};
		float		DecayReleaseRate[16]={6,24,48,72,114,168,204,240,300,750,1500,2400,3000,9000,15000,25000};
		int32		AttackStep[16];
		int32		DecayReleaseStep[16];


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void WipeSID( void )
{
	for(int i = 0xfd40; i<=0xfd58; i++){
		Poke( i,0 );
	}
}

void DisableHardSID( void )
{
	WipeSID( );
	if( g_HardSIDAvailable != 0 ){
		MuteHardSID_Line( 0 );
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void DetectHARDSID( void )
{
	HINSTANCE	hHardSID;               // Handle to 3DMA DLL
	int			a;

	hHardSID = LoadLibrary("HardSID.dll");
	if( hHardSID == NULL ){
		g_HardSIDActive = 0;
		g_HardSIDAvailable = 0;
		return;
	}
	else{
		g_HardSIDAvailable = 1;
		g_HardSIDActive = 1;
	}

	*((uint32*)(&InitHardSID_Mapper)) = (uint32) GetProcAddress( hHardSID,"InitHardSID_Mapper");
	*((uint32*)(&GetHardSIDCount))	  = (uint32) GetProcAddress( hHardSID,"GetHardSIDCount");
	*((uint32*)(&MuteHardSID_Line))	  = (uint32) GetProcAddress( hHardSID,"MuteHardSID_Line");
	*((uint32*)(&WriteToHardSID))	  = (uint32) GetProcAddress( hHardSID,"WriteToHardSID");
	*((uint32*)(&ReadFromHardSID))	  = (uint32) GetProcAddress( hHardSID,"ReadFromHardSID");
	*((uint32*)(&SetDebug))			  = (uint32) GetProcAddress( hHardSID,"SetDebug"); 

	InitHardSID_Mapper();

	// Hardsid configured?
	a = GetHardSIDCount();
	if( a == 0 ){
		g_HardSIDActive = 0;
		g_HardSIDAvailable = 0;
		return;
	}
	
	MuteHardSID_Line( 0xff );
//	SetDebug(0xff );
	WipeSID();
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void	InitADSR( void )
{
	float	a,b,base;
	int32	i;

	base=( ((float)t_BUFFERSIZE) / (1000.0f/50) );
	for (i=0;i<16;i++){
		a = base*AttackRate[i];						// get "clicks" count
		b = (VOLUME/a)*((float)0x1000000);			// make 8.24
		AttackStep[i] = (int32)b;					// and store...then cross our fingres!
	}

	for (i=0;i<16;i++){
		a = base*(float)DecayReleaseRate[i];			// get "clicks" count
		b = (VOLUME/a)*((float)0x1000000);					// make 8.24
		DecayReleaseStep[i]=(int32)b;			
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void InitSID ( void )
{
	int	i;
//	TriSize=GetSize("midctri.raw");
//	SawSize=GetSize("midcsaw.raw");
//	NoiSize=GetSize("noise.raw");
//	pTri=(uint8*) WindLoad("midctri.raw");
//	pSaw=(uint8*) WindLoad("midcsaw.raw");
//	pNoi=(uint8*) WindLoad("noise.raw");

	pSidReg = &SidReg;

	TriSize = 32329;
	pTri = &MidCTri[0];
	SawSize = 1208;
	pSaw= &MidCSaw[0];
	NoiSize = 32768;
	pNoi= &NoiseWave[0];
	PulSize = 134;

	pSid1Buffer = (uint8*) MALLOC(BUFFERSIZE);					// allocate space for sound....
	pSid2Buffer = (uint8*) MALLOC(BUFFERSIZE);
	pSid3Buffer = (uint8*) MALLOC(BUFFERSIZE);

	for(i=0;i<BUFFERSIZE;i+=2 ){
		pSid1Buffer[i]=0x00;
		pSid2Buffer[i]=0x00;
		pSid3Buffer[i]=0x00;
	}

	pPul[0]=(uint8*) MALLOC(134);								// single cycle at "middle C - C4"
	pPul[1]=(uint8*) MALLOC(134);								// single cycle at "middle C - C4"
	pPul[2]=(uint8*) MALLOC(134);								// single cycle at "middle C - C4"

	Sid[0].pBuffer = pSid1Buffer;
	Sid[1].pBuffer = pSid2Buffer;
	Sid[2].pBuffer = pSid3Buffer;

	Sid[0].ADSR=VOICE_OFF;
	Sid[1].ADSR=VOICE_OFF;
	Sid[2].ADSR=VOICE_OFF;

	Sid[0].SidData.control=0;
	Sid[1].SidData.control=0;
	Sid[2].SidData.control=0;

	InitADSR();					// Set up adsr step rates
	if( g_SoundActive != 0 ){
		DetectHARDSID();
	}
	WipeSID();

}
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void FreeSID( void )
{
// 	FREE(pTri);
//	FREE(pSaw);
	FREE(pPul[0]);
	FREE(pPul[1]);
	FREE(pPul[2]);
//	FREE(pNoi);
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void MakePulseWave(uint8 *pPul, int16 PulseSize)
{
	float		percent=(PulseSize&0xfff)/40.95f;		// get percentage left/right
	uint32		i,index,count;
	uint8		level;
	
	count=(uint32)  ((PulSize/100.0f)*percent);

	level=128;
	index=0;
	for (i=0;i<count;i++){
		*pPul++=level;
		index++;
	}
	level=127;	//255/2;
	while (index<PulSize){
		*pPul++=level;
		index++;
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void ProcessSIDChannel(tSID *pSid, int32	channel, int32 Regoffset)
{
	float		scale;
	uint32		size = 0;

//	pSIDREG=(tSIDREG*) &(pMemory[0xfd40+Regoffset]);		// get base address of hardware

//	if( channel != 2 ) return;

	SidReg.pitch = (uint16) ((pMemory[0xfd40+Regoffset]&0xff) + ((pMemory[0xfd41+Regoffset]&0xff)<<8));
	SidReg.PulseSize = (uint16) ( (pMemory[0xfd42+Regoffset]&0xff)+((pMemory[0xfd43+Regoffset]&0xff)<<8) );
	SidReg.control = (uint8) (pMemory[0xfd44+Regoffset]&0xff);
	SidReg.AD = (uint8) (pMemory[0xfd45+Regoffset]&0xff);
	SidReg.SR = (uint8) (pMemory[0xfd46+Regoffset]&0xff);

	// channel OFF?
	if ( (( pSidReg->control&1)==0) && (pSid->ADSR==VOICE_OFF)){
		pSid->active=0;                            
		return;
	}

	if ((pSidReg->pitch!=pSid->SidData.pitch) ||			// has the user CHANGED the pitch?
		(pSidReg->control!=pSid->SidData.control)){			// or the control byte

      
		pSid->active=1;

		if ((pSidReg->control&1)!=(pSid->SidData.control&1))			// channel JUST been started or stopped?
		{
			if ((pSidReg->control&1)==0){								// If just stopped....
				pSid->ADSR=RELEASE;										// Set RELEASE phase
				pSid->ADSRstep=DecayReleaseStep[(pSidReg->SR&0xf)];		// get delta step!
				pSid->TargetVolume=0;
			}else{														// If just started...
				pSid->ADSR=ATTACK;										// Set ATTACK phase
				pSid->ADSRstep=AttackStep[(pSidReg->AD>>4)&0xf];		// get delta step!
				pSid->ADSRvolume=0;										// set current volume!
				pSid->TargetVolume=15;
			}
		} 

//		if ((pSidReg->control&8)==8){
//			pSid->active=0;												// switch OFF voice!!
//		}
			
		pSid->SidData.pitch	  = pSidReg->pitch;
		pSid->SidData.control = pSidReg->control;

      // get sample and sample size
		switch (pSidReg->control&0xf0){
			case	16	:	pSid->pSample=pTri; 
							size = TriSize; 
							pSid->step=0;
							break;

			case	32	:	pSid->pSample=pSaw; 
							size = SawSize; 
							pSid->step=0;
							break;

			case	64	:	pSid->pSample=pPul[channel];
							size = PulSize;
							pSid->step=0;
							break;

			case	128	:	pSid->pSample=pNoi; 
							size = NoiSize;
							pSid->step=0;
							break;

			default		:	pSid->active=0;
		};
		pSid->samplesize = size<<16;

		if( pSidReg->pitch == 0 ) pSidReg->pitch = 1;
		scale= ( MIDDLEC/ ((float)pSidReg->pitch) ) * size;		// get size sample SHOULD be
		if( scale == 0 ) scale = 1;
		pSid->stepdelta = (int32) ((size/scale)*65536.0f);		// get step delta

		pSid->SidData.AD=pSidReg->AD;
		pSid->SidData.SR=pSidReg->SR;
   
	}//((pSidReg->pitch!=pSid->SidData.pitch)OR(pSidReg->control!=pSid->SidData.control))

	// Do we have the correct PULSEWAVE size? If not... make a new one!
	if( pSid->SidData.PulseSize != pSidReg->PulseSize ){
		MakePulseWave( pPul[channel], pSidReg->PulseSize );
		pSid->SidData.PulseSize = pSidReg->PulseSize;
	}
}



//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void InitChannel1( int32 address, int32 val )
{
	if( g_HardSIDActive == 1 ){
		WriteToHardSID( 0, address-0xfd40, val&0xff );
	}
	ProcessSIDChannel(&Sid[0],0,0);	// process SID channel 1
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void InitChannel2( int32 address, int32 val )
{
	if( g_HardSIDActive == 1 ){
		WriteToHardSID( 0, address-0xfd40, val&0xff );
	}
	ProcessSIDChannel(&Sid[1],1,7);	// process SID channel 2
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void InitChannel3( int32 address, int32 val  )
{
	if( g_HardSIDActive == 1 ){
		WriteToHardSID( 0, address-0xfd40, val&0xff );
	}
	ProcessSIDChannel(&Sid[2],2,14);	// process SID channel 3
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void WriteChannelData( int32 address, int32 val)
{
	if( g_HardSIDActive == 1 ){
		WriteToHardSID( 0, address-0xfd40, val&0xff );
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void ProcessSID( int32 index )
{
	tSID	*pSid;
	int		i,Regoffset = index;
	float	a,b;
//	char	ss[1024];

//	if( index >= BUFFERSIZE ) return;

//	pSidReg = &SidReg;
  	if ((pMemory[0xfd58]&0xf)==0){
		Sid[0].pBuffer[index]=0;			// No volume... so skip it
		Sid[1].pBuffer[index]=0;
		Sid[2].pBuffer[index]=0;
	}else{
	   for (i=0;i<3;i++)
	   {
			pSid=&Sid[i];
			Regoffset = i*7;
			SidReg.pitch = (uint16) ((pMemory[0xfd40+Regoffset]&0xff) + ((pMemory[0xfd41+Regoffset]&0xff)<<8));
			SidReg.PulseSize = (uint16) ( (pMemory[0xfd42+Regoffset]&0xff)+((pMemory[0xfd43+Regoffset]&0xff)<<8) );
			SidReg.control = (uint8) (pMemory[0xfd44+Regoffset]&0xff);
			SidReg.AD = (uint8) (pMemory[0xfd45+Regoffset]&0xff);
			SidReg.SR = (uint8) (pMemory[0xfd46+Regoffset]&0xff);


			if (pSid->active==1)
			{

				// Process ADSR
				switch (pSid->ADSR){
				   case	ATTACK:	if ((pSid->ADSRvolume>>24)==pSid->TargetVolume){
											   pSid->ADSR=DECAY;
											   //pSid->ADSRstep=DecayReleaseStep[pSid->SidData.AD&0xf];	//pSIDREG->AD&0xf];
											   //pSid->TargetVolume = (pSid->SidData.SR>>4);
											   pSid->ADSRstep=DecayReleaseStep[SidReg.AD&0xf];
											   pSid->TargetVolume = (SidReg.SR>>4)&0xf;
										   }else{
											pSid->ADSRvolume += pSid->ADSRstep;
										}
									   break;
				   case	DECAY:	if ((pSid->ADSRvolume>>24)==pSid->TargetVolume){
										   pSid->ADSR=SUSTAIN;
										   pSid->ADSRstep=0;
									   }else{
											pSid->ADSRvolume-=pSid->ADSRstep;
										}
									   break;

				   case	RELEASE:	if ((pSid->ADSRvolume>>24) == pSid->TargetVolume){
										   pSid->active=0;
										   pSid->ADSR=VOICE_OFF;
									   }else{
											pSid->ADSRvolume-=pSid->ADSRstep;
										}
									   break;
			   }


				// Sample "just" finished?
			   if( pSid->active == 1)
			   {
					a=((float) ((pSid->pSample[(pSid->step>>16)]+128)&0xff)  );
					b=((float) (pSid->ADSRvolume>>24));
					a=( ((a*b)/15.0f) *  (Memory[0xfd58]&0xf)/15.0f);
					//a=(a*  (Memory[0xfd58]&0xf)/15.0f);
					
					//if( i==0 ){
					//	sprintf(&ss[0],"ADSR %f\n",b );
					//	OutputDebugStr( &ss[0] );
					//}
					pSid->pBuffer[index]=(uint8)a;
					pSid->step+=pSid->stepdelta;
					if (pSid->step > pSid->samplesize){
						pSid->step-=pSid->samplesize;
					}
			   }
			   else{
			      pSid->pBuffer[index]=0;
			   }
	      }else{
		      pSid->pBuffer[index]=0;
			  a = 0.0f;
		  }
		  if( i== 2 ){
			  pMemory[0xfe9b] = pMemory[0xfd5b] = (uint8) a;			// Oscillator 3 output
		  }
		  if( (ChannelsActive&(1<<i))==0 ){
			  pSid->pBuffer[index]=0;
		  }
	      //pSid->pBuffer[index]=0;
		  if( g_HardSIDActive == 1 ) {			// If HARDSID active... disable output..
	  	      pSid->pBuffer[index]=0;
		  }
		  pSid++;
	   }
	}
}
//******************************************************************************
//
//	Normal TED and sample emulation starts here....
//
//
//
//******************************************************************************
extern	int	g_TapeListen;
void ProcessTEDSample( int32 index, int32 tick )
{
	if( g_PlayAllSamples == 0 ){
		pSampleBufferFrame[tick] = pSampleBuffer[index] = TEDSample[ pMemory[0xff11] ];

	}
	else{
		pSampleBufferFrame[tick] = pSampleBuffer[index] = TEDSample2[ pMemory[0xff11] ];
	}

	//	pSampleBuffer[index] = pMemory[0xfd22]<<8;

	if( g_TapeListen == 1 )
	{
		if( (pMemory[0x01]&0x10) != 0 ){
			pSampleBuffer[index] = 0x8000;
		}else{
			pSampleBuffer[index] = 0;
		}
	}
	
//	if( (pMemory[0x01]&0x02) != 0 ){
//		pSampleBuffer[index] = 0xffff;
//	}else{
//		pSampleBuffer[index] = 0;
//	}
	//pSampleBuffer[index] = pMemory[2]<<8;
}


//************************************************************
//                                                           *
//   Name    : InitTedSamples								 *
//   Function: Build a lookup table for the TED sample       *
//             so FF11 can be used DIRECTLY as an index.     *
//                                                           *
//************************************************************

void InitTedSamples ( void )
{
	float	TempSample,tone;
	int	i;

	// Play samples that ONLY set AD bit
	for (i=0;i<256;i++){
		if ( ((i&0x80)!=0) AND ((i&0x30)!=0) ){
			TempSample=((float) (i&0xf));
			if (TempSample>8) TempSample=8.0f;
			TempSample=TempSample*0.125f;							// make volume 0 to 1
			if ((i&0x30)==0x30){
				tone=65535.0f*TempSample;						// *2 if BOTH channels are playing
			} else {
         		tone=32767.0f*TempSample;						// 0 to 0.5 for 1 channel playing
			}
		} else {
			tone=0;												// 0 for NO channels playing.
		}
		TEDSample[i]=(uint16) tone;
	}


	// Play ALL samples... Don't test for AD bit...
	for (i=0;i<256;i++){
		if ( ((i&0x30)!=0) ){
			TempSample=((float) (i&0xf));
			if (TempSample>8) TempSample=8.0f;
			TempSample=TempSample*0.125f;							// make volume 0 to 1
			if ((i&0x30)==0x30){
				tone=65535.0f*TempSample;						// *2 if BOTH channels are playing
			} else {
         		tone=32767.0f*TempSample;						// 0 to 0.5 for 1 channel playing
			}
		} else {
			tone=0;												// 0 for NO channels playing.
		}
		TEDSample2[i]=(uint16) tone;
	}

}


//******************************************************************************
//
//	Name:		WaitForEvent
//	Function:	Audio thread used to wait for events
//
//******************************************************************************
int	sndindex=0;
extern	CSoundBuffer	*pSample;
extern	void	ProcessEmulator( void );

void __cdecl WaitForEvent( LPVOID lpv)
{
 
  while (TRUE)
  {
		DWORD dwEvt = MsgWaitForMultipleObjects(
					NUMEVENTS,      // How many possible events
					rghEvent,      // Location of handles
					FALSE,          // Wait for all?
					100,				// How long to wait (ms)
					0				//QS_ALLEVENTS
					);
 
			// WAIT_OBJECT_0 == 0 but is properly treated as an arbitrary
			// index value assigned to the first event, therefore we subtract
			// it from dwEvt to get the zero-based index of the event.
 			dwEvt -= WAIT_OBJECT_0;
 

			// If the event was set by the buffer, there's input
			// to process. 
			
			if (dwEvt < NUMEVENTS) 
			{
				if( g_SoundActive == 0 ){
					_endthread();
					return;
				}
				ProcessSound( dwEvt );
				if( EmuPause == 0 ){
					ProcessEmulator();
				}


/*
				dIndex = dwEvt+2;
				while( dIndex >= NUMEVENTS ) dIndex -= NUMEVENTS;			// loop round...

				buff = BUFFERSIZE*dIndex;
				pSample->Lock( buff, BUFFERSIZE);	// Lock correct section of buffer
				
				buff = 0;
				if( pSample->m_pBuffer1 != NULL)
				{
					unsigned short *pBuff = (unsigned short*)pTestSound;
					for(i=0;i<(BUFFERSIZE/2);i++)
					{
						pSample->m_pBuffer1[buff++] = pBuff[sndindex++];
						if( sndindex>60 ) sndindex=0;
					}
				}
				pSample->Unlock();		
				pSample->m_pBuffer1 = NULL;
*/

			}

  }
}


//******************************************************************************
//
//	Name:		EqualiseTedNoise()
//	Function:	Maximise the TED noise sample
//
//******************************************************************************
void MaximiseTedSamples( void )
{
	int		i;
	int		mins=0xff,maxs=0;
	float	f,s;

	for(i=0;i<35208;i++){
		if( TedNoise[i]< mins ){
			mins=TedNoise[i];
		}
		if( TedNoise[i]> maxs ){
			maxs=TedNoise[i];
		}
	}
	f = ((float)0xff)/((float)(maxs-mins));
	for(i=0;i<35208;i++){
		s = (float)(TedNoise[i]-mins);
		s = s*f;
		TedNoise[i] = (unsigned char) s;
	}



	// TED Middle C sample	
	for(i=0;i<286;i++){
		if( TedMiddleCSample[i]< mins ){
			mins=TedMiddleCSample[i];
		}
		if( TedMiddleCSample[i]> maxs ){
			maxs=TedMiddleCSample[i];
		}
	}
	f = ((float)0xff)/((float)(maxs-mins));
	for(i=0;i<286;i++){
		s = (float)(TedMiddleCSample[i]-mins);
		s = s*f;
		TedMiddleCSample[i] = (unsigned char) s;
	}
}


//******************************************************************************
//
//	Name:		InitMinus4Sound()
//	Function:	Allocate memory and init internal sound buffers.
//
//******************************************************************************
void	InitMinus4Sound( void )
{
	int		i;

	pTed1Buffer = (uint8*) MALLOC(BUFFERSIZE);
	pTed2Buffer = (uint8*) MALLOC(BUFFERSIZE);
	pSampleBuffer = (uint16*) MALLOC(BUFFERSIZE);			// 16bit buffer

	pTed1BufferFrame = (uint8*) MALLOC(FRAMESIZE);
	pTed2BufferFrame = (uint8*) MALLOC(FRAMESIZE);
	pSampleBufferFrame = (uint16*) MALLOC(FRAMESIZE*2);
	pMixedFrame = (uint16*) MALLOC(FRAMESIZE*2);

	memset(pTed1Buffer, 0, BUFFERSIZE );
	memset(pTed2Buffer, 0, BUFFERSIZE );
	memset(pSampleBuffer,0,BUFFERSIZE );

	Ted[0].SampleIndex = 0;
	Ted[0].sampledelta = 1<<16;
	Ted[1].SampleIndex = 0;
	Ted[1].sampledelta = 1<<16;

	InitTedSamples();
	MaximiseTedSamples();
	InitSID();

	for(i=0;i<BUFFERSIZE;i+=2 ){
		pSampleBuffer[i]=0x00;
		pSampleBuffer[i+1]=0x80;
	}


	if( SoundActive == 1 ){
		//AudioMutex = CreateMutex( NULL, FALSE,"AudioMutex" );
		pTestSound = Load("c:\\TEDMIDDLEC_SMALL.raw");
		_beginthread( WaitForEvent, 0, NULL );
		AudioDone=0;
	}

}


//************************************************************
//                                                           *
//   Name    : GetFreq										 *
//   Function: Take a Plus/4 register and return the real    *
//             frequency its playing                         *
//                                                           *
//   In   : SoundReg = Plus/4 0-$3ff sound value             *
//   Out  : float    = actual frequency.                     *
//                                                           *
//************************************************************

float	GetFreq ( uint16 SoundReg, int noise )
{
	float	reg;

		if( SoundReg>=0x3f8) return 0.0f;					// out of range!
	if( noise == 1 ){
		if( SoundReg>=0x3fe) return 0.0f;					// out of range!
	}
	else{
		if( SoundReg>=0x3f8) return 0.0f;					// out of range!
	}
	reg=(float) (1024-SoundReg);
	reg = 111840.45f/reg;								// PAL timings
	//reg=111860.781f / reg;								// NTSC timings.
	return  reg;										// return "HZ" hertz
}


//******************************************************************************
//
//	Name:		InitMinus4Sound()
//	Function:	Allocate memory and init internal sound buffers.
//
//
//	                          OrgFREQ
//	stepdelta = samplesize / --------*SampleSize
//	                         NoteFreq
//
//******************************************************************************
uint32	gggg = BUFFERSIZE;
uint32	gg2 = 0;

#define	RELEASE_SPEED			(255)
int		LastFreq1;
int		LastFreq2;
int		Channel1Control=0;
int		Channel2Control=0;
int		VolumeControl=0;
int		LastLevel1;
int		LastLevel2;

void	ProcessTEDsound( int32  sdIndex, int32 tick )
{
	int32	Volume = VolumeControl<<24;		//((pMemory[0xff11]&0xf)<<24);			// 8.24 fixed point
	int32	TedFreq1, TedFreq2;
	float	step;
	float	Freq;

	// Error checking for overruns (fasr forward mode)
	if( sdIndex >= BUFFERSIZE ) {
		return;
	}


	// TED in "D/A" (sample)  mode? if so no sound from here...
	if( (pMemory[0xff11]&0x80) != 0 ){
		pTed1Buffer[ sdIndex ] = 0;
		pTed2Buffer[ sdIndex ] = 0;
		pTed1BufferFrame[ tick ] = 0;
		pTed2BufferFrame[ tick ] = 0;
		return;
	}

	pTed1BufferFrame[ tick ] = pTed1Buffer[ sdIndex ] = 0;			// Just clear here... keeps code simpler...
	pTed2BufferFrame[ tick ] = pTed2Buffer[ sdIndex ] = 0;		


	if( g_TedSamples == 0 )
	{
		Ted[0].samplesize = TedToneSize;
		Ted[0].pSample    = &TedMiddleC[0];
	}
	else{
		Ted[0].samplesize = TedToneSize;
		Ted[0].pSample    = &TedMiddleCSample[0];
	}
	// Process Voice 1 (TONE only...)
//	TedFreq1 = ((pMemory[0xff0e]&0xff) + ((pMemory[0xff12]&0x3)<<8));		// Get freq scale
	TedFreq1 = NewTedFreq1;
	if( TedFreq1!=LastFreq1){
		LastFreq1 = TedFreq1;
	}
//	if((pMemory[0xff11]&0x10)!=0){
	if( Channel1Control!=0 ){
		Freq = GetFreq( TedFreq1, 0 );

		// Are we out of sound range? ($3fe is used to stop sound since its past human hearing)
		if( Freq != 0 ){
			step = (TedMiddleCFreq/((float)Freq)) * ((float)Ted[0].samplesize);
			step = ((float)Ted[0].samplesize)/step;
			
			Ted[0].sampledelta = (int32) (step*65536.0f);			// make 16.16
			Ted[0].SampleIndex += Ted[0].sampledelta;
			
			while( (Ted[0].SampleIndex>>16) >= (int32) Ted[0].samplesize ){
				Ted[0].SampleIndex -= (Ted[0].samplesize<<16);
			}

			pTed1BufferFrame[ tick ] = pTed1Buffer[ sdIndex ] = Ted[0].pSample[ (Ted[0].SampleIndex>>16) ];
		}
	}
	else{
		if( Ted[0].sampledelta != 0 )
		{
			Ted[0].SampleIndex += Ted[0].sampledelta;
			if( (Ted[0].SampleIndex>>16) >= Ted[0].samplesize ){
				Ted[0].sampledelta = 0;
				Ted[0].SampleIndex=0;		// reset sample
			}
			else{
				pTed1BufferFrame[ tick ] = pTed1Buffer[ sdIndex ] = Ted[0].pSample[ (Ted[0].SampleIndex>>16) ];
			}
		}
		else{
			Ted[0].SampleIndex=0;		// reset sample
		}
	}


	// Check for Channel 2 NOISE or TONE
	if( (Channel2Control&0x20) != 0 ){
		if( g_TedSamples == 0 )
		{
			Ted[1].samplesize = TedToneSize;
			Ted[1].pSample    = &TedMiddleC[0];
		}
		else{
			Ted[1].samplesize = TedToneSize;
			Ted[1].pSample    = &TedMiddleCSample[0];
		}
	}
	else{
		Ted[1].samplesize  = TedNoiseSize;
		Ted[1].pSample     = &TedNoise[0];
	}


	// Process Voice 2 in TONE mode
//	TedFreq2 = ((pMemory[0xff0f]&0xff) + ((pMemory[0xff10]&0x3)<<8));		// Get freq scale
	TedFreq2 = NewTedFreq2;
	if( TedFreq2!=LastFreq2){
		//_asm{ int 3 };
		LastFreq2 = TedFreq2;
	}
	//if( (pMemory[0xff11]&0x60)!=0){
	if( Channel2Control!=0 )
	{
		if( Ted[1].samplesize == TedToneSize ){
			Freq = GetFreq( TedFreq2, 1 );
		}else{
			Freq = GetFreq( TedFreq2, 0 );
		}


		// Are we out of sound range? ($3fe is used to stop sound since its past human hearing)
		if( Freq != 0 ){
			step = (TedMiddleCFreq/((float)Freq)) * ((float)Ted[1].samplesize);
			step = ((float)Ted[1].samplesize)/step;
			
			Ted[1].sampledelta = (int32) (step*65536.0f);			// make 16.16
			Ted[1].SampleIndex += Ted[1].sampledelta;

			while( (Ted[1].SampleIndex>>16) >= Ted[1].samplesize ){
				Ted[1].SampleIndex -= (Ted[1].samplesize<<16);
			}
			
			LastLevel2 = pTed2BufferFrame[ tick ] = pTed2Buffer[ sdIndex ] = Ted[1].pSample[ (Ted[1].SampleIndex>>16) ];
		}
	
	}
	else{
		if( (Channel2Control&0x20)!=0){
			if( Ted[1].sampledelta != 0 )
			{
				Ted[1].SampleIndex += Ted[1].sampledelta;
				if( (Ted[1].SampleIndex>>16) >= Ted[1].samplesize ){
					Ted[1].sampledelta = 0;
					Ted[1].SampleIndex=0;		// reset sample
				}
				else{
					LastLevel2 = pTed2BufferFrame[ tick ] = pTed2Buffer[ sdIndex ] = Ted[1].pSample[ (Ted[1].SampleIndex>>16) ];
				}
			}
			else{
				Ted[1].SampleIndex=0;		// reset sample
			}
		}
		else{
			Ted[1].SampleIndex=0;		// reset sample
		}
	}
//	if( Channel2Control!=0){
//		if( pTed2BufferFrame[ tick ]==0x00 ){
//			_asm{ int 3 };
//		}
//	}
}


